unit lptlcd;
{
  Parallel LCD unit for MPXF Software
  Written on 10/16/99

}
interface

procedure LPTClear;
procedure LPTInitLCD;
procedure LPTCursorOff;
procedure LPTCursorOn;
procedure LPTToggle;
procedure LPTHome;
procedure LPTCursor(l,x:byte);
procedure LPTSetPort(p:word);
procedure SetRSPin(p:byte);
procedure SetRWPin(p:byte);
procedure SetE2Pin(p:byte);
procedure SetEnablePin(p:byte);
procedure LPTPushIns(b:byte);
procedure LPTPushChar(charc:byte);
procedure LPTReadSettings(section:string);
procedure LPTDefineChar(cn,d1,d2,d3,d4,d5,d6,d7,d8:byte);
function lptchardelay:byte;
function lptcontroldelay:byte;

implementation
uses newdelay,crt,config;
type
 PinStatus = byte;
 PinData = array[0..17] of PinStatus;

 const
    PinDataOn:Pindata = (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0);
   PinDataOff:pindata = (0,1,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8);

var
  E2PinOn:boolean;
  RS_Pin:byte;
  Enable_Pin,E2_Pin:byte;
  RW_Pin:byte;
  PushCharCommand1,PushCharCommand2:byte;
  PushInsCommand1,pushinscommand2:byte;
  Fourbit:boolean;
    controldelay:word;
    chardelay:word;
    portaddress:word;
    data:word;
    status:word;
    control:word;

    LineOffsets:array[1..4] of byte;

procedure LPTSetPort(p:word); begin portaddress:=p; end;
function lptchardelay:byte; begin lptchardelay := chardelay; end;
function lptcontroldelay:byte; begin lptcontroldelay := controldelay; end;


procedure SetE2Pin(p:byte);
  begin
    E2_Pin := p;
  end;
procedure SetRSPin(p:byte);
  begin    RS_Pin := p;  end;

procedure SetRWpin(p:byte);
  begin    RW_Pin := p;  end;

procedure SetEnablePin(p:byte);
  begin   Enable_pin:=p; end;


procedure delaychar;
  var k:word;
  begin
    for k := 1 to chardelay do;
  end;

procedure delaycmd;
  var k:word;
  begin
    for k := 1 to controldelay do;
  end;

procedure LPTPushIns(b:byte);
 var pc1,pc2:byte;
  begin

    if FourBit then begin
      port[DATA] := b;
      if (E2_Pin > 0) then
      begin
        if E2PinOn then
        begin
          pc1 := PushInsCommand1 - PinDataOn[Enable_Pin] {+ PinDataOff[Enable_Pin]} + PinDataOn[E2_Pin];
          pc2 := PushInsCommand2 - PinDataOn[Enable_Pin] {+ PinDataOff[Enable_Pin]} + PinDataOff[E2_Pin];
        end else begin
          pc1 := PushInsCommand1 + PinDataOff[E2_Pin];
          pc2 := PushInsCommand2 + PinDataOff[E2_Pin];
        end;
        port[control] := pc1;
        delaycmd;
        port[control] := pc2;
      end else
      begin
        port[control] := PushInsCommand1;
        delaycmd;
        port[control] := PushInsCommand2;
      end;
      b := b shl 4;
      delaychar;
    end;

    port[DATA] := b;
    {$IFDEF angry} delaycmd; {$ENDIF}
    if (E2_Pin > 0) then
    begin
      if E2PinOn then
      begin
        pc1 := PushInsCommand1 - PinDataOn[Enable_Pin] {+ PinDataOff[Enable_Pin]} + PinDataOn[E2_Pin];
        pc2 := PushInsCommand2 - PinDataOn[Enable_Pin] {+ PinDataOff[Enable_Pin]} + PinDataOff[E2_Pin];
      end else begin
        pc1 := PushInsCommand1 + PinDataOff[E2_Pin];
        pc2 := PushInsCommand2 + PinDataOff[E2_Pin];
      end;
      port[control] := pc1;
      delaycmd;
      port[control] := pc2;
    end else
    begin
      port[control] := PushInsCommand1;
      delaycmd;
      port[control] := PushInsCommand2;
    end;
        {$IFDEF angry} delaycmd; {$ENDIF}
{    if Fourbit then delaycmd;}
  end;

procedure LPTPushChar2(charc:byte);
  begin
   asm
     mov dx, 888
     mov al, charc
     out dx, al

     mov dx, control
     mov al, pushcharcommand1
     out dx, al
     end;
    delay(controldelay);
    asm
     mov dx, control
     mov al, pushcharcommand2
     out dx, al
     end;


  end;

procedure LPTPushChar(charc:byte);
var pc1,pc2:byte;
   k:word;
  begin
    if FourBit then begin
      port[data] := charc;
      if E2_Pin > 0 then
      begin
        if E2PinOn then
        begin
          pc1 := PushCharCommand1 - PinDataOn[Enable_Pin] {+ PinDataOff[Enable_Pin]} + PinDataOn[E2_Pin];
          pc2 := PushCharCommand2 - PinDataOff[Enable_Pin] + PinDataOff[E2_Pin] + PinDataOn[Enable_Pin];
        end else begin
          pc1 := PushCharCommand1 + PinDataOff[E2_Pin];
          pc2 := PushCharCommand2 + PinDataOff[E2_Pin];
        end;
        port[control] := PC1;
        delaychar;
        port[control] := PC2;
      end else
      begin
        port[control] := PushCharcommand1;
        delaychar;
        port[control] := Pushcharcommand2;
      end;
      charc := charc shl 4;
    end;

    port[data] := charc;
        {$IFDEF angry} delaycmd; {$ENDIF}
    if E2_Pin > 0 then
    begin
      if E2PinOn then
      begin
        pc1 := PushCharCommand1 - PinDataOn[Enable_Pin] {+ PinDataOff[Enable_Pin]} + PinDataOn[E2_Pin];
        pc2 := PushCharCommand2 - PinDataOff[Enable_Pin] + PinDataOff[E2_Pin] + PinDataOn[Enable_Pin];
      end else begin
        pc1 := PushCharCommand1 + PinDataOff[E2_Pin];
        pc2 := PushCharCommand2 + PinDataOff[E2_Pin];
      end;
      port[control] := PC1;
      delaychar;
      port[control] := PC2;
    end else
    begin
      port[control] := PushCharcommand1;
      delaychar;
      port[control] := Pushcharcommand2;
    end;
        {$IFDEF angry} delaycmd; {$ENDIF}
  end;

procedure LPTDefineChar(cn,d1,d2,d3,d4,d5,d6,d7,d8:byte);
  var
   k:boolean;
  begin
    k:= E2PinOn;
    if E2_Pin > 0 then begin
      E2PinOn := true;
      lptpushins($40+(cn shl 3));
      lptpushchar(d1); lptpushchar(d2); lptpushchar(d3);
      lptpushchar(d4); lptpushchar(d5); lptpushchar(d6);
      lptpushchar(d7); lptpushchar(d8);
      delaychar;
    end;
    E2PinOn := false;
    lptpushins($40+(cn shl 3));
    lptpushchar(d1); lptpushchar(d2); lptpushchar(d3);
    lptpushchar(d4); lptpushchar(d5); lptpushchar(d6);
    lptpushchar(d7); lptpushchar(d8);
    delaychar;
    E2PinOn := k;
  end;

 procedure LPTCursorOn;
   begin
     LPTPushIns(13);
   end;

 procedure LPTCursorOff;
   begin
     LPTPushIns(12);
   end;

procedure LPTClear;
  begin
    if E2_Pin > 0 then begin
      E2PinOn := true;
      LPTPushIns(1);
      delay(1);
    end;
    E2PinOn := false;
    LPTPushIns(1);
    delaychar;
    if Fourbit then delaychar;
    delay(2);
  end;

procedure LPTToggle; begin LPTPushIns(8); end;

procedure LPTHome;
  begin
    E2PinOn := false;
    LPTPushIns(2);
  end;

procedure LPTCursor(l,x:byte);
  begin
    if (E2_Pin > 0) and (l > 2) then E2PinOn := true else E2PinOn := false;
    LPTPushIns(128+LineOffsets[l]+(x-1));
    delay(2);
    {    case l of
      1: lcdwritedata($80+(x-1));
      2: lcdwritedata($c0+(x-1));
      3: lcdwritedata($94+(x-1));
      4: lcdwritedata($d4+(x-1));
    end;}

  end;

procedure LPTReadSettings(section:string);
var lptport:word;
begin
    Fourbit := False;
    CharDelay := ReadWord(section,'CharDelay');
    ControlDelay := ReadWord(section,'ControlDelay');
    LPTPort := ReadWord(section,'LPTPort');
    Fourbit := ReadBoolean(section,'4bit');
    if LPTPort <> 0 then LPTSetPort(LPTPort);
    DATA := PORTADDRESS+0;
    STATUS := PORTADDRESS+1;
    CONTROL := PORTADDRESS+2;

    E2PinOn := false;
    SetRSPin(ReadWord(section,'RS_Pin'));
    SetRWPin(ReadWord(section,'RW_Pin'));
    SetEnablePin(ReadWord(section,'Enable_Pin'));
    SetE2Pin(ReadWord(section,'Enable_Pin2'));

    PushCharCommand1 := PinDataOn[RS_Pin] + PinDataOff[RW_Pin] + PinDataOn[Enable_Pin];
    PushInsCommand1 := PinDataOff[RS_Pin] + PinDataOn[Enable_Pin] + PinDataOff[RW_Pin];
    PushInsCommand2 := PinDataOff[RS_Pin] + PinDataOff[Enable_Pin] + PinDataOff[RW_Pin];

    PushCharCommand2 := PinDataOn[RS_Pin] + PinDataOff[RW_Pin] + PinDataOff[Enable_Pin];
    LineOffsets[1] := ReadWord(section,'Line1Offset');
    LineOffsets[2] := ReadWord(section,'Line2Offset');
    LineOffsets[3] := ReadWord(section,'Line3Offset');
    LineOffsets[4] := ReadWord(section,'Line4Offset');
end;

procedure LPTInitLCD;
  begin

    if E2_Pin > 0 then begin
      if Fourbit then
      begin
        E2PinOn := true;
        Fourbit := false;
        lptpushins(48);
        delay(2);
        lptpushins(48);
        delay(2);
        lptpushins(48);
        delay(2);
        lptpushins(40);
        delay(2);
        Fourbit := true;
        lptpushins($0c); { Setup display with cursor off}
        delay(2);
      end else
      begin
        E2PinOn := true;
        lptpushins(48);
        lptpushins(48);
        lptpushins(48); { 8 bit / 5x7 font }
        lptpushins(48); { 8 bit / 5x7 font }
        lptpushins(56); { 8 bit / 5x7 font / 2 lines }
        lptpushins(56); { 8 bit / 5x7 font / 2 lines }
        lptpushins(56); { 8 bit / 5x7 font / 2 lines }
        lptpushins($0c); { Setup display with cursor off}
        delay(2);
      end;
    end;

    if Fourbit then
    begin
      E2PinOn := false;
      Fourbit := false;
      lptpushins(48);
      delay(2);
      lptpushins(48);
      delay(2);
      lptpushins(48);
      delay(2);
      lptpushins(40);
      delay(2);
      Fourbit := true;
      lptpushins($0c); { Setup display with cursor off}
      delay(2);
    end else
    begin
      E2PinOn := false;
      lptpushins(48); { 8 bit / 5x7 font }
      lptpushins(48); { 8 bit / 5x7 font }
      lptpushins(48); { 8 bit / 5x7 font }
      lptpushins(48); { 8 bit / 5x7 font }
      lptpushins(56); { 8 bit / 5x7 font / 2 lines }
      lptpushins(56); { 8 bit / 5x7 font / 2 lines }
      lptpushins(56); { 8 bit / 5x7 font / 2 lines }
      lptpushins($0c); { Setup display with cursor off}
      delay(1);
    end;
    delay(50);
  end;

begin

end.
