unit mp3tag;
{
  MPXF ID3 Tag Unit
  strips ID3 tags.
}

interface

function songinfo(s:string):string;
implementation
uses dos,crt;
type
  tId3Tag = record                                 { Standard ID3 Tag }
             Tag : array[1..3] of char;
             Song, Artist, Album : array[1..30] of char;
             year : array[1..4] of char;
             comment : array[1..30] of char;
             genre : byte;
           end;

  tFindRecord = record                             { My Find Record, used to }
                 hasID3Tag : boolean;              { find the tags in a file }
                 ID3Tag : tId3Tag;
                 DIDTag : boolean;
                 DIDSize : word;
                 DIDStartPos : longint;
                end;

const DID    : string = 'DIDTAG';                  { Strings enclosing the }
      DIDEND : string = 'ENDDID';                  { tag }

var                                                { Some variables }
  mpfile : file;
  findrec: tFindRecord;
  genstring : string;

  length_of_tag : word;
  title, artist, album, software, sampledby, comment, genre, year : string;

{ Function arrayToString, converts array x to string }

function arrayToString(x: array of char; size : byte) : string;
var resulting : string;
begin;
  resulting[0]:=chr(size);
  move(mem[seg(x):ofs(x)],mem[seg(resulting[1]):ofs(resulting[1])],size);
  arrayToString:=resulting;
end;

function stripend(s:string):string;
  var dest:string;
      i,c:integer;
  begin
     i:=length(s);
     dest := '';
     c:=0;
     while ((s[i] = #0) or (s[i] = #32)) do begin
       inc(c);
       dec(i);
     end;
     dest := copy(s,1,(length(s)-c));
     i:=pos('_',dest);
     while i > 0 do begin
       dest[i] := ' ';
       i := pos('_',dest);
     end;
     i:=pos('-',dest);
     while i > 0 do begin
       dest[i] := ' ';
       i := pos('-',dest);
     end;
{     i:=pos('''',dest);
     while i > 0 do begin
       dest[i] := ' ';
       i := pos('''',dest);
     end;}

{     for i := 1 to length(dest) do dest[i] := upcase(dest[i]);}
     stripend := dest;
  end;


function strip(s:string; st:char): string;
  var
    l:integer;
    b:string;
    begin
      b:='';
      for l := 1 to length(s) do
        if s[l] <> st then b:=b+s[l];
      strip := b;
    end;

{ StringToArray, coverts string s to array x }

procedure StringToArray(var x : array of char;s : string);
begin;
  move(mem[seg(s[1]):ofs(s[1])],mem[seg(x):ofs(x)],ord(s[0]));
end;

{ findTag, finds the DID and ID3 Tags in file where, results are stored in
  frec }

procedure findTag(var where : file;var frec : tfindrecord);
var result : byte;
    idtest : tId3Tag;
    testarray : array[1..6] of char;
    size : word;


begin;
  result:=0;
  fillchar(frec,sizeof(tfindrecord),0);
{$I-}  seek(where,filesize(where)-128);
  blockread(where,idtest,128); {$I+}
  if IOResult = 0 then
  if arrayToString(idtest.tag,3)='TAG' then
  begin;
    frec.hasID3Tag:=true;
    frec.ID3Tag:=idtest;
  end;
{  if frec.hasID3Tag then tryDIDTag(128) else tryDIDTag(0);}
end;



function songinfo(s:string):string;
  var back:string;
      v:string;
begin
  filemode := 0;
  {$I-} assign(mpfile,s);
  reset(mpfile,1); {$I+}
 if IOResult = 0 then begin
   findTag(mpfile,findrec);                          { Search for the tags }
   if findrec.hasID3Tag then                         { Found ID3 Tag? }
   with findrec.id3tag do                            { Yes! }
     begin
       str(genre,v);
       back:=stripend(arrayToString(artist,30))+'-'+stripend(arraytoString(song,30)) +'-';
       back:=back+stripend(arraytoString(album,30))+'-'+v;
     end
   else back:='NoTag';
   close(mpfile);
   filemode := 2;
 end;
{ writeln(back);}
 songinfo := back;                        { Close the file to }
end;

end.                                               { make DOS happy }