unit mpxfcd;
{
  CD Audio Unit for MPXF
  Uses CDAUDIO.PAS (not written by me) for
  simple routines like eject, etc.
  CD audio playing is handled by MPXPlay
}

interface
uses newdelay;
procedure CDAudioPlay;
procedure ChangeCDROM;
procedure EjectCDROM;
procedure InitCDROM;

implementation

uses crt,lcd,cdaudio,mpxfvars,mpxfmenu;

procedure InitCDROM;
 begin
   initcdaudio;
 end;

procedure CDAudioPlay;
var s:string;
  begin
    if curcddrive <> 0 then
    begin
      s:='';
     s:=mp3prog + ' ' +mpxplaylistnormal + ' ' + chr(curcddrive+65)+':\*.cdw';
    lcdclear;
    if s <> '' then shell(s);

    end;
  end;

procedure OldCDAudioPlay;
 var
   CD:DiscRec;
   Track:TMSF;
   c:char;
   disctime:string;
   tracktime:string;
   min,sec:string[3];
  begin
    CD.Track := nil;
    LCDClear;
    LCDPrintAt(1,'Getting CD Info...');
    GetDiscInfo(CD);
    LCDPrintAt(2,'Got Info.');
    disctime := strr(CD.Length.Trk)+' trks ('+strr(CD.Length.Min)+':'+strr(CD.Length.Sec)+')  ';
    LCDPrintAt(1,disctime);
    delay(500);
    if InPause then ResumeAudio
     else if not DrvBusy then PlayTrack(1);
    repeat
      c:=' ';
      CurTrkPos(Track);
      tracktime := 'Track:'+strr(Track.Trk);
      Min := strr(Track.Min);
      Sec := strr(Track.Sec);
      if length(sec) = 1 then sec := '0'+sec;
      tracktime := tracktime + '  '+min+':'+sec+'  ';;
      LCDPrintAt(1,disctime);
      LCDPrintAt(2,tracktime);
      if keypressed then c:=readkey;
      if c=#27 then c:='.';
      case c of
        '+': PlayNextTrk;
        '-': PlayPrevTrk;
        '6': begin
               inc(Track.Sec,20);
               PlayFrom(Track);
             end;
        '5': if InPause then ResumeAudio else PauseAudio;
        '4': begin
               dec(Track.Sec,20);
               PlayFrom(Track);
             end;
      end;
    until c='.';
  end;

procedure ChangeCDROM;
    var mmchar:integer;
      main:^menu;
      savedir:string;
      i:integer;
      totald,d:byte;
      dir:string;
 begin
   new(main);
   totald:=0;
   for i := 1 to numcddrv do begin
     inc(totald);
     main^[totald] := chr(ord(drvlist[i-1])+65)+ ' drive';
   end;
   inc(totald);
   main^[totald] := 'Exit';
   d:=menuselect(main^,totald);
   dispose(main);
   if d<>totald then
     changecdromdrv(d-1);
 end;


procedure DiscInfo;
  var
   CD:DiscRec;
   Track:TMSF;
   c:char;
   disctime:string;
   tracktime:string;
   min,sec:string[3];
  begin
    CD.Track := nil;
    LCDClear;
    LCDPrintAt(1,'Getting CD Info...');
    GetDiscInfo(CD);
    LCDPrintAt(2,'Got Info.');
    LCDClear;
    delay(50);
    if not NoDisc then
      Info(strr(CD.Length.Trk)+' tracks ('+strr(CD.Length.Min)+':'+strr(CD.Length.Sec)+')  ',lcdlines)
    else Info('No Disc in Drive!',2);
 end;

procedure EjectCDROM;
  var
   CD:DiscRec;
   Track:TMSF;
   c:char;
   disctime:string;
   tracktime:string;
   min,sec:string[3];
  begin
    CD.Track := nil;
    GetDiscInfo(CD);
    LCDClear;
    LCDPrintAt(1,'Ejecting....');
    EjectDoor;
    delay(500);
    Info('Push <ENTER> when disc is loaded.',lcdlines);
    LCDClear;
    LCDPrintAt(1,center('Reading...'));
    InsertDoor;
    delay(500);
 end;

begin
end.