unit mpxfmem;
{
  MPXF Memory Unit
}

interface
uses mpxfvars;
procedure ReleaseXMS;
procedure Init_XMS;
procedure SetXMSMemory;
procedure PrepareAdd;
procedure putsong(thesong:song);
procedure savemem(p:integer);
procedure putsongat(position:integer;thesong:song);
function getsonginfo(position:integer) : songname;
function getsongall(position:integer) : songname;
function getsongpath(position:integer) : songname;
implementation
uses xms,lcd,newdelay,crt;
  var
  data:array[1..MaxMem] of string[SongSize];

procedure Init_XMS;
begin
  xmscount:=0;
  memblocks:=0;
  numhdl:=0;
  HiMemOK := XMSDriverLoaded;
{  WriteLn('XMS Memory=', HiMemOK);}
  IF NOT HiMemOK THEN begin
     writeln('Unable to allocate XMS');
     writeln('Make sure you have HIMEM.SYS loaded in your config.sys file.');
     Halt;
  end;
  Hdl := XMSAllocateBlock((MaxSongs * SongSize + 1023) DIV 1024);
end;

procedure SetXMSMemory;
begin
    inc(memblocks);
    savemem(memblocks);
    dec(memblocks); { Go back }
end;

procedure PrepareAdd;
var
      ret:songname;

  begin
    ret := getsonginfo(totalsongs);
  end;

procedure savemem(p:integer);
  var i:integer;
  begin
{    for i := 1 to maxmem do writeln(data[i]);
    readln;}
      IF NOT XMSMoveDataTo(@data, sizeof(data), Hdl, (p - 1) *
        sizeof(data)) THEN
        WriteLn('Error on Move to XMS: ',I,' Error: ', XMSErrorCode);
      for i := 1 to maxmem do data[i] := '';
  end;

function getsongpath(position:integer) : songname;
  var rest:song;
      ret:songname;
      l:integer;
      h:integer;
      where:integer;
  begin
    ret := '';
    if position > totalsongs then exit;
     clear(rest);
   h := ((position-1) div maxmem);
  where := position - (h*maxmem);
{  if where = 0 then where := maxmem;}
  IF NOT XMSGetDataFrom(Hdl, h * sizeof(Data),
    sizeof(data), @Data) THEN
    WriteLn('Error on XMSGetDataFrom, getsongpath, handle=', h)
    ELSE begin
       ret := Data[where];
       ret := copy(ret,1,length(ret)-1);
       ret:=copy(ret,1,100);
    end;
    getsongpath := ret;
  end;

function getsonginfo(position:integer) : songname;
  var rest:song;
      ret:songname;
      l:integer;
      h:integer;
      where:integer;
  begin
    ret := '';
    if position > totalsongs then exit;
     clear(rest);
   h := ((position-1) div maxmem);
  where := position - (h*maxmem);
{  if where = 0 then where := maxmem;}
  IF NOT XMSGetDataFrom(Hdl, h * sizeof(Data),
    sizeof(data), @Data) THEN
    WriteLn('Error on XMSGetDataFrom, getsonginfo, handle=', h, ' totalsongs=',totalsongs)
    ELSE begin
       ret := Data[where];
       ret := copy(ret,1,length(ret)-1);
       ret:=copy(ret,101,200);
    end;
    if position = 0 then ret := '';
    getsonginfo := ret;
  end;

function getsongall(position:integer) : songname;
  var rest:song;
      ret:songname;
      l:integer;
      h:integer;
      where:integer;
  begin
    ret := '';
    if position > totalsongs then exit;
     clear(rest);
   h := ((position-1) div maxmem);
  where := position - (h*maxmem);
{  if where = 0 then where := maxmem;}
  IF NOT XMSGetDataFrom(Hdl, h * sizeof(Data),
    sizeof(data), @Data) THEN
    WriteLn('Error on XMSGetDataFrom, getsonginfo, handle=', h, ' totalsongs=',totalsongs)
    ELSE begin
       ret := Data[where];
       ret := copy(ret,1,length(ret)-1);
    end;
    getsongall := ret;
  end;

procedure putsongat(position:integer;thesong:song);
  var rest:song;
      ret:songname;
      l:integer;
      h:integer;
      where:integer;
      puts:song;
  begin
    ret := '';
    if position > totalsongs then exit;
     clear(rest);
   h := ((position-1) div maxmem);
  where := position - (h*maxmem);
{  if where = 0 then where := maxmem;}
  IF NOT XMSGetDataFrom(Hdl, h * sizeof(Data),
    sizeof(data), @Data) THEN
    begin
      WriteLn('Error on XMSGetDataFrom, getsongpath, handle=', h);
      delay(2000);
    end
    ELSE begin
        clear(puts);
        puts:=thesong;
        data[where] := puts;
        savemem(h+1);
    end;
  end;

procedure putsong(thesong:song);
  var puts:song;
      ret:songname;
      mb:word;

  begin
    clear(puts);
    puts:=thesong;
    inc(xmscount);
    data[xmscount] := puts;
    if (xmscount=maxmem) then begin
      xmscount := 0;
      inc(memblocks);
      savemem(memblocks);
    end;
  end;



procedure ReleaseXMS;
  var l:integer;
  begin
      if not XMSReleaseBlock(Hdl) then begin
         writeln('Error Releasing!');
         LCDClear;
         LCDPrintAt(1,'Error Releasing');
         LCDPrintAt(2,'  Memory!');
       end;
  end;

begin
end.