unit mpxfmenu;
{
  MPXF Menus.
  This was rewritten for the last versions.
  It uses MPXFMENU.CFG to parse the menus, which can be dynamic.
}


interface
  type
  menu_type = record
    Display:string[100];
    Data:string[100];
  end;
  newmenu = array[1..50] of ^menu_type;
  menu = array[1..300] of string[40];
  var
  PlayerHalt:boolean;
function MenuSelect(TheMenu:menu; choices:integer) : integer;
procedure SearchMenu;
procedure PlayListMenu;
procedure SetupMenu;
procedure DatabaseMenu;
procedure CDAudioMenu;
procedure IRMenu;
procedure LoadMenu(section:string;choices:integer;var temp:menu);
procedure MenuLoop(StartMenu : string);
implementation

uses mpxfvars,lcd,crt,mpxfsrch,mpxfpl,mpxfgen,mpxfdb,mpxfcd,config,mpxfir;

var
  NextMenu:string[100];

const
  mnuPlayDatabase=50;
  mnuPlayDrive=51;
  mnuSearchArtist=30;
  mnuSearchSong=31;
  mnuSearchAlbum=32;
  mnuBrowseHD=60;
  mnuBacktoMain=10;

  mnuSortArtist=100;
  mnuSortAlbum=101;
  mnuSortSong=102;
  mnuSortPath=103;

  mnuDatabaseInfo=20;
  mnuBrowseSongs=21;
  mnuAddMP3=22;
  mnuDatabaseLoad=23;
  mnuDatabaseSave=24;
  mnuDatabaseClear=25;
  mnuDatabaseSort=26;

  mnuHelpBoxes=80;
  mnuUseGenres=81;
  mnuSelectGenres=82;

  mnuIRInfo=90;
  mnuIRAddcode=91;
  mnuIRClearcode=92;
  mnuIRLoadcode=93;
  mnuIRSavecode=94;

  mnuPLPlay=40;
  mnuPLLoad=41;
  mnuPLEdit=42;
  mnuPLSave=43;
  mnuPLClear=44;

  mnuPlayCD=70;
  mnuChangeDisc=71;
  mnuChangeDrive=72;

  mnuPlayOption = 5;


procedure AddData(var data:string);
var p:byte;
    a1,a2:string;
    add:string;

    procedure ProcessKey(key,replace:string);

      begin
        if pos(key,upstring(data)) > 0 then
        begin
           p := pos(key,upstring(data));
           a1 := copy(data,1,p-1);
           a2 := copy(data, p + length(key), length(data));
           data := a1 + replace + a2;
        end;
      end;

    begin
      PlayOptionData := '';
      AddPlayOptions(PlayOptionData);
      if Helpboxes then add := YesStr else add := NoStr;
      ProcessKey('$HELPBOXES',add);
      if GenreSupport then add := YesStr else add := NoStr;
      ProcessKey('$USEGENRES',add);
      ProcessKey('$FILEINFO', PlayData);
      ProcessKey('$PLAYOPTIONS', PlayOptionData);
      ProcessKey('$MP3PROG',mp3prog);
    end;

function MenuSelect(TheMenu:menu; choices:integer) : integer;
  var
    i:integer;
    cs:string;
    ch:char;
    tag:word;
    CurrentChoice:word;
    iReturn:integer;
    PrintLine:byte;
    br1,br2:string;
    brp:byte;
    aa:string;
    cv:byte;
    code:integer;

    function center(s:string):string;
      var l:integer;
          space:integer;
          ret:string;
      begin
        ret := s;
        l := length(s);
        if (l < lcdlen) then begin
          space := LCDLen-l;
          space := space div 2;
          ret := s;
          for l := 1 to space do ret := ' ' + ret + ' ';
        end else center := s;
        center := ret;
     end;



    procedure Update;
      var sn:string;
          Album:string;
          Artist:string;
          i,b,a :integer;
      begin
        lcdclear;
        lcdcursoroff;
        gotoxy(1,12);
        writeln('                     Processing Menu: ['+NextMenu+']');

       if (CurrentChoice = choices) and (Choices >= LCDLines) then begin
          for i := CurrentChoice-1 downto CurrentChoice-LCDLines+1 do
            LCDPrintAt(LCDLines-(CurrentChoice-i),center(TheMenu[i]));
          LCDPrintAt(LCDLines,center('['+TheMenu[CurrentChoice]+']'));
          PrintLine := LCDLines;
       end else
       if ((Choices-CurrentChoice) < LCDLines-1) and (Choices>=LCDLines) then begin
         b := choices-currentchoice;
         a := lcdlines - b;
         for i := 1 to a-1 do
           LCDPrintAt(i, center(TheMenu[Choices-lcdlines+i]));
         LCDPrintAt(a, center('['+TheMenu[CurrentChoice]+']'));
         PrintLine := a;
         for i := a+1 to LCDLines do
           LCDPrintAt(i,center(TheMenu[Choices+-lcdlines+i]));
       end else
       begin
          LCDPrintAt(1,center('['+TheMenu[CurrentChoice]+']'));
          PrintLine := 1;
          for i := 2 to LCDLines do
            if ((i-1+currentchoice)<=choices) then
            LCDPrintAt(i,center(TheMenu[CurrentChoice+i-1]))
            else
              LCDPrintAt(i,spaces(LCDLen));
       end;
      end;

  begin
    cv := 0;
    if (not cmdempty) then
    begin
      ch:= upcase(cmdnext);
      aa := ch;
      val(aa,cv,code);
    end;
    if (cv > 0) then
    begin
      cmdpop;
      MenuSelect := cv;
    end else
    begin
      for i := 1 to Choices do
      begin
        aa := TheMenu[i];
        AddData(aa);
        TheMenu[i] := aa;
{        AddData(TheMenu[i]);}
      end;
      brp:=1;
      br1:='>]-';
      br2:='<[-';
      delay(50);
      InitLCD;
      delay(50);
      LCDCoolClear;
      LCDCursorOFF;
      CurrentChoice:=1;
      Update;
      iReturn := 0;
      repeat
        ch := ' ';
        if keypress then ch:=getkey;
        if ch=#27 then ch:=chr(ExitChar);
        if (ch=chr(UpChar)) then
          begin
            if CurrentChoice = 1 then CurrentChoice := Choices
              else dec(CurrentChoice);
            Update;
          end;
        if (ch=chr(DownChar)) then
        begin
          if CurrentChoice = Choices then CurrentChoice := 1 else
            inc(CurrentChoice);
          Update;
        end;
    {$IFNDEF notwirl}
        LCDPrintAt(PrintLine,center(br1[brp]+TheMenu[CurrentChoice]+br2[brp]));
        delay(60);
    {$ENDIF}
        inc (brp);
        if brp = 4 then begin
          brp := 1;
          DrawMPXFLogo;
        end;
       until (ch=chr(EnterChar)) or (ch=chr(ExitChar));
       if (ch = chr(ExitChar)) then MenuSelect := choices else MenuSelect := CurrentChoice;
   { // Check if user got out // }
   end;

 end;

function QuitPlayer:boolean;
var
 q:boolean;
 begin
   q:=false;
   lcdclear;
   lcdprintat(1,center('Quit Player?'));
   q:=YesNo(2);
   QuitPlayer := q;
 end;

procedure StartSearch(t:byte);
      var
      inp:string;
      code:integer;
      iSong:word;
      i:word;

  begin
       numresults := 0;
      for i := 1 to MaxSearch do begin
        Songsearch[i].songnum := 0;
        Songsearch[i].tag := 0;
      end;


    Search := t;
    LCDClear;
    case Search of
      1: begin
           LCDPrintAt(1,ArtistStr+':');
           inp:=input(1,length(ArtistStr)+2);
         end;
      2: begin
           LCDPrintAt(1,SongStr+':');
           inp:=input(1,length(SongStr)+2);
         end;
      3: begin
           LCDPrintAt(1,AlbumStr+':');
           inp:=input(1,length(albumStr)+2);
         end;
    end;
    LCDClear;
    LCDPrintAt(1,LoadingStr+'...');
    DoSearch(Search,inp,Songsearch,numresults);
    if numresults > 0 then iSong := ScrollPlayList(Songsearch,numresults);
  end;

procedure ProcessMenu(section:string);
  var
    b,choices:byte;
    temp1,temp2:string;
    a:string;
    MS:newmenu;
    TMenu:menu;
    selmenu:byte;
    begin
      if (openconfig('mpxfmenu.cfg') = false) then
      begin
        clrscr;
        writeln('Cannot open MPXF Menu config!');
        halt;
      end else
      begin
        choices := 0;
        temp1 := 'Start';
        while (temp1 <> '') do
        begin
          temp1 := ReadString(section,'Disp'+strr(choices+1));
          temp2 := ReadString(section,'Data'+strr(choices+1));
          if temp1 <> '' then
          begin
            inc(choices);
            new(MS[choices]);
            MS[choices]^.Display := temp1;
            MS[choices]^.Data := temp2;
          end;
        end;
        closeconfig; { We're done }
        if (choices > 0) then
        begin
          if choices = 1 then NextMenu := MS[choices]^.data
          else
          begin
            for b := 1 to choices do
              TMenu[b] := MS[b]^.display;
            selmenu := MenuSelect(Tmenu,choices);
            NextMenu := MS[selmenu]^.data;
          end;
        end else
          NextMenu := 'Error'; { More than 1 choice }
      end; { Menu found }

      for b := 1 to choices do
        dispose(MS[b]);
    end; { Procedure }



procedure MenuLoop(StartMenu : string);
  var stopped:boolean;
      prevmenu:string;
      cod,mv:integer;
      temp:string;
      i:integer;
      backout:boolean;

  begin
    if playerhalt then exit;
    stopped := false;
{    NextMenu := 'Start Menu';}
    NextMenu := StartMenu;
    if PlayerHalt = False then
    repeat
      PrevMenu := NextMenu;
      ProcessMenu(NextMenu);
      if NextMenu = 'Error' then
      begin
        clrscr;
        writeln('Error in Menu config file!');
        writeln('See ',PrevMenu,' section!');
        delay(2500);
        stopped := true;
        NextMenu := PrevMenu;
      end else
      if copy(NextMenu,1,1) = '[' then begin
        { Its a Menu, lets strip the [  ] }
        NextMenu := copy(NextMenu,2,length(NextMenu));
        NextMenu := copy(NextMenu,1,length(NextMenu)-1);
      end else
      if upstring(copy(NextMenu,1,5)) = 'SHELL' then
        begin
          NextMenu := copy(NextMenu,7,length(nextmenu));
          temp := nextmenu;
          AddData(temp);
          shell(temp);
          NextMenu := PrevMenu;
        end else
      if upstring(copy(NextMenu,1,4)) = 'PLAY' then
        begin
          NextMenu := copy(NextMenu,6,length(nextmenu));
          temp := nextmenu;
          AddData(temp);
          writeln;
          writeln(PlayData);
          writeln(PlayOptionData);
          writeln(temp);
          shell(temp);
          stopped := true;
{          NextMenu := PrevMenu;}
        end else


      if (NextMenu = 'Quit') and (QuitPlayer) then begin
        stopped := true;
        playerhalt := true
      end else
      begin { Its not a menu, we need to process the command }
        val(NextMenu,mv,cod);
        case mv of
          mnuPlayDatabase: begin Help('All MP3s in the database will be sent to the playlist file MPXFALL.M3U',LCDLines);
            PlayALL;      end;
          mnuPlayDrive: begin Help('This command plays all the MP3s on a selected drive. No Database is needed.',LCDLines);
            PlayDrive;    end;
          mnuSearchArtist: StartSearch(1);
          mnuSearchSong: StartSearch(2);
          mnuSearchAlbum: StartSearch(3);
          mnuBrowseHD: BrowseDrive;
          mnuSortArtist:SortDatabase(1);
          mnuSortAlbum:SortDatabase(2);
          mnuSortSong:SortDatabase(3);
          mnuSortPath:SortDatabase(4);
          mnuDatabaseInfo: DatabaseInfo;
          mnuBrowseSongs: BrowseSongs;
          mnuAddMP3: begin             Help('This will add songs on disk to the database in memory.',LCDLines);
             AddFiles;     end;
          mnuDatabaseLoad: begin       Help('This will load a database on disk into memory.',LCDLines);
             PickDatabase; end;
          mnuDatabaseSave: begin       Help('This saves all song in memory to a database file (M3D).',LCDLines);
             PromptSaveDatabase;    end;
          mnuDatabaseClear:begin
      Help('Clearing the database wipes out all songs in memory. All changes made to the database will be lost unless saved.',
                      LCDLines);   ClearDatabase;    end;
          mnuHelpBoxes: HelpBoxes := not HelpBoxes;
          mnuUseGenres:  GenreSupport := not GenreSupport;
          mnuSelectGenres: begin   Help('Tag the Genre Styles that you want to appear in searches.',LCDLines);
                                   Help('Use + to tag. Press Enter to Exit',LCDLines);
               GenreSelect; end;
          mnuIRInfo: begin lcdclear;
            if irfound then
              Info('IR active on com'+strr(IRPort)+'. '+irmpxffn+' holds '+strr(numcodes)+' button codes.',lcdlines) else
            Info('IR not active.',lcdlines);       end;
          mnuIRAddCode: IRAddKeys;
          mnuIRClearCode: IRClearCodes;
          mnuIRLoadCode: IRLoadConfig(GetIRFilename);
          mnuIRSavecode: IRSaveConfig(GetIRFilename);
          mnuPLPlay: PlayPlayList;
          mnuPLEdit: EditPlayList;
          mnuPLLoad: LoadPLayList;
          mnuPLSave: SavePlayList;
          mnuPLClear: begin
              ClearPlayList;
              LCDClear;
              LCDPrintAt(1,'Playlist Cleared!');
              LCDCursorOn;
              delay(500);
              LCDCursorOff;
            end;
          mnuPlayCD:CDAudioPlay;
          mnuChangeDisc: ChangeCDROM;
          mnuChangeDrive: EjectCDROM;
          mnuPlayOption:PlayOptionSelect;
        end;
        NextMenu := PrevMenu;
      end;
    until stopped or playerhalt;
  end;

procedure LoadMenu(section:string;choices:integer;var temp:menu);
var b:byte;
    a:string;

  begin
    write('Load Menu was called!');
    readln;
{    if (openconfig('mpxflang.cfg') = false) then
      begin
        clrscr;
        writeln('Cannot find MPXF language file (mpxflang.cfg)!');
        delay(1500);
      end else
     begin
       for b := 1 to choices do begin
         a := ReadString(section,'Choice'+strr(b));
         if a <> '' then temp[b] := a
           else
             begin
               writeln('mpxflang.cfg is out of date.');
               delay(500);
             end;
       end;
       closeconfig;
     end;}
  end;

procedure SearchMenu;
  var sch:integer;
      inp:string;
      code:integer;
      iSong:word;
      smenu:^menu;
      i:integer;

  begin
    repeat

      LCDClear;
      LCDCursorOff;
      new(smenu);
      smenu^[1] := 'Play Database';
      smenu^[2] := 'Play Drive';
      smenu^[3] := 'Search Artist';
      smenu^[4] := 'Search Song';
      smenu^[5] := 'Search Album';
      smenu^[6] := 'Browse HD';
      smenu^[7] := 'Back to Main';
      {LoadMenu('Play/Search Menu',7, smenu^);}
      sch := menuselect(smenu^,7);
      dispose(smenu);

      search := sch-2;
      numresults := 0;
      LCDClear;
      for i := 1 to MaxSearch do begin
        Songsearch[i].songnum := 0;
        Songsearch[i].tag := 0;
      end;
      case Sch of
       1: begin
            Help('All MP3s in the database will be sent to the playlist file MPXFALL.M3U',LCDLines);
            PlayALL;
          end;
       2: begin
            Help('This command plays all the MP3s on a selected drive. No Database is needed.',LCDLines);
            PlayDrive;
          end;

        3: begin
             LCDPrintAt(1,ArtistStr+':');
             inp:=input(1,length(ArtistStr)+2);
           end;
        4: begin
             LCDPrintAt(1,SongStr+':');
             inp:=input(1,length(SongStr)+2);
           end;
        5:  begin
             LCDPrintAt(1,AlbumStr+':');
             inp:=input(1,length(albumStr)+2);
           end;
        6: BrowseDrive;
     end;
     if length(inp) > 0 then
     if (Search >= 1) and (Search <=3) then begin
       LCDClear;
       LCDPrintAt(1,LoadingStr+'...');
       DoSearch(Search,inp,Songsearch,numresults);
     end;
     if numresults > 0 then iSong := ScrollPlayList(Songsearch,numresults);
   until sch=7;
end;


procedure SortDatabaseMenu;
  var dbchar:integer;
      dbmenu:^menu;
  begin
      LCDClear;
      LCDCursorOff;
      new(dbmenu);
      dbmenu^[1] := 'Sort by Artist';
      dbmenu^[2] := 'Sort by Album';
      dbmenu^[3] := 'Sort by Title';
      dbmenu^[4] := 'Sort by Path';
      dbmenu^[5] := 'Cancel';
      LoadMenu('SortDatabase Menu',5, dbmenu^);
      dbchar := menuselect(dbmenu^,5);
      dispose(dbmenu);
      if dbchar <> 5 then
      begin
        LCDClear;
        LCDPrintAt(1,center('Sorting...'));
        SortDatabase(dbchar);
      end;
      LCDClear;
  end;

procedure DatabaseMenu;
  var dbchar:integer;
      dbmenu:^menu;
  begin
    repeat
      LCDClear;
      LCDCursorOff;
      new(dbmenu);
      dbmenu^[1] := 'Database Info';
      dbmenu^[2] := 'Browse Songs';
      dbmenu^[3] := 'Add MP3s';
      dbmenu^[4] := 'Load Database';
      dbmenu^[5] := 'Save Database';
      dbmenu^[6] := 'Clear Database';
      dbmenu^[7] := 'Sort Database';
      dbmenu^[8] := 'Back to Main';
      LoadMenu('Database Menu',8, dbmenu^);
      dbchar := menuselect(dbmenu^,8);

      dispose(dbmenu);
      case dbchar of
        1: DatabaseInfo;
        2: BrowseSongs;
        3: begin
             Help('This will add songs on disk to the database in memory.',LCDLines);
             AddFiles;
           end;
        4: begin
             Help('This will load a database on disk into memory.',LCDLines);
             PickDatabase;
            end;
        5: begin
             Help('This saves all song in memory to a database file (M3D).',LCDLines);
             PromptSaveDatabase;
           end;
        6: begin
Help('Clearing the database wipes out all songs in memory. All changes made to the database will be lost unless saved.',
LCDLines);
             ClearDatabase;
           end;
        7: begin
             SortDatabaseMenu;
           end;
      end;
    until dbchar = 8;
  end;

procedure SetupMenu;
  var smchar:integer;
      smenu:^menu;
 begin
   repeat
     LCDClear;
     LCDCursorOff;
     new(smenu);
     smenu^[1] := 'Help Boxes:';
     smenu^[2] := 'Use Genres:';
     smenu^[3] := 'Select Genres';
     smenu^[4] := 'MP3 Maintnence';
     smenu^[5] := 'IR Setup';
     smenu^[6] := 'Back to Main';
     LoadMenu('Setup Menu',6, smenu^);
     if HelpBoxes then smenu^[1] := smenu^[1] + 'Yes' else smenu^[1] := smenu^[1] + 'No';
     if GenreSupport then smenu^[2] := smenu^[2] + 'Yes' else smenu^[2] := smenu^[2] + 'No';
     smchar := menuselect(smenu^,6);
     dispose(smenu);
     case smchar of
       1: HelpBoxes := not HelpBoxes;
       2: GenreSupport := not GenreSupport;
       3: begin
            Help('Tag the Genre Styles that you want to appear in searches.',LCDLines);
            Help('Use + to tag. Press Enter to Exit',LCDLines);
            GenreSelect;
          end;
       4: begin
            Help('This launches an external program defined in the MPXF.CFG file.',LCDLines);
            shell(networkutil);
          end;
       5: IRmenu;
     end;
   until smchar = 6;
   save_settings;
 end;

procedure IRMenu;
  var irchar:integer;
      irmenu:^menu;
 begin
   repeat
     LCDClear;
     LCDCursorOff;
     new(irmenu);
     irmenu^[1] := 'IR Info';
     irmenu^[2] := 'Add a code';
     irmenu^[3] := 'Clear Codes';
     irmenu^[4] := 'Load Codes';
     irmenu^[5] := 'Save Codes';
     irmenu^[6] := 'Back to Setup';
{     LoadMenu('IR Menu',6, irmenu^);}
{P     irmenu^[1] := irmenu^[1] + strr(numcodes);}

     irchar := menuselect(irmenu^,6);
     dispose(irmenu);
     case irchar of
       1: begin
            lcdclear;
            if irfound then
              Info('IR active on com'+strr(IRPort)+'. '+irmpxffn+' holds '+strr(numcodes)+' button codes.',lcdlines) else
            Info('IR not active.',lcdlines);
          end;
       2: IRAddKeys;
       3: IRClearCodes;
       4: IRLoadConfig(GetIRFilename);
       5: IRSaveConfig(GetIRFilename);
     end;
   until irchar = 6;
 end;



procedure PlayListMenu;
  var plchar:integer;
      playmenu:^menu;
 begin
   repeat
     LCDClear;
     LCDCursorOff;
     new(playmenu);
     playmenu^[1] := 'Play List';
     playmenu^[2] := 'Load List';
     playmenu^[3] := 'Edit List';
     playmenu^[4] := 'Save List';
     playmenu^[5] := 'Clear List';
     playmenu^[6] := 'Back to Main';
     LoadMenu('Playlist Menu',6,playmenu^);
     plchar := menuselect(playmenu^,6);
     dispose(playmenu);
{     repeat plchar:=readkey; until (pos(plchar,'123') > 0) or (plchar = #13);}
     case plchar of
       1: PlayPlayList;
       3: EditPlayList;
       2: LoadPLayList;
       4: SavePlayList;
       5: begin
              ClearPlayList;
              LCDClear;
              LCDPrintAt(1,'Playlist Cleared!');
              LCDCursorOn;
              delay(500);
              LCDCursorOff;
            end;

     end
   until plchar = 6;
 end;

procedure CDAudioMenu;
  var cdchar:integer;
      playmenu:^menu;

 begin
   repeat
     LCDClear;
     LCDCursorOff;
     new(playmenu);
     playmenu^[1] := 'Play CD';
     playmenu^[2] := 'Change Disc';
     playmenu^[3] := 'Change Drive';
     playmenu^[4] := 'Back to Main';
     LoadMenu('CDAudio Menu',4,playmenu^);
     cdchar := menuselect(playmenu^,4);
     dispose(playmenu);
     case cdchar of
       1: begin
            CDAudioPlay;
          end;
       2: ChangeCDROM;
       3: EjectCDROM;

     end
   until cdchar = 4;
 end;

begin

end.