unit mpxfpl;
{
  MPXF Playlist unit
}

interface
uses mpxfvars;
procedure PlayDrive;
function GetPlayList:word;
procedure ClearPlayList;
procedure LoadPlayList;
procedure SavePlayList;
procedure EditPlayList;
procedure BrowseSongs;
procedure PlayPlayList;
procedure PlayAll;
function ScrollPlayList(var results:sresults; numresults:word) : integer;
implementation
uses mpxfmenu,dos,lcd,crt,newdelay,mpxfgen,mpxfmem,mpxfdb,config;

function aPlayListMenu:byte;
      var
      sch:integer;
      smenu:menu;
      s:string;
  begin
    repeat
      lcdclear;
      smenu[1] := 'Play Normal';
      smenu[2] := 'Play Random';
      smenu[3] := 'Play Options';
      smenu[4] := 'Cancel';
      LoadMenu('Play Options',4,smenu);
      sch := menuselect(smenu,4);
      if sch = 3 then PlayOptionselect;
    until sch <> 3;
    aPlaylistmenu := sch;
  end;

procedure LaunchPlaylist(tpl:string);
var
      sch:integer;
      smenu:menu;
      s:string;
      c:char;
  begin
{    sch := playlistmenu;
    s:='';
    if sch = 2 then
      s:=mp3prog + ' ' + mpxplaylistrandom + ' -@ ' + PlayListDir+tpl
     else  if sch = 1 then s:=mp3prog + ' ' +mpxplaylistnormal + ' -@ ' + PlayListDir+tpl;
     }
    lcdclear;
    PlayData := PlayListDir+tpl;
    PlayOptionData := '';
    AddPlayOptions(PlayOptionData);
    MenuLoop('Play');
{    AddPlayOptions(s);}
{    if (sch <> 4) and (s <> '') then shell(s);}
  end;

procedure PlayPlayList;
var i:integer;
    numresults:word;
    s:string;
    pt:text;

  procedure LoadandPlayList;
  var lists:^menu;
      longlist:^menu;
      numlists:word;
      pick:word;
      numsongs:word;
      inp:string;
      t:text;
      code:integer;
      allsongs:word;
      SongCount:word;
      DirInfo: SearchRec;
      f:string;

      begin
        new(lists);
        new(longlist);
        LCDClear;
        LCDPrintAt(1,LoadingStr+'.');
        numlists := 0;
        openconfig('fileinfo.cfg');
        FindFirst(PlayListDir+'*.m3u', Archive+ReadOnly, DirInfo);
        while DosError = 0 do
        begin
          inc(numlists);
          lists^[numlists] := copy(DirInfo.Name,1,length(DirInfo.name)-4);
          f:=ReadString('PlayList',DirInfo.Name);
          if f <> '' then longlist^[numlists] := f else longlist^[numlists] := lists^[numlists];

           FindNext(DirInfo);
           if (numlists=9) then LCDCursor(2,1);
           LCDPrint('.');
         end;
         closeconfig;
      LCDClear;
       If numlists = 0 then begin
         LCDPrintAt(1,'No Lists Found!');
         delay(1500);
      end else begin
        inc(numlists);
        lists^[numlists] := '-EXIT-';
        longlist^[numlists] := '-EXIT-';
        pick := menuselect(longlist^,numlists);
        if pick <> numlists then begin
           LaunchPlayList(lists^[pick]+'.m3u');
        end;
        dispose(lists);
        dispose(longlist);
      end;

  end;

  begin
     i := 1;
     numresults := GetPlayList;
     LCDClear;
     if numresults > 0 then begin
       LCDPrintAt(1,'Creating');
       LCDPrintAt(2,'Playlist...');
       assign(pt,Playlistdir+'mpxf.m3u');
      {$I-}
       rewrite(pt);
      if IOResult = 0 then
      begin
       while (PlayList[i].songnum <> 0) do begin
          writeln(pt,strip(getsongpath(PlayList[i].songnum),' '));
          i:= i+1;
       end;
       close(pt);
       LaunchPlayList('mpxf.m3u');
      end else close(pt);
     end else LoadandPlayList;


   end;

procedure PlayALL;
 var i:integer;
      pt:text;
      s:string;

  begin
    if totalsongs = 0 then begin
      LCDClear;
      Info(NoStr+' '+songsstr+' in Database!',LCDLines);
      exit;
    end;
    LCDClear;
    LCDPrintAt(1,'Creating');
    LCDPrintAt(2,'Playlist...');
    assign(pt,Playlistdir+'mpxfall.m3u');
    {$I-}
    rewrite(pt);
    if IOResult = 0 then
    begin
      for i := 1 to totalsongs do begin
       if (SongInGenre(getsonginfo(i))) then
           writeln(pt,strip(getsongpath(i),' '));
      end;
      close(pt);
      LaunchPlayList('mpxfall.m3u');
    end else close(pt);
  end;

function GetPlayList:word;
  var i:word;
      f:word;
    begin
      f:=0;
      i:=0;
      while ((f=0) and (i<MaxSearch)) do begin
        inc(i);
        if PlayList[i].SongNum = 0 then f:= i;
      end;
      if f=0 then f:=1;
      GetPlayList := f-1;
    end;

procedure LoadPlayList;
var lists:menu;
    longlist:menu;
    numlists:word;
    pick:word;
    numsongs:word;
    inp:string;
    t:text;
    code:integer;
    allsongs:word;
    SongCount:word;
    f:string;

var
 DirInfo: SearchRec;
begin
          LCDClear;
        LCDPrintAt(1,LoadingStr+'.');
        numlists := 0;
        openconfig('fileinfo.cfg');
        FindFirst(PlayListDir+'*.m3u', Archive+ReadOnly, DirInfo);
        while DosError = 0 do
        begin
          inc(numlists);
          lists[numlists] := copy(DirInfo.Name,1,length(DirInfo.name)-4);
          f:=ReadString('PlayList',DirInfo.Name);
          if f <> '' then longlist[numlists] := f else longlist[numlists] := lists[numlists];

           FindNext(DirInfo);
           if (numlists=9) then LCDCursor(2,1);
           LCDPrint('.');
         end;
         closeconfig;
      LCDClear;
       If numlists = 0 then begin
         LCDPrintAt(1,'No Lists Found!');
         delay(1500);
      end else begin
        inc(numlists);
        lists[numlists] := '-EXIT-';
        longlist[numlists] := '-EXIT-';
        pick := menuselect(longlist,numlists);

     if pick <> numlists then begin
       assign(t,PlayListDir+lists[pick]+'.m3u');
       reset(t);
       SongCount := GetPlayList;
       LCDClear;
       LCDPrintAt(1,'Loading.');
       code := 0;
       while not(eof(t)) do begin
         inc(numsongs);
         readln(t,inp);
         if (numsongs=8) then LCDCursor(2,1);
         LCDPrint('.');
         inp := strip(inp,' ');
         FindFirst(inp, Archive+ReadOnly, DirInfo); { See if exists before adding }
         if DosError = 0 then begin
           AllSongs := 1;
           while (Allsongs < totalsongs) do begin
             if inp = strip(getsongpath(allsongs),' ') then begin
               inc(SongCount);
               Playlist[SongCount].songnum := allsongs;
             end;
             inc(allsongs,1);
           end;
         end;
      end;
      close(t);
      LCDClear;
      LCDPrintAt(1,strr(SongCount)+' '+songsstr+' loaded.');
      LCDCursorOn;
      delay(1500);
      LCDCursorOff;
      LCDClear;
     end;
  end;
 end;


procedure PlayDrive;
  var
    thedrive :string;
    smenu:^menu;
    s:string;
    sch:byte;

    begin
      thedrive := selectdrive;
      if thedrive <> '0' then
        begin
          lcdclear;
          PlayData := thedrive+ '*.*\*.mp3';
          PlayOptionData := '';
          AddPlayOptions(PlayOptionData);
          MenuLoop('Play Drive');

{          sch := playlistmenu;
          s:='';
          if sch = 2 then
             s:=mp3prog + ' ' + mpxplaylistrandom + ' ' +thedrive+ '*.*\*.mp3 '
           else  if sch = 1 then s:=mp3prog + ' ' +mpxplaylistnormal + ' ' +thedrive + '*.*\*.mp3 ';}
          lcdclear;
          LCDPrintAt(1,LoadingStr);
{          AddPlayOptions(s);
          if (sch<>4) and (s <> '') then shell(s);}
        end;
    end;


procedure SavePlayList;
  var i:integer;
      numresults:word;
      filename:string;
      t:text;
    begin
      numresults := GetPlayList;
      if numresults = 0 then exit;
      LCDClear;
      LCDPrintAt(1,'Save '+strr(numresults)+' songs.');
      LCDPrintAt(2,'Enter Filename:');
      delay(2000);
      filename := getalpha;
      LCDClear;
      if length(filename) = 0 then exit;
      LCDPrintAt(1,'Saving.');
      filename := PlayListDir+copy(filename,1,8)+'.m3u';
      writeln(filename);
      assign(t,filename);
      rewrite(t);
      {$I-}
       rewrite(t);
       if IOResult = 0 then
      for i := 1 to numresults do begin
        writeln(t,strip(GetSongpath(PlayList[i].songnum),' '));
        if (i=9) then LCDCursor(2,1);
        LCDPrint('.');
      end;
      close(t);
      LCDClear;
      LCDPrintAt(1,'Done!');
      delay(1000);
      LCDClear;
    end;

procedure RemoveFromPlayList(p: word);
  var i:word;
      f:word;
    begin
      f:=0;
      i:=0;
      while (f=0) do begin
        inc(i);
        if PlayList[i].SongNum = p then begin
          PlayList[i].SongNum := 0;
          PlayList[i].Tag := 0;
          f := i;
        end;
      end;
      for i := f to MaxSearch-1 do
        PlayList[i].SongNum := PlayList[i+1].SongNum;
    end;


procedure AddToPlayList(p: word);
  var i:word;
      f:word;
    begin
      f:=0;
      i:=0;
      while ((f=0) and (i<MaxSearch)) do begin
        inc(i);
        if PlayList[i].SongNum = 0 then f:= i;
      end;
      if (f<>0) then begin
        PlayList[f].SongNum := p;
        PlayList[f].Tag := 0;
      end;
    end;

function slashconv(inp:string):string;
 var a:string;
     l:integer;
   begin
    a:=inp;
    for l := 1 to length(a) do if a[l] = '\' then a[l] := '/';
    slashconv := a;
   end;

function ScrollPlayList(var results:sresults; numresults:word) : integer;
  type
    linerec=record
      buf:string;
      pos:integer;
      dir:byte;
      endlinepause:word;
      content:string;
    end;
  var
{    PlaySong:string;}
    start:integer;
    info:integer;
    line:array[1..4] of linerec;
    i:integer;
    cs:string;
    ch:char;
    tag:word;
    CurrentSong:word;
    CurrentLine:word;
    SongTitle:string;
    SongDesc:string;
    Ppos:word;
    iReturn:integer;


    procedure UpdateSong(songnum:word);
      var sn:string;
          Album:string;
          Artist:string;
          i :integer;
      begin
        LCDClear;
        sn := strr(CurrentSong);
        if length(sn) = 1 then sn := '  '+sn;
        if length(sn) = 2 then sn := ' '+sn;
        sn := sn + '|';
        SongTitle := GetTitle(getsonginfo(songnum));
        while (length(SongTitle) <= (LCDLen-start)) do SongTitle := SongTitle + ' ';
        Album := GetAlbum(getsonginfo(songnum));
        Artist := GetArtist(getsonginfo(songnum));
        LCDPrintAt(1,sn);
        SongDesc := Artist;
        if length(Album) > 2 then SongDesc := SongDesc + ' - ' + Album;
        while (length(SongDesc) <= (LCDLen-start)) do SongDesc := SongDesc + ' ';
        LCDPrintAt(2,' ');
        if (results[CurrentSong].tag = 0) then LCDPrint(chr(219)) else
          LCDPrint(chr(255));
        LCDPrint(' |');

        for i:=1 to lcdlines do begin
          line[i].dir := 1; line[i].buf := ' '; line[i].pos := 0;
          line[i].content := ' ';
        end;

        line[1].content := Songtitle;
        line[1].buf := slashconv(copy(SongTitle,1,(LCDLEN-start)+1));
        line[2].content := SongDesc;
        line[2].buf := slashconv(copy(SongDesc,1, (LCDLEN-start)+1));


        if (lcdlines > 2) and (CurrentSong+1 <= numresults) then begin
          sn := strr(CurrentSong+1);
          if length(sn) = 1 then sn := '  '+sn;
          if length(sn) = 2 then sn := ' '+sn;
          sn := sn + '|';

          SongTitle := GetTitle(getsonginfo(results[CurrentSong+1].songnum));
          while (length(SongTitle) <= (LCDLen-start)) do SongTitle := SongTitle + ' ';
          Album := GetAlbum(getsonginfo(results[CurrentSong+1].songnum));
          Artist := GetArtist(getsonginfo(results[CurrentSong+1].songnum));
          SongDesc := Artist;
          if length(Album) > 2 then SongDesc := SongDesc + ' - ' + Album;
          while (length(SongDesc) <= (LCDLen-start)) do SongDesc := SongDesc + ' ';
          LCDPrintAt(3,sn);
          LCDPrintAt(4,' ');
          if (results[CurrentSong+1].tag = 0) then LCDPrint(chr(219)) else
            LCDPrint(chr(255));
          LCDPrint(' |');

        line[3].content := Songtitle;
        line[3].buf := slashconv(copy(SongTitle,1,(LCDLEN-start)+1));
        line[4].content := SongDesc;
        line[4].buf := slashconv(copy(SongDesc,1, (LCDLEN-start)+1));

        end;

        if not scrolling then begin
          for i := 1 to lcdlines do begin
            LCDCursor(i,start);
            LCDPrint(slashconv(line[i].buf));
          end;
        end;
        delay(5);
      end;

     procedure LCDHelp;
       var
         lines:array[1..4] of string;
         b:byte;

         procedure next(line:string);
           var b:byte;
           begin
             for b := 1 to (lcdlines-1) do lines[b] := lines[b+1];
             for b := 1 to lcdlines do LCDPrintAt(b,lines[b]);
             delay(700);
          end;

          begin
             LCDClear;
             for b:=1 to lcdlines do lines[b] := ' ';
             lines[lcdlines]:='HELP Commands   ';
             next('----------------');
             next('8 Up Song       ');
             next('2 Down Song     ');
             next('+ Add/Remove    ');
             next('* De/Select All ');
             next('0 Loop   ON/OFF ');
             next('5 Scroll ON/OFF ');
             next('<CR> Play Song  ');
             next('- EXIT Menu     ');
             delay(1500);
             next('----------------');
         end;


  begin
{    LCDtoScreen := False;}
    for i := 1 to lcdlines do begin
      line[i].buf := ''; line[i].pos := 1;
      line[i].dir := 1; line[i].endlinepause := 0;
    end;
    Tag := 0;
    CurrentSong:=1;
    starcount := 0;
    start:=5;
    ch := ' ';
    UpdateSong(results[CurrentSong].songnum);
    iReturn := 0;
    repeat
     for CurrentLine := 1 to lcdlines do begin
       if (Scrolling) and ((length(line[CurrentLine].content) > (LCDLen-start+1))) then
       begin
         if line[CurrentLine].dir=1 then inc(line[CurrentLine].pos) else dec(line[CurrentLine].pos);
         if (line[CurrentLine].pos > (length(line[CurrentLine].content)-LCDLen+start)) then
         begin
           if line[CurrentLine].endlinepause = 0 then line[CurrentLine].endlinepause := (ScrollPause div 4)+1;
           if line[CurrentLine].endlinepause = 1 then
           begin
             line[CurrentLine].pos:=length(line[CurrentLine].content)-LCDLen+start;
             line[CurrentLine].dir := 0;
             line[CurrentLine].endlinepause := 0;
           end else begin
             dec(line[CurrentLine].endlinepause);
             dec(line[CurrentLine].pos);
           end;
         end;
         if (line[CurrentLine].pos < 1) then
         begin
           if line[CurrentLine].endlinepause = 0 then line[CurrentLine].endlinepause := (ScrollPause div 4)+1;
           if line[CurrentLine].endlinepause = 1 then
           begin
             line[CurrentLine].pos:=1;
             line[CurrentLine].dir := 1;
             line[CurrentLine].endlinepause := 0;
           end else begin
             dec(line[CurrentLine].endlinepause);
             inc(line[CurrentLine].pos);
           end;
         end;
         line[CurrentLine].buf := copy(line[CurrentLine].content,line[CurrentLine].pos,lcdlen-start+1);
{         while(length(line[Currentline].buf)) < lcdlen do line[Currentline].buf := line[Currentline].buf + ' ';
         line[CurrentLine].buf := copy(line[CurrentLine].buf, 1, lcdlen-start)}
       end;
       LCDCursor(CurrentLine,start);
       LCDPrint(line[CurrentLine].buf);
     end; { Do lines }
     dostar(2);
     ch := ' ';
     if keypress then ch:=getkey;
     if ch=chr(LoopToggleChar) then
       begin
         LOOP := not Loop;
         LCDClear;
         LCDPrintAt(1,'Loop is ');
         if loop then LCDPrint('ON') else LCDPrint('OFF');
         delay(1000);
         UpdateSong(results[CurrentSong].songnum);
       end;
     if ch=chr(TagChar) then
       begin
         if (results[CurrentSong].tag = 1) then
         begin
           dec(Tag);
           RemoveFromPlayList(results[CurrentSong].songnum);
           results[CurrentSong].tag := 0;
         end else
         begin
           AddToPlayList(results[CurrentSong].songnum);
           inc(Tag);
           results[CurrentSong].tag := 1;
         end;
         LCDCursor(2,2);
         if (results[CurrentSong].tag = 0) then LCDPrint(chr(219)) else
           LCDPrint(chr(255));
       end;
     if ch=chr(ScrollToggleChar) then
       begin
         Scrolling := not Scrolling;
         UpdateSong(results[CurrentSong].songnum);
       end;
     if ch=chr(UpChar) then
       begin
         if CurrentSong = 1 then CurrentSong := NumResults else
           dec(CurrentSong);
         UpdateSong(results[CurrentSong].songnum);
       end;
     if ch=Chr(DownChar) then
       begin
         if CurrentSong = NumResults then CurrentSong := 1 else
         inc(CurrentSong);
         UpdateSong(results[CurrentSong].songnum);
       end;
     if ch=chr(LCDHelpChar) then
       begin
         LCDHelp;
         UpdateSong(results[CurrentSong].songnum);
       end;
     if ch=chr(TagAllChar) then
       begin
         for i := 1 to numresults do
           if (results[i].tag = 0) then
           begin
             results[i].tag := 1;
             AddToPlayList(results[i].songnum);
             Inc(tag);
           end else
           begin
             results[i].tag := 0;
             RemoveFromPlayLIst(results[i].songnum);
             dec(Tag);
           end;
         UpdateSong(results[CurrentSong].songnum);
       end;
     if ch=chr(EnterChar) then
       begin
         if tag = 0 then
           PlaySong(results[CurrentSong].songnum)
         else
           PlayPlayList;
         UpdateSong(results[CurrentSong].songnum);
       end;
     delay(ScrollDelay);
     drawmpxflogo;
   until (ch=chr(ExitChar));

   { // Check if user got out // }
   if (Ch<>chr(ExitChar)) then begin
     if (Tag = 0) then begin
        iReturn := CurrentSong;
     end;
   end;
   LCDtoSCreen := True;
   ScrollPlayList := iReturn;
 end;

procedure EditPlayList;
var i:integer;
    numresults:word;

  begin
     i := 1;
     numresults := GetPlayList;
     Songsearch := PlayList;
     if numresults > 0 then begin
       for i := 1 to numresults do Songsearch[i].tag := 1;
       ScrollPlayList(Songsearch,numresults);
     end;
   end;


procedure ClearPlayList;
var i:integer;
  begin
   for i := 1 to MaxSearch do begin
     PlayList[i].songnum := 0;
     PlayList[i].tag := 0;
   end;
 end;

procedure BrowseSongs;
  type
    linerec=record
      buf:string;
      pos:integer;
      dir:byte;
      endlinepause:word;
      content:string;
    end;
  var

    start:integer;

    line:array[1..4] of linerec;
    i:integer;
    cs:string;
    ch:char;
    tag:word;
    CurrentSong:word;
    CurrentLine:word;
    SongTitle:string;
    SongDesc:string;
    Ppos:word;
    iReturn:integer;
    jumpnum:word;


function jump:word;
 {
   Jump to #
   9/17/99
 }
 var
  position :integer;
  ch:char;
  data:string;
  code:integer;
  number:integer;
  ret:word;
  line,start:byte;

  begin
    lcdclear;
    ret := 0;
    LCDPrintat(1,'Jump to');
    LCDPrintat(2,'  Song#');
    data:='';
    LCDCursorON;
    position := 0;
    line:=2;
    start :=8;
    repeat
      repeat until keypress;
      ch:=getkey;
      if (pos(ch, '1234567890') > 0) then
        begin
          data := data + ch;
          inc(position);
          val(ch,number,code);
          LCDCursor(line,start+position-1);
          LCDChar(ch);
       end;
      if ((ch = chr(ExitChar)) and (position > 0)) then
        begin
          position := position - 1;
          LCDCursor(line,start+position);
          LCDChar(' ');
          LCDCursor(line,start+position);
          data:=copy(data,1,position);
          LCDCursorOn;
        end;
       until (ch=chr(EnterChar)) or (ch=chr(JumpChar));
      val(data,ret,code);
      LCDClear;
      LCDCursorOFF;
      jump := ret;
    end;

    procedure UpdateSong;
      var sn:string;
          Album:string;
          Artist:string;
          i :integer;
          songnum:word;
      begin
        songnum := CurrentSong;
        LCDClear;
        sn := strr(CurrentSong);
        if length(sn) = 1 then sn := '  '+sn;
        if length(sn) = 2 then sn := ' '+sn;
        sn := sn + '|';
        SongTitle := GetTitle(getsonginfo(songnum));
        while (length(SongTitle) <= (LCDLen-start)) do SongTitle := SongTitle + ' ';
        Album := GetAlbum(getsonginfo(songnum));
        Artist := GetArtist(getsonginfo(songnum));
        LCDPrintAt(1,slashconv(sn));
        SongDesc := Artist;
        if length(Album) > 2 then SongDesc := SongDesc + ' - ' + Album;
        while (length(SongDesc) <= (LCDLen-start)) do SongDesc := SongDesc + ' ';
        LCDPrintAt(2,'   |');

        for i:=1 to lcdlines do begin
          line[i].dir := 1; line[i].buf := ''; line[i].pos := 0;
        end;

        line[1].content := Songtitle;
        line[1].buf := slashconv(copy(SongTitle,1,(LCDLEN-start)+1));
        line[2].content := SongDesc;
        line[2].buf := slashconv(copy(SongDesc,1, (LCDLEN-start)+1));


        if (lcdlines > 2) and (CurrentSong+1 <= TotalSongs) then begin
          sn := strr(CurrentSong+1);
          if length(sn) = 1 then sn := '  '+sn;
          if length(sn) = 2 then sn := ' '+sn;
          sn := sn + '|';

          SongTitle := GetTitle(getsonginfo(songnum+1));
          while (length(SongTitle) <= (LCDLen-start)) do SongTitle := SongTitle + ' ';
          Album := GetAlbum(getsonginfo(songnum+1));
          Artist := GetArtist(getsonginfo(songnum+1));
          SongDesc := Artist;
          if length(Album) > 2 then SongDesc := SongDesc + ' - ' + Album;
          while (length(SongDesc) <= (LCDLen-start)) do SongDesc := SongDesc + ' ';
          LCDPrintAt(3,sn);
          LCDPrintAt(4,'   |');

          line[3].content := Songtitle;
          line[3].buf := slashconv(copy(SongTitle,1,(LCDLEN-start)+1));
          line[4].content := SongDesc;
          line[4].buf := slashconv(copy(SongDesc,1, (LCDLEN-start)+1));
        end;


        if not scrolling then begin
          for i := 1 to lcdlines do begin
            LCDCursor(i,start);
            LCDPrint(slashconv(line[i].buf));
          end;
        end;
        delay(20);
      end;

     procedure LCDHelp;
       var
         lines:array[1..4] of string;
         b:byte;

         procedure next(line:string);
           var b:byte;
           begin
             for b := 1 to (lcdlines-1) do lines[b] := lines[b+1];
             for b := 1 to lcdlines do LCDPrintAt(b,lines[b]);
             delay(700);
          end;

          begin
             LCDClear;
             for b:=1 to lcdlines do lines[b] := ' ';
             lines[lcdlines]:='HELP Commands   ';
             next('----------------');
             next('8,4 Back Song   ');
             next('1,9 Back 10 Sngs');
             next('2,6 Next Song   ');
             next('3   Fwd 10 Songs');
             next('+ Jump to Song  ');
             next('0 Loop   ON/OFF ');
             next('* Scroll ON/OFF ');
             next('5   Play Song   ');
             next('-  EXIT Menu    ');
             delay(1500);
             next('----------------');
         end;


  begin
    if totalsongs > 0 then begin
  {    LCDtoScreen := False;}
      for i := 1 to lcdlines do begin
       line[i].buf := ''; line[i].pos := 1;
       line[i].dir := 1; line[i].endlinepause := 0;
      end;
      Tag := 0;
      CurrentSong:=1;
      starcount := 0;
      start:=5;
      ch := ' ';
      UpdateSong;
      iReturn := 0;
      repeat
        for CurrentLine := 1 to LCDLines do begin
          if (CurrentLine < 3) and (Scrolling) and ((length(line[CurrentLine].content) > (LCDLen-start+1))) then
          begin
            if line[CurrentLine].dir=1 then inc(line[CurrentLine].pos) else dec(line[CurrentLine].pos);
            if (line[CurrentLine].pos > (length(line[CurrentLine].content)-LCDLen+start)) then
            begin
              if line[CurrentLine].endlinepause = 0 then line[CurrentLine].endlinepause := (ScrollPause div 4)+1;
              if line[CurrentLine].endlinepause = 1 then
              begin
                line[CurrentLine].pos:=length(line[CurrentLine].content)-LCDLen+start;
                line[CurrentLine].dir := 0;
                line[CurrentLine].endlinepause := 0;
              end else
              begin
               dec(line[CurrentLine].endlinepause);
               dec(line[CurrentLine].pos);
             end;
           end;
           if (line[CurrentLine].pos < 1) then
           begin
             if line[CurrentLine].endlinepause = 0 then line[CurrentLine].endlinepause := (ScrollPause div 4)+1;
             if line[CurrentLine].endlinepause = 1 then
             begin
               line[CurrentLine].pos:=1;
               line[CurrentLine].dir := 1;
               line[CurrentLine].endlinepause := 0;
             end else
             begin
               dec(line[CurrentLine].endlinepause);
               inc(line[CurrentLine].pos);
             end;
           end;
           line[CurrentLine].buf := copy(line[CurrentLine].content,line[CurrentLine].pos,lcdlen-start+1);
{          while(length(line[Currentline].buf)) < lcdlen do line[Currentline].buf := line[Currentline].buf + ' ';}
         end;
         LCDCursor(CurrentLine,start);
         LCDPrint(line[CurrentLine].buf);
       end; { Do lines }
       dostar(2);
       ch := ' ';
       if keypress then ch:=getkey;
       if ch=chr(LoopToggleChar) then
         begin
           LOOP := not Loop;
           LCDClear;
           LCDPrintAt(1,'Loop is ');
           if loop then LCDPrint('ON') else LCDPrint('OFF');
           delay(1000);
           UpdateSong;
         end;
      if ch=chr(ScrollToggleChar) then
        begin
          Scrolling := not Scrolling;
          UpdateSong;
        end;
      if ((ch=chr(LeftChar)) or (ch=chr(UpChar))) then
        begin
         if CurrentSong = 1 then CurrentSong := TotalSongs else
           dec(CurrentSong);
         UpdateSong;
        end;
      if ((ch=chr(RightChar)) or (ch=chr(DownChar))) then
        begin
          if CurrentSong = TotalSongs then CurrentSong := 1 else
           inc(CurrentSong);
          UpdateSong;
        end;
      if (ch=chr(Down10Char)) then
        begin
          if CurrentSong < 10 then CurrentSong := TotalSongs else
            dec(CurrentSong,10);
          UpdateSong;
        end;
      if (ch=chr(Up10Char)) then
        begin
          if CurrentSong > (TotalSongs-11) then CurrentSong := 1 else
            inc(CurrentSong,10);
          UpdateSong;
        end;
      if ch=chr(LCDHelpChar) then
        begin
          LCDHelp;
          UpdateSong;
        end;
      if ch=chr(JumpChar) then
        begin
          jumpnum := jump;
          if (jumpnum <> 0) and (jumpnum <= TotalSongs) then CurrentSong := jumpnum;
          updatesong;
        end;
      if ch=chr(EnterChar) then
        begin
          PlaySong(CurrentSong);
          UpdateSong;
        end;
     delay(ScrollDelay);
     drawmpxflogo;
   until (ch=chr(ExitChar));

   LCDtoSCreen := True;
   end else
   begin
{     LCDClear;
     delay(200);}
     Info('No Songs in Database!',LCDLines);
   end;
 end;


begin
end.