unit mpxfsrch;
{
  MPXF Searching routines
}

interface
uses mpxfvars;
procedure initphone;
function input(line,start:byte):string;
procedure DoSearch(kind:integer;phonelist:string;var results:sresults; var numresults:word);
implementation
uses lcd,mpxfgen,crt,mpxfmem;


function phonesearch(number:string; asong:songname):boolean;
{
  Phone Search
  input phone number Ex: 24559
  and desc, Ex: BillyJoel

  returns TRUE if phone # fits desc.

}
 var
   num,code:integer;
   match:boolean;
   count:word;
   song:songname;
   numchar:char;
  begin
    song := strip(asong,' ');
    song := strip(asong,'''');
    match:=true;
    count:=0;
    while (length(number) > 0) and (match) do begin
      inc(count);
      val(number[1],num,code);

      number := copy(number,2,length(number));
      match := match and (pos(upcase(song[count]),phone[num]) > 0)
    end;
    phonesearch:=match;
{    writeln('out');}
  end;

procedure initphone;
 begin
   phone[0] := '0';
   phone[1] := '1';
   phone[2] := 'ABC2';
   phone[3] := 'DEF3';
   phone[4] := 'GHI4';
   phone[5] := 'JKL5';
   phone[6] := 'MNO6';
   phone[7] := 'PQRS7';
   phone[8] := 'TUV8';
   phone[9] := 'WXYZ9';
 end;

procedure DoSearch(kind:integer;phonelist:string;var results:sresults; var numresults:word);
  var
    count:word;
    thesong:songname;
    respos:word;
    rest:string;
    bar:word;
    i:integer;
  begin
    for i := 1 to MaxSearch do results[i].songnum := 0;
    bar := totalsongs div SearchBar;
    count := 0;
    respos := 0;
    LCDCursor(SearchBarLine,1);
    LCDPrint('[');
    for i := 1 to bar do LCDPrint(' ');
    LCDPrint(']');
    LCDCursor(SearchBarLine,2);
    while (count < totalsongs) do begin
      inc(count);
{      write(count,',',totalsongs,'  ');}
      if (count mod SearchBar) = 0 then LCDPrint('.');
      case kind of
        1: thesong := upstring(strip(GetArtist(getsonginfo(count)),' '));
        2: thesong := upstring(strip(GetTitle(getsonginfo(count)),' '));
        3: thesong := upstring(strip(GetAlbum(getsonginfo(count)),' '));
      end;
      if (length(thesong) > 1) and (SongInGenre(getsonginfo(count))) then
      if phonesearch(phonelist, upstring(thesong)) then begin
        if respos <= MaxSearch then begin
          inc(respos);
          results[respos].songnum := count;
        end;
      end;
    end;
    numresults := respos;
  end;

procedure FastSearch(kind:integer;phonelist:string;var results:sresults; var numresults:word);
  var
    count:word;
    thesong:songname;
    respos:word;
    rest:string;
  begin
    count := 0;
    respos := 0;
    while (count < SongBuildResults) do begin
      inc(count,1);
      case kind of
        1: thesong := upstring(strip(GetArtist(getsonginfo(SongBuild[count].songnum)),' '));
        2: thesong := upstring(strip(GetTitle(getsonginfo(SongBuild[count].songnum)),' '));
        3: thesong := upstring(strip(GetAlbum(getsonginfo(SongBuild[count].songnum)),' '));
      end;
      if (length(thesong) > 1) and (SongInGenre(getsonginfo(SongBuild[count].songnum))) then
      if phonesearch(phonelist, upstring(thesong)) then begin
        inc(respos);
        results[respos].songnum := count;
      end;
    end;
    numresults := respos;
  end;

procedure ClearSongBuild;
var i:integer;
  begin
   for i := 1 to MaxSearch do begin
     SongBuild[i].songnum := 0;
     SongBuild[i].tag := 0;
   end;
 end;

function input(line,start:byte):string;
 {
   Inputs from Keypad w/LCD display
   3/23/99
 }
 var
  position :integer;
  ch:char;
  data:string;
  code:integer;
  number:integer;
  keybuild : string;

  begin
    keybuild := mpxfnumone + mpxfnumtwo + mpxfnumthree + mpxfnumfour + mpxfnumfive + mpxfnumsix + mpxfnumseven;
    keybuild := keybuild + mpxfnumeight + mpxfnumnine + mpxfnumzero;
    data:='';
    LCDCursorON;
    position := 0;
    repeat
      repeat until keypress;
      ch:=getkey;
      if ch=#27 then ch:=chr(ExitChar);
      if (pos(ch, keybuild) > 0) then
        begin
          if (ch = mpxfnumone) then ch :='1';
          if (ch = mpxfnumtwo) then ch:='2';
          if (ch = mpxfnumthree) then ch:='3';
          if (ch = mpxfnumfour) then ch:='4';
          if (ch = mpxfnumfive) then ch:='5';
          if (ch = mpxfnumsix) then ch:='6';
          if (ch = mpxfnumseven) then ch:='7';
          if (ch = mpxfnumeight) then ch:='8';
          if (ch = mpxfnumnine) then ch:='9';
          if (ch = mpxfnumzero) then ch:='0';

          data := data + ch;
          inc(position);
          val(ch,number,code);
          LCDCursor(2,13);
          LCDPrint(phone[number]+' ');

          LCDCursor(line,start+position-1);
          LCDChar(ch);
          write(ch);
          if length(data) = 1 then begin
            ClearSongBuild;
            DoSearch(Search,data,SongBuild,SongBuildResults);
            LCDPrintAt(2,strr(SongBuildResults)+' results. ');
            LCDCursor(1,start+position);
          end;
          if (Search >0) and (length(data) > 1) then begin
            FastSearch(Search,data,Songsearch,numresults);
            LCDPrintAt(2,strr(numresults)+' results. ');
            LCDCursor(1,start+position);
          end;
       end;
      if ((ch = chr(ExitChar)) or (ch = '0')) and (position > 0) then
        begin
          position := position - 1;
          LCDPrintAt(2,'                ');
          LCDCursor(line,start+position);
          LCDChar(' ');
          LCDCursor(line,start+position);
{          gotoxy(wherex-1,wherey);
          write(' ');
          gotoxy(wherex-1,wherey);}
          data:=copy(data,1,position);
          LCDCursorOn;
        end;
       until ch=#13;
      if position = 0 then songbuildresults := 0;
      input:=data;
      LCDClear;
      LCDCursorOFF;
    end;

begin
end.