unit mpxftsrb;
{ TSR Routines }
interface

procedure doit;
procedure shutoff;

implementation

Uses lcd,Dos ,config
 {$IFDEF serkey} ,mpxfkey{$ENDIF};

TYPE  Treg = 0..$D;     { range for time/date register addresses    }
      To23 = 0..23;     { range for hours                           }
      To59 = 0..59;     { range for minutes and seconds             }
VAR   Yr, Mth, Day, DoW, Hr, Min, Sec : BYTE;

const

  vdate = '08/24/00';

type
  bound_rec= record
     start,theend:byte;
  end;
  attr_rec= record
     name:string;
  end;

  scroll_rec = record
    on:boolean;
    p:integer;
    dir:integer;
    pause:integer;
    delay:integer;
  end;

  line_rec = record
    LineScroll:boolean;
    LineValue:byte;
    LineString:string[50];
    LineTime:word;
  end;

  Browse_Rec = record
    filestring:string[80];
  end;

  line_type = record
    Values:byte;
    scrolling:boolean;
    current:byte;
    DelayTime:word;
    data:array[1..4] of line_rec;
  end;
Var

    PlayListBound, FileseekBound,  TimeBound,  CPUBound,  ArtistBound,
    SongBound: byte;
    Paused:boolean;
    DrawLogo:boolean;
    Printing:boolean;
    StatLine,  StartLine,    InfoLine,   VolLine,   PauseLine,BracketLine,
    DelayFactor,    LCDLines,    LCDLen : byte;
{    lcdcontroldelay,lcdchardelay:byte;
    lcdport:word;}
    RefreshDelay,TimetoRefresh:word;
    scrolldelay,scrollpause:byte;
    ShowNumLock:boolean;
    AllStats:string;
    c:char;
    i,j,k:integer;
    changes:boolean;
    codefile:string[30];

    BrowseString:string[80];

    PlayFile:string;
    bounds:array[1..6] of bound_rec;
    attrinfo:array[1..5] of attr_rec;
    displayit:array[1..4] of boolean;
    Attributes:byte;
    b:string;
    a:byte;
    w:word;

    keyPlayView,keyScrollToggle,keyLineUp,keyLineDown,keyLineToggle:byte;
    registered :boolean;
    crcfail:boolean;
    InKeyRoutine:boolean;

    PauseCheck:boolean;
    ViewFiles:boolean;



    Count:Byte;                       { Counts Seconds                }
{    Time:Longint  Absolute $40:$6C;   { Bios Keeps Clock Time Here    }
    Orgint9:Procedure;
    Old1Cint:Procedure;               { Linkage To Old 1C Interrupt   }
    itson:boolean;
{    LCDLineSelected:array[1..4] of byte;}
    LCDLineSet:array[1..4] of line_type;
{    LCDInfo:array[1..4] of string;}
    LCDSelected:byte;
    Scrolling:array[1..4] of scroll_rec;
    ExitPlayer:boolean;
    KeyboardEnabled :boolean;
    NumLockStatus:boolean;


function FileExists(FileName: String): Boolean;
{ Boolean function that returns True if the file exists;otherwise,
 it returns False. Closes the file if it exists. }
var
 F: file;
begin
 {$I-}
 Assign(F, FileName);
 FileMode := 0;
 Reset(F);
 Close(F);
 {$I+}
 FileExists := (IOResult = 0) and (FileName <> '');
end;  { FileExists }

procedure delay(d:word);
 var k,j:word;
  begin
    k := d * 4000;
    for j := 1 to k do ;
  end;

function strr(b:word):string;
var s1:string;
  begin
    s1:='';
    str(b,s1);
    strr:=s1;
  end;

Function ShiftState : Byte;
Var
  Regs : Registers;
begin
  Regs.Ah := 2;
  Intr($16, Regs);
  ShiftState := Regs.Al;
end;

Function NumLockOn : Boolean;
begin
  NumLockOn := (ShiftState and 32) <> 0;
end;

procedure eq_bars;
begin
  delay(50);
  initlcd;
  delay(50);
  lcddefinechar(7,  0,0,0,0,0,0,0,31);
  lcddefinechar(6, 0,0,0,0,0,0,31,31);
  lcddefinechar(5, 0,0,0,0,0,31,31,31);
  lcddefinechar(4, 0,0,0,0,31,31,31,31);
  lcddefinechar(3, 0,0,0,31,31,31,31,31);
  lcddefinechar(2, 0,0,31,31,31,31,31,31);
  lcddefinechar(1, 0,31,31,31,31,31,31,31);
  lcddefinechar(0, 31,31,31,31,31,31,31,31);
  delay(50);
  lcdclear;
end;

procedure clear_bars;
begin
  lcddefinechar(7,  0,0,0,0,0,0,0,0);
  lcddefinechar(6,  0,0,0,0,0,0,0,0);
  lcddefinechar(5,  0,0,0,0,0,0,0,0);
  lcddefinechar(4,  0,0,0,0,0,0,0,0);
  lcddefinechar(3,  0,0,0,0,0,0,0,0);
  lcddefinechar(2,  0,0,0,0,0,0,0,0);
  lcddefinechar(1,  0,0,0,0,0,0,0,0);
  lcddefinechar(0,  0,0,0,0,0,0,0,0);
end;


procedure TSRLogo;
 var c,i,j,k,a,d:integer;
 begin
   d:= 4;
   if (lcdlines = 4) and (lcdlen > 20) then d := 4;
   if lcdlines = 2 then d := 8 else d:=4;
   if (lcdlines = 2) and (lcdlen > 20) then d := 4;
   for a:= 1 to 20 do
    for i := 1 to lcdlines do begin
      LCDCursor(i,1);
      for j := 1 to lcdlen do
        begin
          k:=random(7);
          LCDPrint(chr(k));
          delay(d);
        end;
    end;
    c:= lcdlen div 2;
    c:=c-3;
    delay(10);
    LCDCursor(1,c);
    LCDPrint('MPXF TSR');
    LCDCursor(2,c);
    LCDPrint(' v'+version+'    ');
if lcdlines > 2 then begin
    LCDCursor(3,c);
    LCDPrint('        ');
    LCDCursor(4,c);
    LCDPrint('        ');
end;
    for a := 1 to 55 do
      for i := 1 to lcdlines do begin
        LCDCursor(i,1);
        for j:=1 to c-1 do begin
          k:=random(7);
          LCDPrint(chr(k));
          delay(d);
        end;
        LCDCursor(i,c+8);
        for j:=c+8 to lcdlen do begin
          k:=random(7);
          LCDPrint(chr(k));
          delay(d);
        end;
        if a= 40 then begin
          LCDCursor(2,c);
          LCDPrint(' Loaded ');
        end;
      end;
      for a := 0 to 8 do
      for i := 1 to lcdlines do begin
        LCDCursor(i,1);
        for j:=1 to c-1 do begin
          if a = 8 then k := ord('*') else k:=a;
          LCDPrint(chr(k));
          delay(d);
        end;
        LCDCursor(i,c+8);
        for j:=c+8 to lcdlen do begin
          if a = 8 then k := ord('*') else k:=a;
          LCDPrint(chr(k));
          delay(d);
        end;
     end;


 end;

procedure DoConfig;
var code,data,h:integer;
  begin
    if not (openconfig('mpxftsr.cfg')) then begin
      writeln('MPXFTSR.CFG not found!');
      halt(1);
    end;

    PauseCheck := ReadBoolean('MPXPlay Settings','PauseCheck');
    PlaylistBound := ReadWord('MPXPlay Settings','Playlistbound');
    FileseekBound := ReadWord('MPXPlay Settings','Fileseekbound');
    TimeBound := ReadWord('MPXPlay Settings','TimeBound');
    CPUBound := ReadWord('MPXPlay Settings','CPUBound');
    ArtistBound := ReadWord('MPXPlay Settings','ArtistBound');
    SongBound := ReadWord('MPXPlay Settings','SongBound');
    BracketLine := ReadWord('MPXPlay Settings','BracketLine');
    StatLine := ReadWord('MPXPlay Settings','StatLine');
    StartLine := ReadWord('MPXPlay Settings','Startline');
    InfoLine := ReadWord('MPXPlay Settings','InfoLine');
    VolLine := ReadWord('MPXPlay Settings','VolLine');
    PauseLine := ReadWord('MPXPlay Settings','PauseLine');

    DelayFactor := ReadWord('TSR Settings','DelayFactor');
    RefreshDelay := ReadWord('TSR Settings','RefreshDelay');
    ScrollDelay := readword('TSR Settings','ScrollDelay');
    ScrollPause := readword('TSR Settings','ScrollPause');

    {$IFDEF serkey}
    if (ReadBoolean('Serial Keypad','Enabled')) then
      begin
        SerialOn;
        KeySetBaud(ReadWord('Serial Keypad','BaudRate'));
        KeySetBits(ReadWord('Serial Keypad','Stopbits'));
        KeySetPort(ReadWord('Serial Keypad','Comport'));
        KeySetBuffer(ReadWord('Serial Keypad','BufferLength'));
        codefile := ReadString('Serial Keypad','Codefile');
      end;
    {$ENDIF}
    keyLineToggle := readword('Keyboard Settings','ChangeLineValue');
    keyScrollToggle := readword('Keyboard Settings','ScrollingValue');
    keyLineup := readword('Keyboard Settings','LineUpValue');
    keyLinedown := readword('Keyboard Settings','LineDownValue');
    keyboardenabled := readboolean('Keyboard Settings','KeyboardEnabled');
    keyPlayView := readword('Keyboard Settings','PlayViewToggle');
    DrawLogo := readboolean('TSR Settings','DisplayLogo');

    ShowNumLock := readboolean('LCD Output','ShowNumLock');

    for code := 1 to 4 do
      for data := 1 to 4 do begin
        LCDLineSet[code].Data[data].LineString :=
          readstring('Line'+strr(code),'Line'+chr(64+data)+'Value');
        LCDLineSet[code].Data[data].LineTime :=
          readword('Line'+strr(code),'Line'+chr(64+data)+'Time');
        LCDLineSet[code].Data[data].LineScroll :=
          readboolean('Line'+strr(code),'Line'+chr(64+data)+'Scroll');
      end;
    for code := 1 to 4 do begin
      for data := 1 to 4 do begin
        for h := 1 to length(LCDLineSet[code].Data[data].LineString) do
          LCDLineSet[code].Data[data].LineString[h] := upcase(LCDLineSet[code].Data[data].LineString[h]);
        if LCDLineSet[code].Data[data].LineTime <> 0 then begin
          LCDLineSet[code].Values := data;
          LCDLineSet[code].Data[data].LineTime := LCDLineSet[code].Data[data].LineTime div DelayFactor;
        end;
      end;
      if LCDLineSet[code].Values = 0 then LCDLineSet[code].Values := 1;

    end;

    closeconfig;

    ReadLCDSettings;
    LCDLen := width;
    LCDLines := lines;
  end;

FUNCTION GetCharC( X,Y :WORD; VAR Attrib:BYTE ) :CHAR;
VAR
   Ofs :WORD;
BEGIN
                        { NOTE: Change the Segment from $B800 }                        {       to $B000 for MonoChrome.      }
  Ofs := ((Y-1) * 160) + ((X SHL 1) - 1);
  Attrib := MEM[$B800:Ofs];
  GetCharC := CHR( MEM[$B800:Ofs-1] );
END;

Function ReadCharThingy(x, y : Word) : Word; Assembler;
  Asm
   dec   x
   dec   y

   mov   ax,y
   mov   cl,5
   shl   ax,cl
   mov   si,ax
   mov   cl,2
   shl   ax,cl
   add   si,ax
   shl   x,1
   add   si,x
   mov   ax,0b800h
   push  ds
   mov   ds,ax
   lodsw
   pop   ds
 End;

FUNCTION GetChar( X,Y :WORD) :CHAR;
var b:byte;
  begin
    getchar := getcharc(x,y,b);
{    getchar := chr(readcharthingy(x,y));}
  end;

function GetAllStats:string;
var start:integer;
  begin
    b := '';
    for i := 1 to 80 do b := b + getchar(i,InfoLine);
    if (length(b) > 0) then
      while(b[length(b)] = #32) do b:=copy(b,1,length(b)-1);
    GetAllStats := b;
  end;

function filename:string;
  var
    a:byte;
    i:integer;
   begin
     b:='';
     for i := 68 to 80 do b:=b+(getchar(i,StatLine));
     while (b[1] = chr(32)) and (length(b) >1) do b:=copy(b,2,(length(b)-1));
     filename := b;
   end;

function mp3bar:string;
  var
    i:integer;
    begin
      b:='';
      for i := bounds[cpubound].theend+1 to bounds[cpubound].theend + 16 do
      begin
        if getchar(i,statline) = '#' then b := b + chr(255) else b := b + ' ';
      end;
      mp3bar := b;
    end;

function GrabCenter(l:byte):string;
  var
    i:integer;
    ab:string;
    begin
      ab:='';
      for i := 1 to 8 do ab := ab + getchar(32+i,l);
      GrabCenter := ab;
    end;

function volume:string;
    begin
      volume:=GrabCenter(volline);
    end;

function MP3Time:string;
  var
    i:integer;
    begin
      b:='';
      for i := bounds[TimeBound].start+1 to bounds[TimeBound].theend-1 do b:= b + getchar(i,StatLine);
      a:=pos('}',b);
      if a>0 then b := copy(b,1,a-1);
      while(b[1] = #32) do b:=copy(b,2,length(b));
      mp3time := b;
      b:='';
    end;

function PlayList:string;
  var
    i:integer;
    begin
      b:='';
      for i:= 1 to 11 do b:=b + getchar(bounds[PlayListBound].start+i,StatLine);
      a:=pos('}',b);
      if a>0 then b := copy(b,1,a-1);
      while(b[1] = #32) do b:=copy(b,1,length(b));
      PlayList := b;
    end;

function CurrentSong:string;
 begin
   b:=playlist;
   currentsong := copy(b,1,pos('/',b)-1);
 end;

function PreLoad:boolean;
var b:boolean;
    a:byte;
  begin
    b:=false;
    b:= (getchar(1,InfoLine) = 'P');
    b:=b and (getchar(2,InfoLine) = 'r');
    b:=b and (getchar(3,InfoLine) = 'e');
    b:=b and (getchar(4,InfoLine) = 'l');
    PreLoad := b;
  end;

procedure DoNumLock;
var test:boolean;
  begin
    if ShowNumLock then begin
      if numlockon <> numlockstatus then
        begin
          numlockstatus := numlockon;
          LCDCursor(LCDLines,LcdLen);
          if numlockstatus then LCDPrint(chr(165)) else LCDPrint(' ');
        end;
    end;
  end;

function changefactor:string;
    begin { This is to make sure that we don't think a song title is Preload }
      dec(TimetoRefresh);
      if (TimetoRefresh = 0) and (ItsOn) then
      begin
        TimetoRefresh := RefreshDelay;
        DoNumLock;
        if PreLoad then changefactor := '=' else changefactor:={playlist+}filename;
      end else changefactor := playfile;
    end;

function TimeVol:string;
  var
    b: string;
    begin
      b:= mp3time;
      b := copy(b,1,pos('/',b)-1);
      b := ' ' + b + ' '+volume;
      timevol := b;
    end;

function TimePlaylist:string;
  begin
    b:=mp3time;
    b:=copy(b,1,pos('/',b)-1);
    b:=  b + ' ' + playlist;
    timeplaylist := b;
    b:='';
  end;

function eqbars(ln:byte):string;
  var
      h:char;
      bar:byte;
      start:byte;
      numinc:word;
      count:byte;
  begin
    b:='';
    start := 3;
    if ln > 28 then ln := 28;

    numinc := 28 div ln; { 32 bars }
    count := 1;
    while (count < 28) do
    begin
      bar:=start;
      h:='.';
      while ((bar-start) <= 18) and (h<>chr(186)) do
        begin
          h:=getchar(count,bar);
          if h<>chr(186) then inc(bar,2);
        end;
      bar := bar - start;
      bar := bar div 2;
      if (bar>0) then dec(bar);
      if (bar >= 8) then b:=b+' ' else
        b:=b+chr(bar);
      inc(count,numinc);
    end;
    eqbars := b;
  end;

function ceqbars(s,e,ln:byte):string;
  var
      h:char;
      bar:byte;
      start:byte;
      numinc:word;
      count:byte;
  begin
    b:='';
    start := s;
    if ln > 28 then ln := 28;

    numinc := 28 div ln; { 32 bars }
    count := 1;
    while (count < 28) do
    begin
      bar:=start;
      h:='.';
      while ((bar-start) <= e) and (h<>chr(186)) do
        begin
          h:=getchar(count,bar);
          if h<>chr(186) then inc(bar,1);
        end;
      bar := bar - start;
      if e = 4 then bar := (2*bar) else
      if e = 6 then begin
        if bar >= e then bar := bar + 1; end
        else bar := bar;
      if (bar >= 8) then b:=b+' ' else
        b:=b+chr(bar);
      inc(count,numinc);
    end;
    ceqbars := b;
  end;

function split4eq(l:byte):string;
  begin
    case l of
      1: split4eq := ceqbars(1,4,lcdlen);
      2: split4eq := ceqbars(6,4,lcdlen);
      3: split4eq := ceqbars(11,4,lcdlen);
      4: split4eq := ceqbars(16,4,lcdlen);
    end;
  end;

function split3eq(l:byte):string;
  begin
    case l of
      1: split3eq := ceqbars(1,6,lcdlen);
      2: split3eq := ceqbars(7,6,lcdlen);
      3: split3eq := ceqbars(14,6,lcdlen);
    end;
  end;

function split2eq(l:byte):string;
  begin
    case l of
      1: split2eq := ceqbars(4,8,lcdlen);
      2: split2eq := ceqbars(12,8,lcdlen);
    end;
  end;

function SingleTime:string;
  begin
    b:=mp3time;
    b:=copy(b,1,pos('/',b)-1);
    Singletime := b;
    b:='';
  end;

function center(ab:string):string;
var c:string;
 begin
   c := ab;
{   if (length(c) > LCDLEN) then c := copy(c,1,lcdlen);}
   while (length(c) < LCDLEN) do
     if (length(c) mod 2) = 0 then c := ' ' + c else c := c + ' ';
   center := c;
 end;

function centerchop(ab:string):string;
var c:string;
 begin
   c := ab;
   if (length(c) > LCDLEN) then c := copy(c,1,lcdlen);
   while (length(c) < LCDLEN) do
     if (length(c) mod 2) = 0 then c := ' ' + c else c := c + ' ';
   centerchop := c;
 end;

function grabrange(l, x1:byte):string;
  var
    g:string[90];
    a:byte;
    c:char;
  begin
    g:='';
    a := x1;
    c := ' ';
    while (a<=80) and (c <> '') do
    begin
      c := getchar(a,l);
      inc(a);
      if (c<> '') then begin
        if (length(g) > 0) and (g[length(g)] = ' ') then
        begin
          if (c<>' ') then g := g + c;
        end
        else g := g + c;
      end;
    end;
    if (l>=50) or (l=BracketLine) then grabrange := ' ' else
    grabrange := g;
  end;

function getblueline:byte;
var
 l:byte;
 at:byte;
 begin
    l := BracketLine;
    at := 0;
    while (l<50) and (at<=15) do
    begin
      inc(l);
      c := getcharc(20,l,at);
    end;
    getblueline := l;
 end;

function getmp3dir:string;
var
 l:byte;
 start:boolean;
 at:byte;
 b,f:string;
 begin
    l := StartLine+1;
    at := 5;
    start:=false;
    while (at<=80) do
    begin
      inc(at);
      c := getchar(at,l);
      if start then b := b + c;
      if (c='\') and (not start) then
      begin
        start := true;
        b := '';
      end else
      if (c='\') and (start) then begin
        f := copy(b,1,length(b)-1);
        b := '';
      end;
    end;
    getmp3dir := f;
 end;

function BrowseLine:string;
var
  at:byte;
  found:boolean;
  l:byte;
  begin
    at := 1;
    found := false;
    l:=getblueline;
    while (at<50) and (not found) do
    begin
      inc(at);
      if getchar(at,l) = '' then found := true;
    end;
    if not found then at := 2 else inc(at);

    BrowseLine := grabrange(l,at);
  end;

function LeadingZero(w : Word) : String;
var
  s : String;
begin
  Str(w:0,s);
  if Length(s) = 1 then
    s := '0' + s;
  LeadingZero := s;
end;

FUNCTION BCD2Bin (BCD:BYTE):BYTE; BEGIN { xlate BCD to binary... }
    BCD2Bin := (BCD AND $0F) + ((BCD SHR 4) * 10);
  END {BCD2Bin};
FUNCTION Bin2BCD (Bin:BYTE):BYTE; BEGIN { xlate binary to BCD... }
    Bin2BCD := (Bin MOD 10) OR BYTE((Bin DIV 10) SHL 4);
  END {Bin2BCD};


FUNCTION RTCbusy:BOOLEAN; BEGIN { RTC time/date being updated?... }
    Port[$70] := $A;;  RTCbusy := (Port[$71] AND 128) = 128;
  END {RTCbusy};

FUNCTION ReadReg (Reg:Treg):BYTE; BEGIN { read an RTC register... }
    IF Reg IN [0..9] THEN REPEAT {wait} UNTIL NOT RTCbusy;
    Port[$70] := Reg;;  ReadReg := Port[$71];
  END {ReadReg};

PROCEDURE GetTime (VAR Hr,Min,Sec:BYTE);
  VAR temp:BYTE; BEGIN
    Sec := ReadReg(0);;  Min := ReadReg(2);
    Hr := ReadReg(4);;  temp := Hr;;  Hr := Hr AND NOT $80;
    IF (ReadReg($B) AND 4) <> 4 THEN BEGIN { xlate BCD to bin... }
      Sec := BCD2Bin(Sec);; Min := BCD2Bin(Min);; Hr := BCD2Bin(Hr);
    END{IF};
    IF (ReadReg($B) AND 2) <> 2 THEN  { RTC in 12-hr mode?... }
      IF (temp AND 128) = 128  { P.M.? }
        THEN BEGIN IF (Hr < 12) THEN INC(Hr,12); END
        ELSE IF Hr = 12 THEN Hr := 0;
  END {GetTime};

PROCEDURE WriteReg (Reg:Treg; Data:BYTE); { write RTC reg... }
  VAR temp:BYTE; BEGIN
    IF Reg IN [0..9] THEN BEGIN { time/date reg? }
      REPEAT {wait} UNTIL NOT RTCbusy;
      Port[$70] := $B;; temp := Port[$71];; Port[$71] := temp OR $80;
    END{IF};
    Port[$70] := Reg;;  Port[$71] := Data;
    IF Reg IN [0..9] THEN BEGIN
      Port[$70] := $B;;  Port[$71] := temp AND NOT $80;
    END{IF};
  END {WriteReg};

PROCEDURE SetTime (Hr:To23; Min,Sec:To59);
  VAR temp:BYTE; BEGIN
    temp := BYTE(Hr);
    IF (ReadReg($B) AND 2) <> 2 THEN  { RTC in 12-hr mode?... }
      IF (Hr > 12) THEN DEC(Hr,12) ELSE IF Hr = 0 THEN Hr := 12;
    IF (ReadReg($B) AND 4) <> 4 THEN BEGIN { RTC wants BCD format... }
      Hr := Bin2BCD(Hr);; Min := Bin2BCD(Min);; Sec := Bin2BCD(Sec);
    END{IF};
    IF ((ReadReg($B) AND 2)<>2) AND (temp > 11) THEN Hr := Hr OR $80;
    WriteReg(0,Sec);; WriteReg(2,Min);; WriteReg(4,Hr);
  END {SetTime};

PROCEDURE GetDate (VAR Yr,Mth,Day:BYTE); BEGIN
    Day := ReadReg(7);;  Mth := ReadReg(8);;  Yr := ReadReg(9);
    IF (ReadReg($B) AND 4) <> 4 THEN BEGIN { xlate BCD to binay... }
      Day := BCD2Bin(Day);; Mth := BCD2Bin(Mth);; Yr := BCD2Bin(Yr);
    END; {IF}
  END {GetDate};

function TFTime:string;
var
  h, m, s, hund : byte;
  add:string;
begin
  GetTime(h,m,s);
  TFTime := LeadingZero(h)+':'+LeadingZero(m)+':'+LeadingZero(s);

end;

function CurrentTime:string;
var
  h, m, s, hund : byte;
  add:string;
begin
  GetTime(h,m,s);
  add := 'am';
  if h > 12 then begin
    h := h - 12;
    add := 'pm';
  end;
  CurrentTime := strr(h)+':'+LeadingZero(m)+':'+LeadingZero(s)+add;

end;
function CurrentDate:string;
var
  y, m, d, dow : byte;
begin
  GetDate(y,m,d);
  CurrentDate := strr(m)+'/'+strr(d)+'/'+LeadingZero(y);
end;


function CurrentEDate:string;
var
  y, m, d, dow : byte;
begin
  GetDate(y,m,d);
  CurrentEDate := strr(d)+'/'+strr(m)+'/'+strr(y);
end;

function GetMP3Info(inst:string):string;
var
  s:string;
  h:byte;
  begin
    s:='';
    changes := false;
    if inst='M3U' then s:=playlist else
    if inst='MSU' then s:=currentsong else
    if inst='FNM' then s:=filename else
    if inst='IAL' then s:=AllStats else
    if inst='DIR' then s:=getmp3dir else
    if inst='ADA' then s:=CurrentDate else
    if inst='EDA' then s:=CurrentEDate else
    if inst[1]='I' then
    begin
      val((inst[2]+inst[3]),h,i);
      if (h > 0) and (attributes >= h) then s:=attrinfo[h].name else s:=filename;
    end else
    if inst[1]='Z' then
    begin
      val((inst[2]+inst[3]),h,i);
      if (h > 0) then s:=GrabCenter(h);
    end else
    begin
      changes := true;
      if inst='FTM' then s:=mp3time else
      if inst='STM' then s:=singletime else
      if inst='VLM' then s:=volume else
      if inst='MDB' then s:=MP3bar else
      if inst='TIM' then s:=CurrentTime else
      if inst='T24' then s:=TFTime else

      if inst='BRW' then s:=BrowseLine else
      if (inst[1]='E') and (inst[2]='Q') then
        begin
           val(inst[3],h,i);
           s:=split2eq(h);
        end;
      if (inst[1]='E') then
       begin
         case inst[2] of
           '4':begin
                 val(inst[3],h,i);
                 s:=split4eq(h);
               end;
           '3':begin
                 val(inst[3],h,i);
                 s:=split3eq(h);
               end;
           else
             begin
               val((inst[2]+inst[3]),h,i);
               if (h>0) then s:=eqbars(h);
             end;
         end;
       end;
     end;
    GetMP3Info := s;
  end;

function MP3Info(b:byte):string;
  var
    s:string;
   begin
     changes := true;
     case b of
       2: s:=center(TimeVol);
       3: s:=center(TimePlayList);
       4: s:=MP3bar;
       5: s:=center(volume);
       6: s:=center(mp3time);
       7: begin changes := false; s:=center(filename); end;
       8: s:=center(AllStats);
       1: begin
            if Attributes > 1 then s:=attrinfo[1].name + ' - '+attrinfo[2].name
              else s:= attrinfo[1].name;
            if (length(s) > lcdlen) then changes := true else changes := false;
            s:=center(s);
          end;
       else begin
         b := b -8;
         s:=center(attrinfo[b].name);
       end;
     end;
{     while (s[length(s)]=#32) do s:=copy(s,1,length(s)-1);
     while (length(s) < LCDLen) do s := s + ' ';}
     mp3info := s;
 end;

function GetLineInfo(l:byte):string;
  var
    build:string;
    code,i:integer;
    aline:string;
    bchange:boolean;
  begin
    bchange := false;
    build:=''; { Init }
    b:=''; { Init Instruction }
    if LCDLineSet[l].Data[LCDLineSet[l].current].LineValue > 0 then
      begin
        build :=MP3Info(LCDLineSet[l].Data[LCDLineSet[l].current].LineValue);
        bchange := {changes;} FALSE;
      end else
    begin
      aline := LCDLineSet[l].Data[LCDLineSet[l].current].LineString;
      while (length(aline) > 0) do
        begin
          a:=pos('%',aline);
          if (a>0) then
            begin
              build := build + copy(aline,1,a-1); { Get whatever is before %in }
              b := copy(aline,a+1,3); { Get instruction (not %)}
              aline := copy(aline,a+4,length(aline)); { Update aline }
              build := build + GetMP3Info(b);
              bchange := bchange or changes;
              b := '';
            end
          else begin
            build := build + aline;
            aline := '';
          end;
        end;
        build := center(build);
    end;
    changes := bchange;
    GetLineInfo := build;
  end;



procedure TurnOff;
  var
    l:integer;
  begin
    itson:=false;
    PlayFile:='Nothing';
    lcdclear;
{    LCDCleanUp;}
    for l := 1 to Attributes do attrinfo[l].name := ' ';

    Attributes := 0;
{    writeln(Attributes);
    for l := 1 to Attributes do writeln(length(attrinfo[l].name),attrinfo[l].name);}
  end;

procedure FindBounds;
  var start:byte;
      cbound:byte;
      c:char;

  begin
    start := 1;
    cbound := 1;
    Attributes := 0;
    while (cbound < 5) and (start<80) do begin
      if (getchar(start,StatLine) = '{') then bounds[cbound].start := start;
      if (getchar(start,Statline) = '}') then begin
        bounds[cbound].theend := start;
        inc(cbound);
      end;
      inc(start);
    end;

    start := 1;

    b:='';
    while (start < 80) do begin
      c:= (getcharc(start,InfoLine,a));
      if (a = 15{white}) or (c=#32) then begin
        if (length(b)=0) then inc(Attributes);
        if (length(b) < 30) then b := b + c;
      end else begin
        if (length(b) > 0) then begin
          attrinfo[attributes].name := b;
          b:='';
        end;
      end;
      inc(start);
    end;
    if (length(b) > 0) then begin
      while(b[length(b)] = #32) do b:=copy(b,1,length(b)-1);
      attrinfo[attributes].name := b;
    end;
    for cbound := 1 to attributes do
      while attrinfo[cbound].name[length(attrinfo[cbound].name)] = ' ' do
        attrinfo[cbound].name := copy(attrinfo[cbound].name,1,length(attrinfo[cbound].name)-1);
    b:='';
    AllStats := GetAllStats;

  end;



function playerpaused:boolean;
 var
   b:boolean;
   c:char;

   begin
     if pausecheck then
     if itson then begin
       c:=getchar(33,pauseline);
       if c='v' then b:=false else b:=true;
{       if b then begin
          LCDPrintAt(1,'  -  Player  -  ');
          LCDPrintAt(2,'   - Paused -   ');
       end;}
     end else b := false else b:=false;
     playerpaused := b;
   end;



procedure ResetLCDInfo;
 var a:byte;
     code,i:integer;
  begin
    BrowseString := '';
    for a := 1 to LCDLines do begin
      scrolling[a].on := true;
      scrolling[a].p := 1;
      scrolling[a].pause := ScrollPause;
      scrolling[a].dir := 2;
      scrolling[a].delay := 0;

      displayit[a] := true;

      for i := 1 to LCDLineSet[a].Values do
      begin
        val(LCDLineSet[a].Data[i].LineString,LCDLineSet[a].Data[i].LineValue,code);
      end;
      LCDLineSet[a].Current := 1;
      LCDLineSet[a].Scrolling := LCDLineSet[a].Data[1].LineScroll;
      LCDLineSet[a].DelayTime := LCDLineSet[a].Data[1].LineTime;
      Scrolling[a].on := LCDLineSet[a].Scrolling;

   end;
      numlockstatus := not numlockon; { Force to update }
      lcdtoscreen := false;
      if crcfail then
       begin
         a:=random(100)+1;
         if a>55 then inc(delayfactor);
       end;
       lcdclear;

{      lcdready; { Make sure Serial LCD is ready }
  end;



{ Is MPX Player Loaded ? }

function MPXLoaded:Boolean;
var ret:boolean;
    a:byte;
    i:integer;
  begin
    b := '';
    for i:=1 to 3 do b:=b+(getchar(32+i,1));
    if b = 'MPX' then ret := true else ret := false;
    ItsOn:=ret;      { Set Player Loaded to On }
    MPXLoaded := ret;
  end;

function PlayerIsOn:Boolean;
var ret:boolean;
    a:byte;
    i:integer;
    b:string;
  begin

    if (getchar(1,StatLine) = '{') then ret := true
      { Set Player to On }
    else ret := false;
{    Itson:=ret;}
    PlayerIsOn := ret;
  end;

function ValidSong:boolean;
  var ret:boolean;
  begin
    if (PlayFile ='Nothing') or (Playfile = 'No file') then ValidSong:=false else ValidSong := true;
  end;

function MPXPlaying:boolean;
  var ret:boolean;
  begin
    if (ValidSong) or (not playerpaused) then ret := true else ret:=false;
    MPXPlaying:= false;
  end;


procedure ProcessLine(l:byte;var s:string);
  begin
    if (Scrolling[l].on) and (length(s) > LCDLen) then
    begin
      if (scrolling[l].delay >= scrolldelay) then scrolling[l].delay := 0;
      if (scrolling[l].delay = 0) then begin
        case scrolling[l].dir of
          1: begin
               inc(scrolling[l].p);
               if (Scrolling[l].p > length(s)-lcdlen+1) then
               begin
                 if Scrolling[l].pause = 0 then Scrolling[l].pause := ScrollPause;
                 if Scrolling[l].pause = 1 then
                 begin
                   Scrolling[l].dir := 2;            { go back! }
                   dec(Scrolling[l].p);
                   Scrolling[l].pause := 0;
                 end else
                 begin
                   dec(Scrolling[l].pause);
                   dec(scrolling[l].p);
                 end;
               end;
             end;
        2: begin
             dec(scrolling[l].p);
             if (Scrolling[l].p = 0) then
               begin
                 if Scrolling[l].pause = 0 then Scrolling[l].pause := (ScrollPause div 2)+1;
                 if Scrolling[l].pause = 1 then
                 begin
                   Scrolling[l].dir := 1;            { go back! }
                   inc(Scrolling[l].p);
                   Scrolling[l].pause := 0;
                 end else
                 begin
                   dec(Scrolling[l].pause);
                   inc(scrolling[l].p);
                 end;
               end;
           end;
         end;
         inc(scrolling[l].delay);
      end else inc(scrolling[l].delay);
      s:=copy(s,scrolling[l].p,scrolling[l].p+lcdlen);
    end; { Scrolling }
  end;

procedure DoBrowse;
var l:byte;
    found :boolean;
    at,atl:byte;
    gs:string;


    procedure showit(la:byte; v:string);
      begin
        processline(la,v);
        if length(v)+2 > lcdlen then
        begin
          v := '>' + v;
          v[lcdlen] := '<';
        end else v := '>' + v + '<';
        lcdprintat(la,center(v));
      end;

  begin
    gs := '';
    l := getblueline;
    at := 1;
    found := false;
    while (at<50) and (not found) do
    begin
      inc(at);
      if getchar(at,l) = '' then found := true;
    end;
    if not found then at := 2 else inc(at);
    begin
      gs := grabrange(l,at);
      if gs <> BrowseString then
      begin
        resetlcdinfo;
        for atl := 1 to lcdlines do scrolling[atl].on := true;
        lcdclear;
        BrowseString := gs;
        if length(gs)+2 > lcdlen then
        begin
          gs := '>' + gs;
          gs[lcdlen] := '<';
        end else gs := '>' + gs + '<';
        case l of
          48: begin
                if LCDLines = 4 then
                begin
                  LCDPrintAt(1,centerchop(grabrange(l-2,at)));
                  LCDPrintAt(2,centerchop(grabrange(l-1,at)));
                  LCDPrintAt(3,centerchop(gs));
                  LCDPrintAt(4,centerchop(grabrange(l+1,at)));
                end else
                begin
                  LCDPrintAt(1,centerchop(gs));
                  LCDPrintAt(2,centerchop(grabrange(l+1,at)));
                end;
              end;
          49: begin
                if LCDLines = 4 then
                begin
                  LCDPrintAt(1,centerchop(grabrange(l-3,at)));
                  LCDPrintAt(2,centerchop(grabrange(l-2,at)));
                  LCDPrintAt(3,centerchop(grabrange(l-1,at)));
                  LCDPrintAt(4,centerchop(gs));
                end else
                begin
                  LCDPrintAt(1,centerchop(grabrange(l-1,at)));
                  LCDPrintAt(2,centerchop(gs));
                end;
              end
          else
              begin
                if LCDLines=4 then
                begin
                  LCDPrintAt(1,center(grabrange(l-1,at)));
                  LCDPrintAt(2,center(gs));
                  LCDPrintAt(3,center(grabrange(l+1,at)));
                  LCDPrintAt(4,center(grabrange(l+2,at)));
                end else
                begin
                  LCDPrintAt(1,center(gs));
                  LCDPrintAt(2,center(grabrange(l+1,at)));
                end;
             end;
          end; { Case }
      end else
      begin { Scroll it }
        case l of
          48: if LCDLines=4 then showit(3,gs) else showit(1,gs);
          49: if LCDLines=4 then showit(4,gs) else showit(2,gs);
         else if LCDLines=4 then showit(2,gs) else showit(1,gs);
       end;
      end;
    end;
  end;



procedure CheckLCDChange(l:byte);
  begin
    if LCDLineSet[l].Values > 1 then
    begin
      if (LCDLineSet[l].DelayTime = 0) then
        begin
          inc(LCDLineSet[l].Current);
          if LCDLineSet[l].Current > LCDLineSet[l].Values then
            LCDLineSet[l].Current := 1;
          LCDLineSet[l].DelayTime := LCDLineSet[l].Data[LCDLineSet[l].current].LineTime;
          LCDLineSet[l].Scrolling := LCDLineSet[l].Data[LCDLineSet[l].Current].LineScroll;
          displayit[l] := TRUE;
          Scrolling[l].p := 1;
          Scrolling[l].dir := 2;
          scrolling[l].pause := ScrollPause;
          scrolling[l].delay := 0;
        end else
        dec(LCDLineSet[l].DelayTime);
    end;
  end;

  procedure display_unreg;
  var k:word;
            begin
              for k:=1 to 4 do displayit[k] := true;
              numlockstatus := not numlockon; { Force to update }
              if LCDLines = 2 then begin
                LCDPrintAt(1,center('MPXF Software'));
                LCDPrintAt(2,center('Unregistered!'));
              end else if LCDLines > 2 then
                begin
                  LCDPrintAt(1, center(' '));
                  LCDPrintAt(2, center('MPXF Software'));
                  LCDPrintAt(3, center('Unregistered!'));
                  LCDPrintAt(4, center(' '));
                end else LCDPrintAt(1,center('MPXF Software Unregistered!'));
            end;

Procedure Get_Time;Interrupt;
Var
    l:integer;
    s:string;
Begin
  if (not Printing) { Not in the interrupt } then
  begin
    Printing := true;
    Inc(Count);
    If (Count = DelayFactor) Then                       
    begin
      if PlayerIsOn and (not Paused) and (not ViewFiles) then
      begin
        ItsOn:=true;
        if Attributes > 0 then { Make sure a song is there }
        begin
          if (not registered) then begin
            s:='2'; { FREE Version
            s:=singletime;
            s:=copy(s,length(s),1); }
          end;
          if (registered) or (not registered and ((s<>'1'))) then
          begin
            for l := 1 to LCDLines do if (not Paused) then
            begin
              CheckLCDChange(l);
              s:=getlineinfo(l);
       {       if changes and (displayit[l] = TRUE) then}
              begin
                if (not Scrolling[l].on) then s := copy(s,1,LCDLEN) else
                  ProcessLine(l,s);
                if (l = LCDlines) and (ShowNumLock) then LCDPrintAt(l,copy(s,1,lcdlen-1))
                 else LCDPrintAt(l,s);
              end{ else
              if not changes and (displayit[l] = TRUE) then
              begin
                if (l = LCDlines) and (ShowNumLock) then LCDPrintAt(l,copy(s,1,lcdlen-1))
                 else LCDPrintAt(l,s);
                displayit[l] := false;
              end};

            end;
          end else { Cycle through lines }
            display_unreg;
        end; { Attributes > 0 }
        s:=changefactor;
        findbounds;
        if (s <> playfile) then begin
          playfile := s;
          findbounds;
          resetlcdinfo;
        end;
      end else { Player is On/ Not Paused }
      begin
        if ViewFiles then begin
          if numlockon <> numlockstatus then
            numlockstatus := numlockon;
          DoBrowse;
        end else
        begin
          if itson and (not paused) then TurnOff;
          playfile := 'Nothing';
          if MPXLoaded then DoBrowse;
        end;
      end;
      Paused := PlayerPaused;
      count := 0;
    end; {Delay Factor }
      Printing := false;
  end; { Delay Factor }

  Inline($9C);                             { Pushf - Push Flags           }
  Old1Cint;                                { Link Old 1C Procedure        }
End;

{$F+}
Procedure LCDOptions; Interrupt;
var mykey :boolean;
begin
  mykey := false;
  if (not InKeyRoutine) and ItsOn and ( not numlockstatus) then begin
    InKeyRoutine := true;
    w:=port[$60];
    if w <> 0 then
      if w = keyLineDown then
        begin
          mykey := true;
          dec(LCDSelected);
          if LCDSelected = 0 then LCDSelected := 1;
        end else
      if w = keyLineUp then
        begin
          mykey := true;
          inc(LCDSelected);
          if LCDSelected > LCDLines then LCDSelected := LCDLines;
       end else
     if w = keyScrollToggle then
      begin
        mykey := true;
        scrolling[lcdselected].on := not scrolling[lcdselected].on;
        Scrolling[lcdselected].p := 1;
        Scrolling[lcdselected].dir := 2;
        scrolling[lcdselected].pause := ScrollPause;
        scrolling[lcdselected].delay := 0;
      end else
     if w = keyPlayView then
       begin
         mykey := true;
         ViewFiles := not ViewFiles
       end else
     if w = keyLineToggle then
       begin
         mykey := true;
         inc(lcdlineSet[lcdselected].Data[lcdlineset[lcdselected].current].LineValue);
         if (lcdlineSet[lcdselected].Data[lcdlineset[lcdselected].current].LineValue > (8+Attributes)) then
    val(LCDLineSet[lcdselected].Data[lcdlineset[lcdselected].current].LineString,
      LCDLineSet[lcdselected].Data[lcdlineset[lcdselected].current].LineValue,w);
     {  lcdlineSet[lcdselected].Data[lcdlineset[lcdselected].current].LineValue := 0;}
         scrolling[lcdselected].p := 1;
       end;
{     83: begin {ExitPlayer := true; numlock(true); end;}
    InKeyRoutine := false;
  end;
{  if (not mykey) then
    begin}
      Inline($9C);                             { Pushf - Push Flags            }
      Orgint9;                                { Link Old 1C Procedure         }
{    end;}
end;
{$F-}


procedure doit;
Begin
  numlockstatus := not numlockon; { Force to update }
  randomize;
  ExitPlayer:=false;
  Printing:=false;
  keyboardenabled := false;
  PlayFile:='Nothing';
  LCDSelected := 1;
  RefreshDelay:=1; TimetoRefresh:=1;
  ViewFiles:=false;
  itson:=false;
  Count:=0;                    { Clock Pulses Counter                }
{  if chkintegrity then crcfail:=false else crcfail:=true;
  clrscr;}
  writeln('MPXF TSR for MPXPlay LCD output');
  writeln('Version '+version+'. ('+vdate+') Written by Scott Bradshaw.');
  writeln;
  write('Loading config...');
  DoConfig;
  writeln('Done!');             { $1C}
  registered := true;
  initlcd;                       { Of Main Program                     }
  eq_bars;
{  LCDCursorOff;
{  lcdclear;}
  lcdtoscreen := true;
{$IFDEF serkey}
  if UsingSerial then
  begin
    if fileexists(codefile) then
      begin
        writeln('Loading Serialport keypad config...');
        writeln('   (delete this file if you wish to assign new keys)');
        KeyLoadConfig(codefile);
        KeyStart;
      end
      else
      begin
        KeyStart;
        writeln('Setting up new keys for serial port keypad..');
        writeln('Press Enter..');
        readln;
        KeyAddKeys;
        writeln('Saving config for next use.');
        KeySaveConfig(codefile);
      end;
  end;
  {$ENDIF}
  LCDtoScreen := false;
  ViewFiles := false;
  Getintvec($1C ,@Old1Cint);
  Setintvec($1C ,@Get_Time);

  if keyboardenabled then begin
    GetIntVec(9, @OrgInt9);
    SetIntVec(9, Addr(LCDOptions));
    writeln('Keyboard enabled!');
  end;
  LCDClear;
  if (registered and DrawLogo) or (not registered) then TSRLogo;

  writeln('MPXF TSR Loaded.');
{  setintvec($1C,@Old1Cint);
  setintvec(9,@OrgInt9);}
End;

procedure shutoff;
begin
  setintvec($1C,@Old1Cint);
  if keyboardenabled then setintvec(9,@OrgInt9);
end;


begin
end.