unit mpxfvars;
{
  MPXF Vars and Common Procedures
}
interface
CONST
  MaxSongs    = 15000;
  MaxSearch   = 300;
  MaxMem      = 200;
  SongSize    = 200;
  DatabaseEmpty = 'No Name';
type
  search_rec = record
    songnum : word;
    tag: byte;
    value:byte;
  end;
  song = array[1..SongSize] of char;
  songname=string[SongSize];
  sresults=array[1..MaxSearch] of search_rec;
  genretype= record
    name : string[40];
    data : string[20];
    tag  : boolean;
  end;
  genres=array[1..35] of ^genretype;
var

  playoptiondata:string;
  playdata:string;

  irmpxffn,irmpxplayfn:string[12];
  IRPort:byte;
  UseIR,UseX10:boolean;
  CmdString:string[100];
  debug:boolean;
  crcfail:boolean;
  DrawLogo:boolean;
  CDRomDefault:byte;
  DefaultDatabase:string[30];
  startlogo:array[1..4] of string[40];
  startdelay:word;
  HelpBoxes:boolean;
  lcdchardelay,lcdcontroldelay:byte;
  lcdport:word;
  GenreSupport:boolean;
{  data:array[1..MaxMem] of string[SongSize];}
  mp3dir,mp3prog,mp3list:string;
  Hdl     : Word;          { Handle for Extended memory allocated }
  memblocks:integer;
  numhdl   : integer;
  HiMemOK : boolean;
  xmscount:longint;

    genretypes:word;
  lcdlen:byte;
  lcdlines:byte;
  PlayListDir:string;
  Databasedir:string;
  genre:genres;
  numplayoptions:byte;
  playoptions:genres;
  Scrolling:boolean;
  phone:array[0..9] of string[5];

  mpxplaynormal,
  mpxplayloop,
  mpxplaylistnormal,
  mpxplaylistrandom:string;
  stars:string;

{ Other Vars }
  starcount:integer;
  loop:boolean;
  ScrollPause:word;
  scrolldelay:word;
  PlayList:sresults;
  SongSearch:sresults;
  SongBuild:sresults;
  SongBuildResults:word;
  totalsongs:word;
  SearchBar:word;
  SearchBarLine:byte;
  NetworkUtil:string[100];
  Search:byte;
  numresults:word;
  screencleardelay:word;

  TagChar,
  LeftChar,
  RightChar,
  UpChar,
  DownChar,
  EnterChar,
  ScrollToggleChar,
  LoopToggleChar,
  LCDHelpChar,
  TagAllChar,
  JumpChar,
  Up10Char,Down10Char,
  ExitChar:byte;
  mpxfnumone,
  mpxfnumtwo,
  mpxfnumthree,
  mpxfnumfour,
  mpxfnumfive,
  mpxfnumsix,
  mpxfnumseven,
  mpxfnumeight,
  mpxfnumnine,
  mpxfnumzero : char;
  NumLockPlay:boolean;

  OKStr,YesStr,NoStr:string[10];
  ArtistStr,
  AlbumStr,
  SongStr,
  SongsStr,
  LoadingStr:string[12];


Procedure NumLock(ONorOFF:Boolean);
function strip(s:string; st:char): string;
procedure clear(var asong:song);
procedure LCDCoolClear;
function strr(b:longint):string;
function GetArtist(sn:string):string;
function GetTitle(sn:string):string;
procedure AddPlayOptions(var ps:string);
function GetAlbum(sn:string):string;
function stripend(s:string):string;
function spaces(l:byte):string;
function UpString(dest:string):string;
procedure dostar(line:byte);
procedure shell(prog:string);
procedure PlaySong(sn:word);
function stripbeg(s:string):string;
function center(ab:string):string;
procedure Help(hmsg:string;var l:byte);
procedure Info(hmsg:string;l:byte);
procedure save_settings;
procedure load_settings;
procedure DefineStars;
procedure LCDOk(l:byte);
function YesNo(l:byte):boolean;
function GetAlpha:string;
function GetKey:char;
function Keypress:boolean;
function CmdNext:char;
function CmdEmpty:boolean;
procedure CmdPop;
implementation
uses xms,lcd,keystats,crt,keyintr,dos,config,mpxfmem,mpxfir,mpxfmenu;



procedure LCDCoolClear;
  var i,j,k:word;
      od1,od2:byte;
      l:byte;
      step:byte;
      a:string;
  begin
    if GetLCDType <> 3 then
    begin
        for i:= 0 to 2 do begin
          for l := 1 to lcdlines do
          begin
            lcdcursor(l,1);
            j := 1;
            while (j<lcdlen) do
            begin
              j:=j + 1;
              a := chr(i);
              lcdprint(a);
              for k := 1 to ScreenClearDelay do ;
            end;
          end;
        end;
        for i:= 2 downto 0 do begin
          for l := 1 to lcdlines do
          begin
            lcdcursor(l,1);
            j := 1;
            while (j<lcdlen) do
            begin
              j:=j + 1;
              a := chr(i);
              lcdprint(a);
              for k := 1 to ScreenClearDelay do;

            end;
          end;
        end;
      end;
     lcdclear;
    lcdcursoroff;
 end;

function CmdEmpty:boolean;
  begin
    if CmdString = '' then CmdEmpty := true else CmdEmpty := false;
  end;

procedure CmdPop;
  begin
    if (not CmdEmpty) then
    begin
      cmdString := copy(cmdstring,3,length(cmdstring));
    end;
  end;

function CmdNext:char;
  begin
    if (not CmdEmpty) then CmdNext := CmdString[1] else CmdNext := #0;
  end;

function Keypress:boolean;
 begin
   if Keypressed then keypress:=true else keypress:=false;
 end;

function GetKey:char;
  begin
    getkey := readkey;
  end;

function YesNo(l:byte):boolean;
  var
    yn:boolean;
    c:char;
    begin
      yn:=true;
      if (not cmdempty) then c:= upcase(cmdnext);
      if (c='Y') or (c='N') then
      begin
        cmdpop;
        if c='N' then yn := false;
      end else
      begin
        LCDPrintAt(l,center('['+YesStr+'] / '+NoStr));
        repeat
          if keypress then
          begin
            c:=getkey;
            if (c<>chr(EnterChar)) then begin
              yn:=not yn;
              if yn then LCDPrintAt(l,center('['+YesStr+'] / '+NoStr)) else
                LCDPrintAt(l,center(YesStr+'/ ['+NoStr+']'));
            end;
          end;
        until c=chr(EnterChar);
      end;
      YesNo := yn;
    end;

procedure LCDOk(l:byte);
  var
    yn:boolean;
    c:char;
    begin
      yn:=true;
      LCDPrintAt(l,center('['+OKStr+']'));
      repeat
        c:=readkey
      until c=chr(EnterChar);
    end;

function spaces(l:byte):string;
  var b:string;
      a:byte;
  begin
    b:='';
    for a := 1 to l do b:=b+' ';
    spaces := b;
  end;

procedure Help(hmsg:string;var l:byte);
  var
    c:char;
    po:integer;
    begin
      if (not cmdempty) then c:= upcase(cmdnext);
      if (c='#') then
      begin
        cmdpop;
      end else
      begin
        lcdclear;
        delay(50);
        if HelpBoxes then
        begin
          for po := 1 to LCDLEN do hmsg := ' ' + hmsg;
          LCDPrintAt(l,center('['+OKStr+']'));
          c:=' ';
          repeat
            LCDPrintAt(1,copy(hmsg,1,lcdlen));
            hmsg := copy(hmsg,2,length(hmsg)-1)+hmsg[1];
            if keypress then c:=getkey;
            delay(ScrollDelay*2);
          until c=chr(EnterChar);
        end;
      end;
    end;

procedure Info(hmsg:string;l:byte);
  var
    c:char;
    po:integer;
    begin
      if (not cmdempty) then c:= upcase(cmdnext);
      if (c='#') then
      begin
        cmdpop;
      end else
      begin
        lcdclear;
        delay(50);
          for po := 1 to LCDLEN do hmsg := ' ' + hmsg;
          LCDPrintAt(l,center('['+OKStr+']'));
          c:=' ';
          repeat
            LCDPrintAt(1,copy(hmsg,1,lcdlen));
            hmsg := copy(hmsg,2,length(hmsg)-1)+hmsg[1];
            if keypress then c:=getkey;
            delay(ScrollDelay*2);
          until c=chr(EnterChar);
        end;
      end;

procedure DefineStars;
  begin
  delay(50);
  initlcd;
  delay(50);
  lcddefinechar(0, 0,0,0,4,0,0,0,0);
  lcddefinechar(1,  0,0,4,14,4,0,0,0);
  lcddefinechar(2, 0 ,4,14, $1f, 14, 4, 0,0);
  lcddefinechar(3, 4, 4, 14,$1f, 14, 4, 4, 0);
  lcddefinechar(5,  4, 4, 14, $1f, $1f, 14, 4, 4);
  lcddefinechar(4,  0, 4, 14, $1f, $1f, 14, 4, 0);
  lcddefinechar(6, 4, 21, 14, $1f, $1f, 14, 21, 4);
  lcddefinechar(7, 21, 21, 14, $1f, $1f, 14, 21, 21);
  delay(50);
  lcdclear;
end;

procedure eq_bars;
begin
  delay(50);
  initlcd;
  delay(50);

  lcddefinechar(7,  0,0,0,0,0,0,0,31);
  lcddefinechar(6, 0,0,0,0,0,0,31,31);
  lcddefinechar(5, 0,0,0,0,0,31,31,31);
  lcddefinechar(4, 0,0,0,0,31,31,31,31);
  lcddefinechar(3, 0,0,0,31,31,31,31,31);
  lcddefinechar(2, 0,0,31,31,31,31,31,31);
  lcddefinechar(1, 0,31,31,31,31,31,31,31);
  lcddefinechar(0, 31,31,31,31,31,31,31,31);
  delay(20);
  lcdclear;

end;


function Addkey(ins:string):byte;
var a:byte;
    code:integer;
  begin
    if ins[1] = '#' then
      begin
        ins:=copy(ins,2,length(ins));
        val(ins,a,code);
      end
      else a:=ord(ins[1]);
   AddKey := a;
  end;

procedure save_settings;
var setfile:text;
    i:integer;
  begin
    assign(setfile,'mpxf.ini');
{$I-}    rewrite(setfile); {$I+}
    If IOResult = 0 then
    begin
      writeln(setfile,version);
      writeln(setfile,DefaultDatabase);
      if HelpBoxes then writeln(setfile,'1') else writeln(setfile,'0');
      if GenreSupport then writeln(setfile,'1') else writeln(setfile,'0');
      for i := 1 to GenreTypes do
        if genre[i]^.tag then writeln(setfile,'1') else writeln(setfile,'0');
      for i := 1 to numplayoptions do
        if PlayOptions[i]^.tag then writeln(setfile,'1') else writeln(setfile,'0');

      if loop then writeln(setfile, '1') else writeln(setfile,'0');

      close(setfile);
    end else writeln('error writing mpxf.ini file.');
  end;

procedure load_settings;
 var setfile:text;
     input:string;
     i:integer;
     a:string;
     cv:string;
     yn:boolean;
     b:byte;
  begin

  CmdString := ReadString('Startup','StartupCommand');
  StartLogo[1] := ReadString('Startup','StartLine1');
  StartLogo[2] := ReadString('Startup','StartLine2');
  StartLogo[3] := ReadString('Startup','StartLine3');
  StartLogo[4] := ReadString('Startup','StartLine4');
  StartDelay := ReadWord('Startup','StartDelay');
  Stars := ReadString('FrontEnd Settings','SearchStars');
  SearchBar := ReadWord('FrontEnd Settings','SearchBarCount');
  SearchBarLine := ReadWord('FrontEnd Settings','SearchBarLine');
  ScreenClearDelay := ReadWord('FrontEnd Settings','ScreenClearDelay');
  mp3prog := ReadString('Player Settings','Player');
  mp3list := ReadString('Player Settings','Database');
  mpxplaynormal:=readstring('Player Settings','MPXPlayNormal');
  mpxplayloop:=readstring('Player Settings','MPXPlayLoop');
  mpxplaylistnormal:=readstring('Player Settings','MPXPlaylistNormal');
  mpxplaylistrandom:=readstring('Player Settings','MPXPlaylistRandom');
  PlayListDir := ReadString('Player Settings','PlaylistDir');
  DatabaseDir := ReadString('Player Settings','DatabaseDir');
  NumLockPlay := ReadBoolean('Player Settings','NumLockOff');
  DrawLogo := ReadBoolean('Frontend Settings','DisplayLogo');

  NetworkUtil := readstring('FrontEnd Settings','NetworkUtil');
  ScrollPause := ReadWord('FrontEnd Settings','ScrollPause');
  ScrollDelay := ReadWord('FrontEnd Settings','ScrollDelay');

  UseIR := (ReadBoolean('IR Settings','UseIR'));
  UseX10 := (ReadBoolean('IR Settings','UseX10'));
  IRSetDelay(ReadWord('IR Settings','Delay'));
  if UseIR or UseX10 then
  begin
    IRPort := ReadWord('IR Settings','Comport');
    irmpxffn := ReadString('IR Settings','MPXF');
    irmpxplayfn := ReadString('IR Settings','MPXPlay');
  end;

  LeftChar := ord('4');
  RightChar := ord('6');
  UpChar := ord('8');
  DownChar := ord('2');
  EnterChar := 13;
  ExitChar := ord('-');
  TagChar := ord('+');
  TagAllChar := ord('*');
  LCDHelpChar := ord('/');
  ScrollToggleChar:=ord('5');
  LoopToggleChar := ord('0');
  JumpChar := ord('+');
  Up10Char := ord('3');
  Down10Char := ord('1');
  mpxfnumone := '1';
  mpxfnumtwo := '2';
  mpxfnumthree := '3';
  mpxfnumfour := '4';
  mpxfnumfive := '5';
  mpxfnumsix := '6';
  mpxfnumseven := '7';
  mpxfnumeight := '8';
  mpxfnumnine := '9';
  mpxfnumzero := '0';

  a := ReadString('Keyboard Settings','LeftChar');
  if (a <> '') then LeftChar := AddKey(a);
  a := ReadString('Keyboard Settings','RightChar');
  if a <> '' then RightChar := AddKey(a);
  a:= ReadString('Keyboard Settings','ExitChar');
  if a <> '' then ExitChar := Addkey(a);
  a := ReadString('Keyboard Settings','UpChar');
  if a <> '' then UpChar := Addkey(a);
  a := ReadString('Keyboard Settings','DownChar');
  if a <> '' then DownChar := Addkey(a);
  a := ReadString('Keyboard Settings','EnterChar');
  if a <> '' then EnterChar := Addkey(a);
  a := ReadString('Keyboard Settings','TagChar');
  if (a <> '') then TagChar := AddKey(a);
  a := ReadString('Keyboard Settings','TagAllChar');
  if (a <> '') then TagAllChar := AddKey(a);
  a := ReadString('Keyboard Settings','LCDHelpChar');
  if (a <> '') then LCDHelpChar := AddKey(a);
  a := ReadString('Keyboard Settings','ScrollToggleChar');
  if (a <> '') then ScrollToggleChar := AddKey(a);
  a := ReadString('Keyboard Settings','LoopToggleChar');
  if (a <> '') then LoopToggleChar := AddKey(a);
  a := ReadString('Keyboard Settings','JumpChar');
  if (a <> '') then JumpChar := AddKey(a);
  a := ReadString('Keyboard Settings','Up10Char');
  if (a <> '') then Up10Char := AddKey(a);
  a := ReadString('Keyboard Settings','Down10Char');
  if (a <> '') then Down10Char := AddKey(a);
  a := ReadString('Keyboard Settings','1');
  if (a <> '') then mpxfnumone := a[1];
  a := ReadString('Keyboard Settings','2');
  if (a <> '') then mpxfnumtwo := a[1];
  a := ReadString('Keyboard Settings','3');
  if (a <> '') then mpxfnumthree := a[1];
  a := ReadString('Keyboard Settings','4');
  if (a <> '') then mpxfnumfour := a[1];
  a := ReadString('Keyboard Settings','5');
  if (a <> '') then mpxfnumfive := a[1];
  a := ReadString('Keyboard Settings','6');
  if (a <> '') then mpxfnumsix := a[1];
  a := ReadString('Keyboard Settings','7');
  if (a <> '') then mpxfnumseven := a[1];
  a := ReadString('Keyboard Settings','8');
  if (a <> '') then mpxfnumeight := a[1];
  a := ReadString('Keyboard Settings','9');
  if (a <> '') then mpxfnumnine := a[1];
  a := ReadString('Keyboard Settings','0');
  if (a <> '') then mpxfnumzero := a[1];


  closeconfig;

    assign(setfile,'mpxf.ini');
    {$I-} reset(setfile); {$I+}
    if IOResult <> 0 then save_settings else
      begin
        readln(setfile,cv);
        if cv <> version then
        begin
          readln(setfile,defaultdatabase);
        end else
        begin
          readln(setfile,DefaultDatabase);
          readln(setfile,input);
          if pos('1',input) > 0 then HelpBoxes := true else HelpBoxes := false;
          readln(setfile,input);
          if pos('1',input) > 0 then GenreSupport := true else GenreSupport := false;
          for i := 1 to GenreTypes do begin
            readln(setfile,input);
            if pos('1',input) > 0 then Genre[i]^.tag := true else Genre[i]^.tag := false;
          end;
          for i := 1 to numplayoptions do begin
            readln(setfile,input);
            if pos('1',input) > 0 then PlayOptions[i]^.tag := true else PlayOptions[i]^.tag := false;
          end;
          readln(setfile,input);
          if pos('1',input) > 0 then loop := true else loop := false;
        end;
        close(setfile);
      end;

  YesStr := 'Yes';
  NoStr := 'No';
  OKStr := 'OK';
  ArtistStr := 'Artist';
  AlbumStr := 'Album';
  SongStr := 'Song';
  songsstr:= 'songs';
  LoadingStr := 'Loading';
  if (openconfig('mpxflang.cfg') = true) then
  begin
    a:=ReadString('Other Settings','ChoiceNo');
    if a <> '' then NoStr := a;
    a:=ReadString('Other Settings','ChoiceYes');
    if a <> '' then YesStr := a;
    a:=ReadString('Other Settings','ChoiceOK');
    if a <> '' then OKStr := a;
    a:=ReadString('Other Settings','Loading');
    if a <> '' then LoadingStr := a;
    a:=ReadString('Other Settings','Artist');
    if a <> '' then ArtistStr := a;
    a:=ReadString('Other Settings','Album');
    if a <> '' then AlbumStr := a;
    a:=ReadString('Other Settings','Song');
    if a <> '' then SongStr := a;
    a:=ReadString('Other Settings','Songs');
    if a <> '' then SongsStr := a;
    closeconfig;
  end;


  end;

function center(ab:string):string;
var c:string;
 begin
   c:='';
   c := ab;
   while (length(c) < LCDLEN) do
     if (length(c) mod 2) = 0 then c := ' ' + c else c := c + ' ';
   center := c;
 end;

function stripbeg(s:string):string;
 var dest:string;
     i:integer;

     begin
       i:=1;
       while(s[i] = #32) do inc(i);
       dest := copy(s,i,length(s));
       stripbeg := dest;
     end;

procedure dostar(line:byte);
  begin
    inc(starcount);
    LCDCursor(line,1);
    LCDPrint(stars[starcount]);
    if starcount = length(stars) then starcount := 0;
  end;

function stripend(s:string):string;
  var dest,dest2:string;
      i,c:integer;
  begin
     i:=length(s);

     dest := ''; dest2 := '';
     c:=0;
     while (s[i] = #32) do begin
       inc(c);
       dec(i);
     end;
     dest := copy(s,1,(length(s)-c));
     i:=pos('_',dest);
     while i > 0 do begin
       dest[i] := ' ';
       i := pos('_',dest);
     end;

{     for i := 1 to length(dest) do dest[i] := upcase(dest[i]);}
     stripend := dest;
  end;

function UpString(dest:string):string;
  var i:integer;
  begin
     for i := 1 to length(dest) do dest[i] := upcase(dest[i]);
     UpString := dest;
  end;

function GetArtist(sn:string):string;
 var art:string;
     p:word;
  begin
    art := '';
    art := stripend(sn);
    p := pos('-',art);
    if (p=0) then p := length(art)+1;
    art := copy(art,1,p-1);
    if sn='' then art := '';
    GetArtist := art;
  end;

function GetTitle(sn:string):string;
  var thesong:string;
      p:word;
  begin
    thesong := '';
    thesong := stripend(sn);
    thesong := copy(thesong,pos('-',thesong)+1,length(thesong));
    p := pos('-',thesong);;
    if (p=0) then p := length(thesong)+1;
    thesong := copy(thesong,1,p-1);
    if sn='' then thesong := '';
    GetTitle := thesong;
  end;

function GetAlbum(sn:string):string;
  var thesong:string;
  begin
    thesong := '';
    thesong := stripend(sn);
    thesong := copy(thesong,pos('-',thesong)+1,length(thesong));
    thesong := copy(thesong,pos('-',thesong)+1,length(thesong));
    thesong := copy(thesong,1,pos('-',thesong)-1);
    if sn='' then thesong := '';
    GetAlbum := thesong;
  end;


function strr(b:longint):string;
  var
   S: string[11];
   begin
    Str(b, S);
    strr := S;
   end;




procedure clear(var asong:song);
  var
    cl:integer;
    begin
      for cl := 0 to SongSize-1 do asong[cl] := #0;
    end;



function strip(s:string; st:char): string;

  var
    l:integer;
    b:string;
    begin
      b:='';
      for l := 1 to length(s) do
        if s[l] <> st then b:=b+s[l];
      strip := b;
    end;

  Procedure NumLock(ONorOFF:Boolean);Assembler;
    asm
    cmp ONorOFF,1
    je @BeLight
    jmp @BeDarkness
    @BeLight:
     MOV SI,40h
     MOV ES,SI
     MOV AL,ES:[0017h]
     OR  AL,20h
     MOV ES,SI
     MOV ES:[0017h],AL
     jmp @FINISH
    @BeDarkness:
     MOV SI,40h
     MOV ES,SI
     MOV AL,ES:[0017h]
     AND AL,0DFh
     MOV ES,SI
     MOV ES:[0017h],AL
    @FINISH:
    end;


Function DosShell(command:String):Integer;Var
 OldHeapEnd,
 NewHeapEnd: Word;
 Error:Integer;
Begin
 Error:=0;
 If MemAvail<$1000 then Error:=8;
 If Error=0 then Begin
  NewHeapEnd:=Seg(HeapPtr^)-PrefixSeg;
  OldHeapEnd:=Seg(HeapEnd^)-PrefixSeg;
   asm
    mov ah,4Ah
    mov bx,NewHeapEnd
    mov es,PrefixSeg
    Int 21h
    jnc @EXIT
    mov Error,ax
    @EXIT:
   end; {asm}
  If Error=0 then begin
   lcdtoscreen := false;
   SwapVectors;
   Exec(GetEnv('COMSPEC'),command);
   SwapVectors;
   lcdtoscreen := true;

    asm
     mov ah,4Ah
     mov bx,OldHeapEnd
     mov es,PrefixSeg
     Int 21h
     jnc @EXIT
     mov Error,ax
     @EXIT:
    end; {asm}
  end;   {If}
 end;    {If}
 DosShell:=Error;
end;     {Function}

procedure AddPlayOptions(var ps:string);
var i:byte;
  begin
{    writeln('Adding options: ');}
      for i := 1 to numplayoptions do begin
        if playoptions[i]^.tag then
          begin
            ps := ps + ' ' + playoptions[i]^.data;
{            write(playoptions[i]^.data,' ');}
          end;
      end;
{      writeln;}
      if debug then readln;
    end;

procedure shell(prog:string);
 var emsswap :boolean;
     er:word;
     savedir:string;
     c:char;

  begin
   if prog <> '' then prog := ' /C ' + prog;
       if numlockon and numlockplay then begin
      delay(50);
      Numlock(FALSE);
      storekey(0,ord('a'));
      if keypressed then c:=readkey;
      delay(50);
    end;

   delay(100);
   getdir(0,savedir);

{  Getintvec($1C ,@Old1Cint);
  Setintvec($1C ,@Get_Time);
  doit;

{      lcdcleanup;  Shut off Serial LCD }

      if debug then begin
        writeln('Shelling...');
        writeln(GetEnv('COMSPEC'),' ',prog);
        write('press enter');
        readln;
      end;
{      prog := GetEnv('COMSPEC')+' '+prog;}
      eq_bars;
      IRClearCodes;
      IRLoadConfig(irmpxplayfn);
      er := dosshell(prog);
      IRClearCodes;
      IRLoadConfig(irmpxffn);

      chdir(savedir);
{      readlcdsettings;


      setback;
      lcdready;  {Turn it back ON }
 {      exec(getenv('COMSPEC'),prog);}
{      swapvectors;
      if er <> 0 then{ Error?  begin
        WriteLn('Dos error #', er);  readln; end;}

{   mpxlcdoff;
   swapvectors;}
   lcdtoscreen:=true;
   delay(50);
   initlcd;
   delay(100);
   definestars;
   lcdclear;
   lcdcursoroff;
   delay(100);
   NUMLOCK(true);
  end;

procedure PlaySong(sn:word);
  var s:string;
     c:char;
  begin
    LCDClear;
    if numlockon and numlockplay then begin
      delay(50);
      Numlock(FALSE);
      storekey(0,ord('a'));
      if keypressed then c:=readkey;
      delay(50);
    end;
    PlayData := stripbeg(getsongpath(sn));;
    PlayOptionData := '';
    AddPlayOptions(PlayOptionData);
    if Loop then MenuLoop('Play Single Loop') else
      MenuLoop('Play Single');

{    if Loop then s := mp3prog + ' ' + mpxplayloop + ' ' else
      s:= mp3prog + ' ' + mpxplaynormal + ' ';
    AddPlayOptions(s);
    s := s + ' ' + stripbeg(getsongpath(sn));
    shell(s);}
  end;

function GetAlpha:string;
var alpha :string;
    curpos:integer;
    left:integer;
    ch:char;
    build:string;

procedure UpdateLCD;
  var lcdpos:integer;
  begin
    if ((curpos > (lcdlen-2)) and (curpos <= ((lcdlen-2)*2))) then left := (lcdlen-1) else
    if (curpos > ((lcdlen-2)*2)) then left := ((lcdlen-2)*2)+1 else left := 1;
    lcdpos := curpos-left+1;
    lcdprintat(1,' '+copy(alpha,left,lcdlen-2)+' ');
    lcdcursor(1,lcdpos);
    lcdprint(chr(255));
    lcdcursor(1,lcdpos+2);
    lcdprint(chr(255));
    lcdprintat(2,'->'+build+' ');
    lcdcursor(2,length(build)+3);
  end;

begin
  LCDCursorOn;
  alpha := '*-ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789        ';
  LCDClear;
  build := '';
  left := 1;
  curpos := 3;
  updateLCD;
  repeat

    if keypress then begin
      ch:=getkey;
      if ch = chr(RightChar) then inc(curpos);
      if ch = chr(LeftChar) then dec(curpos);
      if (curpos > 38) then curpos:= 1;
      if (curpos < 1) then curpos := 38;

      if ((ch=chr(EnterChar)) and (curpos = 2)) or (ch=chr(ExitChar)) then build := copy(build,1,length(build)-1) else
      if (ch=chr(EnterChar)) and (curpos <> 1) then build := build + alpha[curpos];
      updateLCD;
    end;
    drawmpxflogo;
  until (curpos = 1) and (ch=chr(EnterChar));
  GetAlpha := build;
  lcdcursoroff;
  delay(10);
  end;

begin
end.