unit VFDlcd;
{
  Futaba VFD unit for MPXF Software
  Written on 3/6/00

}
interface

procedure VFDClear;
procedure VFDInitLCD;
procedure VFDCursorOff;
procedure VFDCursorOn;
procedure VFDToggle;
procedure VFDHome;
procedure VFDCursor(l,x,lcdlen:byte);
procedure VFDSetPort(p:word);
procedure SetRSPin(p:byte);
procedure SetRWPin(p:byte);
procedure SetEnablePin(p:byte);
procedure VFDPushIns(b:byte);
procedure VFDPushChar(charc:byte);
procedure VFDReadSettings(section:string);
procedure VFDDefineChar(cn,d1,d2,d3,d4,d5,d6,d7,d8:byte);
function VFDchardelay:byte;
function VFDcontroldelay:byte;

implementation
uses newdelay,crt,config;
type
 PinStatus = byte;
 PinData = array[0..17] of PinStatus;

 const
    PinDataOn:Pindata = (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0);
   PinDataOff:pindata = (0,1,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8);

var
  RS_Pin:byte;
  Enable_Pin:byte;
  RW_Pin:byte;
  PushCharCommand1,PushCharCommand2:byte;
  PushInsCommand1,pushinscommand2:byte;
    controldelay:word;
    chardelay:word;
    portaddress:word;
    data:word;
    status:word;
    control:word;

    LineOffsets:array[1..4] of byte;

procedure VFDSetPort(p:word); begin portaddress:=p; end;
function VFDchardelay:byte; begin VFDchardelay := chardelay; end;
function VFDcontroldelay:byte; begin VFDcontroldelay := controldelay; end;


procedure SetRSPin(p:byte);
  begin    RS_Pin := p;  end;

procedure SetRWpin(p:byte);
  begin    RW_Pin := p;  end;

procedure SetEnablePin(p:byte);
  begin   Enable_pin:=p; end;


procedure delaychar;
  var k:word;
  begin
    for k := 1 to chardelay do;
  end;

procedure delaycmd;
  var k:word;
  begin
    for k := 1 to controldelay do;
  end;

procedure VFDPushIns(b:byte);
 var pc1,pc2:byte;
  begin

    port[DATA] := b;
  {  port[control] := (0 or 1) xor 11;
    delaycmd;
    port[control] := (0 and 254) xor 11;
   }
      port[control] := PushInsCommand1;
      delaycmd;
      port[control] := PushInsCommand2;
{    if Fourbit then delaycmd;}
  end;


procedure VFDPushChar(charc:byte);
var pc1,pc2:byte;
   k:word;
  begin
{    if (charc < 9) then charc := 32;}
    port[data] := charc;
{      port[control] := (4 or 1) xor 11;}

      port[control] := PushCharcommand1;
      delaychar;
{      port[control] := (1 and 254) xor 11;}
      port[control] := Pushcharcommand2;
{  writeln((4 or 1) xor 11,'  ',pushcharcommand1);
  writeln((1 and 254) xor 11,'  ',pushcharcommand2);}


  end;

procedure VFDDefineChar(cn,d1,d2,d3,d4,d5,d6,d7,d8:byte);
  var
   k:boolean;
  begin
    VFDpushins($40+(cn shl 3));
    VFDpushchar(d1); VFDpushchar(d2); VFDpushchar(d3);
    VFDpushchar(d4); VFDpushchar(d5); VFDpushchar(d6);
    VFDpushchar(d7); VFDpushchar(d8);
    delaychar;
  end;

 procedure VFDCursorOn;
   begin
     VFDPushIns(19);
   end;

 procedure VFDCursorOff;
   begin
     VFDPushIns(20);
   end;

procedure VFDClear;
  begin
    VFDPushIns(31);
    VFDPushIns(17);
 {   delaychar;}
    VFDCursorOff;
{    delay(2);
    VFDPushIns(2);
    delay(2);}
  end;

procedure VFDToggle; begin VFDPushIns(8); end;

procedure VFDHome;
  begin
    VFDPushIns(2);
  end;

procedure VFDCursor(l,x,lcdlen:byte);
  begin
    vfdpushins(17);
    vfdpushins(16);
    vfdpushins(lcdlen*(l-1)+(x-1));
  end;

procedure VFDReadSettings(section:string);
var VFDport:word;
begin
    CharDelay := ReadWord(section,'CharDelay');
    ControlDelay := ReadWord(section,'ControlDelay');
    VFDPort := ReadWord(section,'LPTPort');
    if VFDPort <> 0 then VFDSetPort(VFDPort);
    DATA := PORTADDRESS+0;
    STATUS := PORTADDRESS+1;
    CONTROL := PORTADDRESS+2;

    SetRSPin(ReadWord(section,'RS_Pin'));
    SetRWPin(ReadWord(section,'RW_Pin'));
    SetEnablePin(ReadWord(section,'Enable_Pin'));

    PushCharCommand1 := PinDataOn[RS_Pin] + PinDataOff[RW_Pin] + PinDataOn[Enable_Pin];
    PushCharCommand2 := PinDataOff[RS_Pin] + PinDataOff[RW_Pin] + PinDataOff[Enable_Pin];
    PushInsCommand1 := PinDataOff[RS_Pin] + PinDataOn[Enable_Pin] + PinDataOff[RW_Pin];
    PushInsCommand2 := PinDataOff[RS_Pin] + PinDataOff[Enable_Pin] + PinDataOff[RW_Pin];
end;

procedure VFDInitLCD;
  begin
    VFDPushIns(63);
    VFDPushIns(63);
    VFDPushIns(63);
     VFDPushIns(8);
    VFDPushIns(31);
    VFDPushIns(6);
    VFDPushIns(20);
    VFDPushIns(2);
    VFDPushIns(17);
    delay(1);
    delay(50);
 end;

begin

end.
