unit MPXFlcd;
{$G+,R-,S-,M 16192,10000,20000 }
interface
procedure doit;
procedure SetBack;
procedure SetupTSR;

implementation
{ MPXF TSR
 16192,10000,20000 worked
}
Uses lcd,Dos ,Crt,config,keystats;

const

  version = '0.96b';
  vdate = '10/21/99 1am';

type
  bound_rec= record
     start,theend:byte;
  end;
  attr_rec= record
     name:string;
  end;

  scroll_rec = record
    on:boolean;
    p:integer;
    dir:integer;
    pause:integer;
    delay:integer;
  end;

  line_rec = record
    LineScroll:boolean;
    LineValue:byte;
    LineString:string;
    LineTime:word;
  end;

  line_type = record
    Values:byte;
    scrolling:boolean;
    current:byte;
    DelayTime:word;
    data:array[1..4] of line_rec;
  end;
Var

    PlayListBound, FileseekBound,  TimeBound,  CPUBound,  ArtistBound,
    SongBound: byte;
    Paused:boolean;
    StatLine,  StartLine,    InfoLine,   VolLine,   PauseLine,BracketLine,
    DelayFactor,    LCDLines,    LCDLen : byte;
{    lcdcontroldelay,lcdchardelay:byte;
    lcdport:word;}
    RefreshDelay,TimetoRefresh:word;
    scrolldelay,scrollpause:byte;
    ShowNumLock:boolean;
    AllStats:string;
    c:char;
    i,j,k:integer;

    PlayFile:string;
    bounds:array[1..10] of bound_rec;
    attrinfo:array[1..5] of attr_rec;
    Attributes:byte;
    b:string;
    a:byte;


    keyScrollToggle,keyLineUp,keyLineDown,keyLineToggle:byte;


   FirstLoad:boolean;





    Count:Byte;                       { Counts Seconds                }
    Time:Longint  Absolute $40:$6C;   { Bios Keeps Clock Time Here    }
    Orgint9:Procedure;
    Old1Cint:Procedure;               { Linkage To Old 1C Interrupt   }
    itson:boolean;
{    LCDLineSelected:array[1..4] of byte;}
    LCDLineSet:array[1..4] of line_type;
{    LCDInfo:array[1..4] of string;}
    LCDSelected:byte;
    Scrolling:array[1..4] of scroll_rec;
    ExitPlayer:boolean;
    KeyboardEnabled :boolean;
    NumLockStatus:boolean;


procedure eq_bars;
begin
  lcddefinechar(7,  0,0,0,0,0,0,0,31);
  lcddefinechar(6, 0,0,0,0,0,0,31,31);
  lcddefinechar(5, 0,0,0,0,0,31,31,31);
  lcddefinechar(4, 0,0,0,0,31,31,31,31);
  lcddefinechar(3, 0,0,0,31,31,31,31,31);
  lcddefinechar(2, 0,0,31,31,31,31,31,31);
  lcddefinechar(1, 0,31,31,31,31,31,31,31);
  lcddefinechar(0, 31,31,31,31,31,31,31,31);
end;

procedure TSRLogo;
 var c,i,j,k,a,d:integer;
 begin
   if lcdlines = 2 then d := 4 else d:=2;
   for a:= 1 to 20 do
    for i := 1 to lcdlines do begin
      LCDCursor(i,1);
      for j := 1 to lcdlen do
        begin
          k:=random(7);
          LCDPrint(chr(k));
          delay(d);
        end;
    end;
    c:= lcdlen div 2;
    c:=c-3;
    LCDCursor(1,c);
    LCDPrint('MPXF TSR');
    LCDCursor(2,c);
    LCDPrint(' v'+version+' ');
    for a := 1 to 35 do
      for i := 1 to lcdlines do begin
        LCDCursor(i,1);
        for j:=1 to c-1 do begin
          k:=random(7);
          LCDPrint(chr(k));
          delay(d*2+1);
        end;
        LCDCursor(i,c+8);
        for j:=c+8 to lcdlen do begin
          k:=random(7);
          LCDPrint(chr(k));
          delay(d*2+1);
        end;
        if a= 20 then begin
          LCDCursor(2,c);
          LCDPrint(' Loaded ');
        end;
      end;
      for a := 0 to 8 do
      for i := 1 to lcdlines do begin
        LCDCursor(i,1);
        for j:=1 to c-1 do begin
          if a = 8 then k := ord('*') else k:=a;
          LCDPrint(chr(k));
          delay(d*2+1);
        end;
        LCDCursor(i,c+8);
        for j:=c+8 to lcdlen do begin
          if a = 8 then k := ord('*') else k:=a;
          LCDPrint(chr(k));
          delay(d*2+1);
        end;
     end;


 end;

procedure DoConfig;
var code,data:integer;
  begin
    if not (openconfig('mpxftsr.cfg')) then begin
      writeln('MPXFTSR.CFG not found!');
      halt(1);
    end;

    PlaylistBound := ReadWord('MPXPlay Settings','Playlistbound');
    FileseekBound := ReadWord('MPXPlay Settings','Fileseekbound');
    TimeBound := ReadWord('MPXPlay Settings','TimeBound');
    CPUBound := ReadWord('MPXPlay Settings','CPUBound');
    ArtistBound := ReadWord('MPXPlay Settings','ArtistBound');
    SongBound := ReadWord('MPXPlay Settings','SongBound');
    BracketLine := ReadWord('MPXPlay Settings','BracketLine');
    StatLine := ReadWord('MPXPlay Settings','StatLine');
    StartLine := ReadWord('MPXPlay Settings','Startline');
    InfoLine := ReadWord('MPXPlay Settings','InfoLine');
    VolLine := ReadWord('MPXPlay Settings','VolLine');
    PauseLine := ReadWord('MPXPlay Settings','PauseLine');

    DelayFactor := ReadWord('TSR Settings','DelayFactor');
    RefreshDelay := ReadWord('TSR Settings','RefreshDelay');
    ScrollDelay := readword('TSR Settings','ScrollDelay');
    ScrollPause := readword('TSR Settings','ScrollPause');

    keyLineToggle := readword('Keyboard Settings','ChangeLineValue');
    keyScrollToggle := readword('Keyboard Settings','ScrollingValue');
    keyLineup := readword('Keyboard Settings','LineUpValue');
    keyLinedown := readword('Keyboard Settings','LineDownValue');
    keyboardenabled := readboolean('Keyboard Settings','KeyboardEnabled');

    {LCDLines := ReadWord('LCD Settings','lcdlines');
    LCDLen := ReadWord('LCD Settings','lcdlength');
    LCDSetLines(LCDLines);
    LCDSetLength(LCDLen);
    LCDSetType(ReadWord('LCD Settings','LCDType'));
    LCDCharDelay := ReadWord('LCD Settings','CharDelay');
    LCDControlDelay := ReadWord('LCD Settings','ControlDelay');
    LCDPort := ReadWord('LCD Settings','LPTPort');
    if LCDPort <> 0 then LCDSetPort(LCDPort);
    LCDSetCharDelay(lcdchardelay);
    LCDSetControlDelay(lcdcontroldelay);}
    ShowNumLock := readboolean('LCD Output','ShowNumLock');

    LCDLineSet[1].Data[1].LineString := readstring('Line1','LineAValue');
    LCDLineSet[1].Data[1].LineTime := readword('Line1','LineATime');
    LCDLineSet[1].Data[1].LineScroll := readboolean('Line1','LineAScroll');

    LCDLineSet[1].Data[2].LineString := readstring('Line1','LineBValue');
    LCDLineSet[1].Data[2].LineTime := readword('Line1','LineBTime');
    LCDLineSet[1].Data[2].LineScroll := readboolean('Line1','LineBScroll');

    LCDLineSet[1].Data[3].LineString := readstring('Line1','LineCValue');
    LCDLineSet[1].Data[3].LineTime := readword('Line1','LineCTime');
    LCDLineSet[1].Data[3].LineScroll := readboolean('Line1','LineCScroll');

    LCDLineSet[1].Data[4].LineString := readstring('Line1','LineDValue');
    LCDLineSet[1].Data[4].LineTime := readword('Line1','LineDTime');
    LCDLineSet[1].Data[4].LineScroll := readboolean('Line1','LineDScroll');

    LCDLineSet[2].Data[1].LineString := readstring('Line2','LineAValue');
    LCDLineSet[2].Data[2].LineString := readstring('Line2','LineBValue');
    LCDLineSet[2].Data[1].LineTime := readword('Line2','LineATime');
    LCDLineSet[2].Data[2].LineTime := readword('Line2','LineBTime');
    LCDLineSet[2].Data[1].LineScroll := readboolean('Line2','LineAScroll');
    LCDLineSet[2].Data[2].LineScroll := readboolean('Line2','LineBScroll');
    LCDLineSet[2].Data[3].LineString := readstring('Line2','LineCValue');
    LCDLineSet[2].Data[4].LineString := readstring('Line2','LineDValue');
    LCDLineSet[2].Data[3].LineTime := readword('Line2','LineCTime');
    LCDLineSet[2].Data[4].LineTime := readword('Line2','LineDTime');
    LCDLineSet[2].Data[3].LineScroll := readboolean('Line2','LineCScroll');
    LCDLineSet[2].Data[4].LineScroll := readboolean('Line2','LineDScroll');

    LCDLineSet[3].Data[1].LineString := readstring('Line3','LineAValue');
    LCDLineSet[3].Data[2].LineString := readstring('Line3','LineBValue');
    LCDLineSet[3].Data[1].LineTime := readword('Line3','LineATime');
    LCDLineSet[3].Data[2].LineTime := readword('Line3','LineBTime');
    LCDLineSet[3].Data[1].LineScroll := readboolean('Line3','LineAScroll');
    LCDLineSet[3].Data[2].LineScroll := readboolean('Line3','LineBScroll');
    LCDLineSet[3].Data[3].LineString := readstring('Line3','LineCValue');
    LCDLineSet[3].Data[4].LineString := readstring('Line3','LineDValue');
    LCDLineSet[3].Data[3].LineTime := readword('Line3','LineCTime');
    LCDLineSet[3].Data[4].LineTime := readword('Line3','LineDTime');
    LCDLineSet[3].Data[3].LineScroll := readboolean('Line3','LineCScroll');
    LCDLineSet[3].Data[4].LineScroll := readboolean('Line3','LineDScroll');

    LCDLineSet[4].Data[1].LineString := readstring('Line4','LineAValue');
    LCDLineSet[4].Data[2].LineString := readstring('Line4','LineBValue');
    LCDLineSet[4].Data[1].LineTime := readword('Line4','LineATime');
    LCDLineSet[4].Data[2].LineTime := readword('Line4','LineBTime');
    LCDLineSet[4].Data[1].LineScroll := readboolean('Line4','LineAScroll');
    LCDLineSet[4].Data[2].LineScroll := readboolean('Line4','LineBScroll');
    LCDLineSet[4].Data[3].LineString := readstring('Line4','LineCValue');
    LCDLineSet[4].Data[4].LineString := readstring('Line4','LineDValue');
    LCDLineSet[4].Data[3].LineTime := readword('Line4','LineCTime');
    LCDLineSet[4].Data[4].LineTime := readword('Line4','LineDTime');
    LCDLineSet[4].Data[3].LineScroll := readboolean('Line4','LineCScroll');
    LCDLineSet[4].Data[4].LineScroll := readboolean('Line4','LineDScroll');

    for code := 1 to 4 do begin
      for data := 1 to 4 do
        if LCDLineSet[code].Data[data].LineTime <> 0 then LCDLineSet[code].Values := data;
      if LCDLineSet[code].Values = 0 then LCDLineSet[code].Values := 1;

    end;

    closeconfig;

    LCDLen := width;
    LCDLines := lines;
    writeln(lcdlines,lcdlen);


  end;

FUNCTION GetCharC( X,Y :WORD; VAR Attrib:BYTE ) :CHAR;
VAR
   Ofs :WORD;
BEGIN
                        { NOTE: Change the Segment from $B800 }                        {       to $B000 for MonoChrome.      }
  Ofs := ((Y-1) * 160) + ((X SHL 1) - 1);
  Attrib := MEM[$B800:Ofs];
  GetCharC := CHR( MEM[$B800:Ofs-1] );
END;

Function ReadCharThingy(x, y : Word) : Word; Assembler;
  Asm
   dec   x
   dec   y

   mov   ax,y
   mov   cl,5
   shl   ax,cl
   mov   si,ax
   mov   cl,2
   shl   ax,cl
   add   si,ax
   shl   x,1
   add   si,x
   mov   ax,0b800h
   push  ds
   mov   ds,ax
   lodsw
   pop   ds
 End;

FUNCTION GetChar( X,Y :WORD) :CHAR;
  begin
    getchar := chr(readcharthingy(x,y));
  end;

function GetAllStats:string;
var start:integer;
  begin
    b := '';
    for i := 1 to 80 do b := b + getchar(i,InfoLine);
    if (length(b) > 0) then
      while(b[length(b)] = #32) do b:=copy(b,1,length(b)-1);
    GetAllStats := b;
  end;

function filename:string;
  var
    a:byte;
    i:integer;
   begin
     b:='';
     for i := 68 to 80 do b:=b+(getchar(i,StatLine));
     while (b[1] = chr(32)) and (length(b) >1) do b:=copy(b,2,(length(b)-1));
     filename := b;
   end;

function mp3bar:string;
  var
    i:integer;
    begin
      b:='';
      for i := bounds[cpubound].theend+1 to bounds[cpubound].theend + 16 do
      begin
        if getchar(i,statline) = '#' then b := b + chr(255) else b := b + ' ';
      end;
      mp3bar := b;
    end;

function GrabCenter(l:byte):string;
  var
    i:integer;
    ab:string;
    begin
      ab:='';
      for i := 1 to 8 do ab := ab + getchar(32+i,l);
      GrabCenter := ab;
    end;

function volume:string;
    begin
      volume:=GrabCenter(volline);
    end;

function MP3Time:string;
  var
    i:integer;
    begin
      b:='';
      for i := 2 to 10 do b:= b + getchar(bounds[TimeBound].start+i,StatLine);
      a:=pos('}',b);
      if a>0 then b := copy(b,1,a-1);
      while(b[1] = #32) do b:=copy(b,2,length(b));
      mp3time := b;
      b:='';
    end;

function PlayList:string;
  var
    i:integer;
    begin
      b:='';
      for i:= 1 to 11 do b:=b + getchar(bounds[PlayListBound].start+i,StatLine);
      a:=pos('}',b);
      if a>0 then b := copy(b,1,a-1);
      while(b[1] = #32) do b:=copy(b,1,length(b));
      PlayList := b;
    end;

function CurrentSong:string;
 begin
   b:=playlist;
   currentsong := copy(b,1,pos('/',b)-1);
 end;

function PreLoad:boolean;
var b:boolean;
    a:byte;
  begin
    b:=false;
    b:= (getchar(1,InfoLine) = 'P');
    b:=b and (getchar(2,InfoLine) = 'r');
    b:=b and (getchar(3,InfoLine) = 'e');
    b:=b and (getchar(4,InfoLine) = 'l');
    PreLoad := b;
  end;

procedure DoNumLock;
var test:boolean;
  begin
    if ShowNumLock then begin
      if numlockon <> numlockstatus then
        begin
          numlockstatus := numlockon;
          LCDCursor(2,LcdLen);
          if numlockstatus then LCDPrint(chr(165)) else LCDPrint(' ');
        end;
    end;
  end;

function changefactor:string;
    begin { This is to make sure that we don't think a song title is Preload }
      dec(TimetoRefresh);
      if (TimetoRefresh = 0) and (ItsOn) then
      begin
        TimetoRefresh := RefreshDelay;
        DoNumLock;
        if PreLoad then changefactor := '=' else changefactor:=playlist{+filename};
      end else changefactor := playfile;
    end;

function TimeVol:string;
  var
    b: string;
    begin
      b:= mp3time;
      b := copy(b,1,pos('/',b)-1);
      b := ' ' + b + ' '+volume;
      timevol := b;
    end;

function TimePlaylist:string;
  begin
    b:=mp3time;
    b:=copy(b,1,pos('/',b)-1);
    b:=  b + ' ' + playlist;
    timeplaylist := b;
    b:='';
  end;

function eqbars(ln:byte):string;
  var
      h:char;
      bar:byte;
      start:byte;
      numinc:word;
      count:byte;
  begin
    b:='';
    start := 3;

    numinc := 28 div ln; { 32 bars }
    count := 1;
    while (count < 28) do
    begin
      bar:=start;
      h:='.';
      while ((bar-start) <= 18) and (h<>chr(186)) do
        begin
          h:=getchar(count,bar);
          if h<>chr(186) then inc(bar,2);
        end;
      bar := bar - start;
      bar := bar div 2;
      if (bar>0) then dec(bar);
      if (bar >= 8) then b:=b+' ' else
        b:=b+chr(bar);
      inc(count,numinc);
    end;
    eqbars := b;
  end;
function SingleTime:string;
  begin
    b:=mp3time;
    b:=copy(b,1,pos('/',b)-1);
    Singletime := b;
    b:='';
  end;

function center(ab:string):string;
var c:string;
 begin
   c := ab;
   while (length(c) < LCDLEN) do
     if (length(c) mod 2) = 0 then c := ' ' + c else c := c + ' ';
   center := c;
 end;

function GetMP3Info(inst:string):string;
var
  s:string;
  h:byte;
  begin
    s:='';
    for h := 1 to length(inst) do inst[h] := upcase(inst[h]);
    if inst='FNM' then s:=filename else
    if inst='FTM' then s:=mp3time else
    if inst='STM' then s:=singletime else
    if inst='IAL' then s:=AllStats else
    if inst='VLM' then s:=volume else
    if inst='MDB' then s:=MP3bar else
    if inst='M3U' then s:=playlist else
    if inst='MSU' then s:=currentsong else
    if inst[1]='E' then
    begin
      val((inst[2]+inst[3]),h,i);
      if (h>0) then s:=eqbars(h);
    end else
    if inst[1]='I' then
    begin
      val((inst[2]+inst[3]),h,i);
      if (h > 0) and (attributes >= h) then s:=attrinfo[h].name else s:=filename;
    end else
    if inst[1]='Z' then
    begin
      val((inst[2]+inst[3]),h,i);
      if (h > 0) then s:=GrabCenter(h);
    end;
    GetMP3Info := s;
  end;

function MP3Info(b:byte):string;
  var
    s:string;
   begin
     case b of
       2: s:=center(TimeVol);
       3: s:=center(TimePlayList);
       4: s:=MP3bar;
       5: s:=center(volume);
       6: s:=center(mp3time);
       7: s:=filename;
       8: s:=AllStats;
       1: begin
            if Attributes > 1 then s:=attrinfo[1].name + ' - '+attrinfo[2].name
              else s:= attrinfo[1].name;
          end;
       else begin
         b := b -8;
         s:=attrinfo[b].name;
       end;
     end;
     while (s[length(s)]=#32) do s:=copy(s,1,length(s)-1);
     while (length(s) < LCDLen) do s := s + ' ';
     mp3info := s;
 end;

function GetLineInfo(l:byte):string;
  var
    build:string;
    code,i:integer;
    aline:string;
  begin
    build:=''; { Init }
    b:=''; { Init Instruction }
    if LCDLineSet[l].Data[LCDLineSet[l].current].LineValue > 0 then
      build :=MP3Info(LCDLineSet[l].Data[LCDLineSet[l].current].LineValue) else
    begin
      aline := LCDLineSet[l].Data[LCDLineSet[l].current].LineString;
      while (length(aline) > 0) do
        begin
          a:=pos('%',aline);
          if (a>0) then
            begin
              build := build + copy(aline,1,a-1); { Get whatever is before %in }
              b := copy(aline,a+1,3); { Get instruction (not %)}
              aline := copy(aline,a+4,length(aline)); { Update aline }
              build := build + GetMP3Info(b);
              b := '';
            end
          else begin
            build := build + aline;
            aline := '';
          end;
        end;
        build := center(build);
    end;
    GetLineInfo := build;
  end;


function strr(b:word):string;
var s1:string;
  begin
    s1:='';
    str(b,s1);
    strr:=s1;
  end;

procedure TurnOff;
  var
    l:integer;
  begin
    itson:=false;
    PlayFile:='Nothing';
    lcdclear;
    LCDCleanUp;
    for l := 1 to Attributes do attrinfo[l].name := ' ';

    Attributes := 0;
{    writeln(Attributes);
    for l := 1 to Attributes do writeln(length(attrinfo[l].name),attrinfo[l].name);}
  end;

procedure FindBounds;
  var start:byte;
      cbound:byte;
      c:char;

  begin
    start := 1;
    cbound := 1;
    Attributes := 0;
    while (cbound < 5) and (start<80) do begin
      if (getchar(start,StatLine) = '{') then bounds[cbound].start := start;
      if (getchar(start,Statline) = '}') then begin
        bounds[cbound].theend := start;
        inc(cbound);
      end;
      inc(start);
    end;

    start := 1;

    b:='';
    while (start < 80) do begin
      c:= (getcharc(start,InfoLine,a));
      if (a = white) or (c=#32) then begin
        if (length(b)=0) then inc(Attributes);
        if (length(b) < 30) then b := b + c;
      end else begin
        if (length(b) > 0) then begin
          attrinfo[attributes].name := b;
          b:='';
        end;
      end;
      inc(start);
    end;
    if (length(b) > 0) then begin
      while(b[length(b)] = #32) do b:=copy(b,1,length(b)-1);
      attrinfo[attributes].name := b;
    end;
    b:='';
    AllStats := GetAllStats;

  end;



function playerpaused:boolean;
 var
   b:boolean;
   c:char;

   begin
     if itson then begin
       c:=getchar(33,pauseline);
       if c='v' then b:=false else b:=true;
{       if b then begin
          LCDPrintAt(1,'  -  Player  -  ');
          LCDPrintAt(2,'   - Paused -   ');
       end;}
     end else b := false;
     playerpaused := b;
   end;



procedure ResetLCDInfo;
 var a:byte;
     code,i:integer;
  begin
    for a := 1 to LCDLines do begin
      scrolling[a].on := true;
      scrolling[a].p := 1;
      scrolling[a].pause := ScrollPause;
      scrolling[a].dir := 2;
      scrolling[a].delay := 0;


      for i := 1 to LCDLineSet[a].Values do
      begin
        val(LCDLineSet[a].Data[i].LineString,LCDLineSet[a].Data[i].LineValue,code);
      end;
      LCDLineSet[a].Current := 1;
      LCDLineSet[a].Scrolling := LCDLineSet[a].Data[1].LineScroll;
      LCDLineSet[a].DelayTime := LCDLineSet[a].Data[1].LineTime;
      Scrolling[a].on := LCDLineSet[a].Scrolling;


   end;
      numlockstatus := not numlockon; { Force to update }
      lcdtoscreen := false;
      lcdready; { Make sure Serial LCD is ready }
  end;



{ Is MPX Player Loaded ? }

function MPXLoaded:Boolean;
var ret:boolean;
    a:byte;
    i:integer;
  begin
    b := '';
    for i:=1 to 3 do b:=b+(getchar(32+i,1));
    if b = 'MPX' then ret := true else ret := false;
    ItsOn:=ret;      { Set Player Loaded to On }
    MPXLoaded := ret;
  end;

function PlayerIsOn:Boolean;
var ret:boolean;
    a:byte;
    i:integer;
    b:string;
  begin

    if (getchar(1,StatLine) = '{') then ret := true
      { Set Player to On }
    else ret := false;
{    Itson:=ret;}
    PlayerIsOn := ret;
  end;

function ValidSong:boolean;
  var ret:boolean;
  begin
    if (PlayFile ='Nothing') or (Playfile = 'No file') then ValidSong:=false else ValidSong := true;
  end;

function MPXPlaying:boolean;
  var ret:boolean;
  begin
    if (ValidSong) or (not playerpaused) then ret := true else ret:=false;
    MPXPlaying:= false;
  end;

procedure DoBrowse;
var l:byte;
  begin
    c := getchar(1,BracketLine);
    if c = chr(201) then
    begin
      b := '';
      l:=30;
      while((l<60) and (c <> ' ')) do
      begin
        c := getchar(l,BracketLine);
        if (c='\') then b:='' else b := b + c;
        inc(l);
      end;
      c:=' ';
      lcdprintat(2,b);
    end;
  end;

{procedure CheckLoading;
var i,a:byte;
  begin
    if ((getchar(1,Startline,a) = chr(27)) and (PreLoad)) then
    begin
      if firstload = false then
      begin
        firstload := true;
        if itson then LCDClear;
        itson:=false;
      end;
      LCDPrintAt(2,'Loading: ');
      for i := 16 to 17 do LCDPrint(getchar(i,InfoLine,a));
      LCDPrint('%');
    end else begin
      if firstload = true then begin
        firstload := false;
        FindBounds;
        ResetLCDInfo;
        playfile := changefactor;
      end else begin
        firstload := false;
        itson:=false;
      end;
    end;
  end;
 }

procedure ProcessLine(l:byte;var s:string);
  begin
    if (Scrolling[l].on) and (length(s) > LCDLen) then
    begin
      if (scrolling[l].delay >= scrolldelay) then scrolling[l].delay := 0;
      if (scrolling[l].delay = 0) then begin
        case scrolling[l].dir of
          1: begin
               inc(scrolling[l].p);
               if (Scrolling[l].p > length(s)-lcdlen+1) then
               begin
                 if Scrolling[l].pause = 0 then Scrolling[l].pause := ScrollPause;
                 if Scrolling[l].pause = 1 then
                 begin
                   Scrolling[l].dir := 2;            { go back! }
                   dec(Scrolling[l].p);
                   Scrolling[l].pause := 0;
                 end else
                 begin
                   dec(Scrolling[l].pause);
                   dec(scrolling[l].p);
                 end;
               end;
             end;
        2: begin
             dec(scrolling[l].p);
             if (Scrolling[l].p = 0) then
               begin
                 if Scrolling[l].pause = 0 then Scrolling[l].pause := (ScrollPause div 2)+1;
                 if Scrolling[l].pause = 1 then
                 begin
                   Scrolling[l].dir := 1;            { go back! }
                   inc(Scrolling[l].p);
                   Scrolling[l].pause := 0;
                 end else
                 begin
                   dec(Scrolling[l].pause);
                   inc(scrolling[l].p);
                 end;
               end;
           end;
         end;
         inc(scrolling[l].delay);
      end else inc(scrolling[l].delay);
      s:=copy(s,scrolling[l].p,scrolling[l].p+lcdlen);
    end; { Scrolling }
  end;


procedure CheckLCDChange(l:byte);
  begin
    if LCDLineSet[l].Values > 1 then
    begin
      if (LCDLineSet[l].DelayTime = 0) then
        begin
          inc(LCDLineSet[l].Current);
          if LCDLineSet[l].Current > LCDLineSet[l].Values then
            LCDLineSet[l].Current := 1;
          LCDLineSet[l].DelayTime := LCDLineSet[l].Data[LCDLineSet[l].current].LineTime;
          LCDLineSet[l].Scrolling := LCDLineSet[l].Data[LCDLineSet[l].Current].LineScroll;
          Scrolling[l].p := 1;
          Scrolling[l].dir := 2;
          scrolling[l].pause := ScrollPause;
          scrolling[l].delay := 0;
        end else
        dec(LCDLineSet[l].DelayTime);
    end;
  end;


Procedure Get_Time;Interrupt;
Var
    l:integer;
    s:string;
Begin
  Inc(Count);
  If (Count = DelayFactor) Then                        { Every Second 18.2 Pulses      }
  begin
    if PlayerIsOn and (not Paused) then
    begin
      ItsOn:=true;
      s:=changefactor;
      if (s <> playfile) then begin
        playfile := s;
        findbounds;
        resetlcdinfo;
      end;
      if Attributes > 0 then
        for l := 1 to LCDLines do if (not Paused) then
        begin
          CheckLCDChange(l);
          s:=getlineinfo(l);
          if (not Scrolling[l].on) then s := copy(s,1,LCDLEN) else
            ProcessLine(l,s);
          if (l = LCDlines) and (ShowNumLock) then LCDPrintAt(l,copy(s,1,lcdlen-1))
           else LCDPrintAt(l,s);
        end; { Cycle through lines }
    end else begin
      if itson and (not paused) then TurnOff;
      playfile := 'nothing';
    end;
    Paused := PlayerPaused;
    count := 0;
  end; { Delay Factor }
  Inline($9C);                             { Pushf - Push Flags           }
  Old1Cint;                                { Link Old 1C Procedure        }
End;

{$F+}
Procedure LCDOptions; Interrupt;
 var w:word;
     c1:char;
begin
  if ItsOn and ( not numlockstatus) then begin
    w:=port[$60];
    if w <> 0 then
    if w = keyLineDown then
      begin
        dec(LCDSelected);
        if LCDSelected = 0 then LCDSelected := 1;
      end else
    if w = keyLineUp then
      begin
        inc(LCDSelected);
        if LCDSelected > LCDLines then LCDSelected := LCDLines;
     end else
   if w = keyScrollToggle then
    begin
      scrolling[lcdselected].on := not scrolling[lcdselected].on;
      Scrolling[lcdselected].p := 1;
      Scrolling[lcdselected].dir := 2;
      scrolling[lcdselected].pause := ScrollPause;
      scrolling[lcdselected].delay := 0;
    end else
   if w = keyLineToggle then
     begin
       inc(lcdlineSet[lcdselected].Data[lcdlineset[lcdselected].current].LineValue);
       if (lcdlineSet[lcdselected].Data[lcdlineset[lcdselected].current].LineValue > (8+Attributes)) then

   val(LCDLineSet[lcdselected].Data[lcdlineset[lcdselected].current].LineString,
    LCDLineSet[lcdselected].Data[lcdlineset[lcdselected].current].LineValue,
    w);
     {  lcdlineSet[lcdselected].Data[lcdlineset[lcdselected].current].LineValue := 0;}
       scrolling[lcdselected].p := 1;
     end;
{     83: begin {ExitPlayer := true; numlock(true); end;}
  end;
    Inline($9C);                             { Pushf - Push Flags            }
    Orgint9;                                { Link Old 1C Procedure         }
end;
{$F-}



procedure SetBack;
 begin
   Setintvec($1C ,@Old1Cint);
   if keyboardenabled then SetIntVec(9, @OrgInt9);

 end;

procedure SetupTSR;
begin
  DoConfig;
  readln;
end;

procedure doit;
Begin
  numlockstatus := not numlockon; { Force to update }
  ExitPlayer:=false;
  keyboardenabled := false;
  PlayFile:='Nothing';
  LCDSelected := 1;
  RefreshDelay:=1; TimetoRefresh:=1;
  Attributes := 0;
  itson:=false;
  Count:=0;                    { Clock Pulses Counter                }
  initlcd;                       { Of Main Program                     }
  eq_bars;
  LCDCursorOff;
  lcdclear;
  LCDtoScreen := false;
  Getintvec($1C ,@Old1Cint);
  Setintvec($1C ,@Get_Time);
  if keyboardenabled then begin
    GetIntVec(9, @OrgInt9);
    SetIntVec(9, Addr(LCDOptions));
    writeln('Keyboard enabled!');
  end;


  writeln('MPXF TSR Loaded.');
  firstload:=false;
  {if not debug then TSRLogo;

  writeln('MPXF TSR Loaded.');}

{  swapvectors;
{  Keep(0);                     { Terminate And Stay Resident - Tsr   }
 {delay(3000);
  exec('c:\windows\command.com','');}

End;

begin
end.