Program MPXFTSR;
{$G+,R-,S-,M 8192,0,0 }
Uses lcd,Dos ,Crt,config,keystats;

const

  version = '0.94b';
  vdate = '09/30/99 1am';

type
  bound_rec= record
     start,theend:byte;
  end;
  attr_rec= record
     name:string;
  end;

  scroll_rec = record
    on:boolean;
    p:integer;
    dir:integer;
    pause:integer;
    delay:integer;
  end;
Var

    PlayListBound, FileseekBound,  TimeBound,  CPUBound,  ArtistBound,
    SongBound: byte;
    Paused:boolean;
    StatLine,  StartLine,    InfoLine,   VolLine,   PauseLine,BracketLine,
    DelayFactor,    LCDLines,    LCDLen : byte;
    lcdcontroldelay,lcdchardelay:byte;
    lcdport:word;
    RefreshDelay,TimetoRefresh:word;
    scrolldelay,scrollpause:byte;
    ShowNumLock:boolean;
    AllStats:string;
    c:char;
    i:integer;

    PlayFile:string;
    bounds:array[1..10] of bound_rec;
    attrinfo:array[1..5] of attr_rec;
    Attributes:byte;
    b:string;
    a:byte;


    keyScrollToggle,keyLineUp,keyLineDown,keyLineToggle:byte;


   FirstLoad:boolean;




    linedelay:byte;
    Count:Byte;                       { Counts Seconds                }
    Time:Longint  Absolute $40:$6C;   { Bios Keeps Clock Time Here    }
    Orgint9:Procedure;
    Old1Cint:Procedure;               { Linkage To Old 1C Interrupt   }
    itson:boolean;
    LCDLine:array[1..4] of byte;
    LCDLineSet:array[1..4] of string;
    LCDInfo:array[1..4] of string;
    LCDSelected:byte;
    Scrolling:array[1..4] of scroll_rec;
    ExitPlayer:boolean;
    KeyboardEnabled :boolean;
    NumLockStatus:boolean;


procedure DoConfig;
  begin
    if not (openconfig('mpxftsr.cfg')) then begin
      writeln('MPXFTSR.CFG not found!');
      halt(1);
    end;
    PlaylistBound := ReadWord('TSR Settings','Playlistbound');
    FileseekBound := ReadWord('TSR Settings','Fileseekbound');
    TimeBound := ReadWord('TSR Settings','TimeBound');
    CPUBound := ReadWord('TSR Settings','CPUBound');
    ArtistBound := ReadWord('TSR Settings','ArtistBound');
    SongBound := ReadWord('TSR Settings','SongBound');
    BracketLine := ReadWord('TSR Settings','BracketLine');
    StatLine := ReadWord('TSR Settings','StatLine');
    StartLine := ReadWord('TSR Settings','Startline');
    InfoLine := ReadWord('TSR Settings','InfoLine');
    VolLine := ReadWord('TSR Settings','VolLine');
    PauseLine := ReadWord('TSR Settings','PauseLine');
    DelayFactor := ReadWord('TSR Settings','DelayFactor');
    RefreshDelay := ReadWord('TSR Settings','RefreshDelay');
    ScrollDelay := readword('TSR Settings','ScrollDelay');
    ScrollPause := readword('TSR Settings','ScrollPause');

    keyLineToggle := readword('Keyboard Settings','ChangeLineValue');
    keyScrollToggle := readword('Keyboard Settings','ScrollingValue');
    keyLineup := readword('Keyboard Settings','LineUpValue');
    keyLinedown := readword('Keyboard Settings','LineDownValue');
    keyboardenabled := readboolean('Keyboard Settings','KeyboardEnabled');

    LCDLines := ReadWord('LCD Settings','lcdlines');
    LCDLen := ReadWord('LCD Settings','lcdlength');
    LCDSetLines(LCDLines);
    LCDSetLength(LCDLen);
    LCDCharDelay := ReadWord('LCD Settings','CharDelay');
    LCDControlDelay := ReadWord('LCD Settings','ControlDelay');
    LCDPort := ReadWord('LCD Settings','LPTPort');
    if LCDPort <> 0 then LCDSetPort(LCDPort);
    LCDSetCharDelay(lcdchardelay);
    LCDSetControlDelay(lcdcontroldelay);

    LCDLineSet[1] := Readstring('LCD Settings','Line1Value');
    LCDLineSet[2] := ReadString('LCD Settings','Line2Value');
    LCDLineSet[3] := ReadString('LCD Settings','Line3Value');
    LCDLineSet[4] := ReadString('LCD Settings','Line4Value');
    ShowNumLock := readboolean('LCD Settings','ShowNumLock');


    closeconfig;
  end;

FUNCTION GetChar( X,Y :WORD; VAR Attrib:BYTE ) :CHAR;
VAR
   Ofs :WORD;
BEGIN
                        { NOTE: Change the Segment from $B800 }                        {       to $B000 for MonoChrome.      }
  Ofs := ((Y-1) * 160) + ((X SHL 1) - 1);
  Attrib := MEM[$B800:Ofs];
  GetChar := CHR( MEM[$B800:Ofs-1] );
END;


function GetAllStats:string;
var start:integer;
  begin
    b := '';
    for i := 1 to 80 do b := b + getchar(i,InfoLine,a);
    if (length(b) > 0) then
      while(b[length(b)] = #32) do b:=copy(b,1,length(b)-1);
    GetAllStats := b;
  end;

function filename:string;
  var
    a:byte;
    i:integer;
   begin
     b:='';
     for i := 68 to 80 do b:=b+(getchar(i,StatLine,a));
     while (b[1] = chr(32)) and (length(b) >1) do b:=copy(b,2,(length(b)-1));
     filename := b;
   end;

function mp3bar:string;
  var
    i:integer;
    begin
      b:='';
      for i := bounds[cpubound].theend+1 to bounds[cpubound].theend + 16 do
      begin
        if getchar(i,statline,a) = '#' then b := b + chr(255) else b := b + ' ';
      end;
      mp3bar := b;
    end;

function GrabCenter(l:byte):string;
  var
    i:integer;
    ab:string;
    begin
      ab:='';
      for i := 1 to 8 do ab := ab + getchar(32+i,l,a);
      GrabCenter := ab;
    end;

function volume:string;
    begin
      volume:=GrabCenter(volline);
    end;

function MP3Time:string;
  var
    i:integer;
    begin
      b:='';
      for i := 2 to 10 do b:= b + getchar(bounds[TimeBound].start+i,StatLine,a);
      a:=pos('}',b);
      if a>0 then b := copy(b,1,a-1);
      while(b[1] = #32) do b:=copy(b,2,length(b));
      mp3time := b;
      b:='';
    end;

function PlayList:string;
  var
    i:integer;
    begin
      b:='';
      for i:= 1 to 11 do b:=b + getchar(bounds[PlayListBound].start+i,StatLine,a);
      a:=pos('}',b);
      if a>0 then b := copy(b,1,a-1);
      while(b[1] = #32) do b:=copy(b,1,length(b));
      PlayList := b;
    end;

function PreLoad:boolean;
var b:boolean;
    a:byte;
  begin
    b:=false;
    b:= (getchar(1,InfoLine,a) = 'P');
    b:=b and (getchar(2,InfoLine,a) = 'r');
    b:=b and (getchar(3,InfoLine,a) = 'e');
    b:=b and (getchar(4,InfoLine,a) = 'l');
    PreLoad := b;
  end;

function changefactor:string;
    begin { This is to make sure that we don't think a song title is Preload }
      dec(TimetoRefresh);
      if (TimetoRefresh = 0) and (ItsOn) then
      begin
        TimetoRefresh := RefreshDelay;
        if PreLoad then changefactor := '=' else changefactor:=playlist+filename;
      end else changefactor := playfile;
    end;

function TimeVol:string;
  var
    b: string;
    begin
      b:= mp3time;
      b := copy(b,1,pos('/',b)-1);
      b := ' ' + b + ' '+volume;
      timevol := b;
    end;

function TimePlaylist:string;
  begin
    b:=mp3time;
    b:=copy(b,1,pos('/',b)-1);
    b:=  b + ' ' + playlist;
    timeplaylist := b;
    b:='';
  end;

function SingleTime:string;
  begin
    b:=mp3time;
    b:=copy(b,1,pos('/',b)-1);
    Singletime := b;
    b:='';
  end;

function center(ab:string):string;
var c:string;
 begin
   c := ab;
   while (length(c) < LCDLEN) do
     if (length(c) mod 2) = 0 then c := ' ' + c else c := c + ' ';
   center := c;
 end;

function GetMP3Info(inst:string):string;
var
  s:string;
  h:byte;
  begin
    s:='';
    for h := 1 to length(inst) do inst[h] := upcase(inst[h]);
    if inst='FNM' then s:=filename else
    if inst='FTM' then s:=mp3time else
    if inst='STM' then s:=singletime else
    if inst='IAL' then s:=AllStats else
    if inst='VLM' then s:=volume else
    if inst='MDB' then s:=MP3bar else
    if inst='M3U' then s:=playlist else
    if inst[1]='I' then
    begin
      val((inst[2]+inst[3]),h,i);
      if (h > 0) and (attributes >= h) then s:=attrinfo[h].name else s:=filename;
    end else
    if inst[1]='Z' then
    begin
      val((inst[2]+inst[3]),h,i);
      if (h > 0) then s:=GrabCenter(h);
    end;
    GetMP3Info := s;
  end;

function MP3Info(b:byte):string;
  var
    s:string;
   begin
     case b of
       2: s:=center(TimeVol);
       3: s:=center(TimePlayList);
       4: s:=MP3bar;
       5: s:=center(volume);
       6: s:=center(mp3time);
       7: s:=filename;
       8: s:=AllStats;
       1: begin
            if Attributes > 1 then s:=attrinfo[1].name + ' - '+attrinfo[2].name
              else s:= attrinfo[1].name;
          end;
       else begin
         b := b -8;
         s:=attrinfo[b].name;
       end;
     end;
     while (s[length(s)]=#32) do s:=copy(s,1,length(s)-1);
     while (length(s) < LCDLen) do s := s + ' ';
     mp3info := s;
 end;

function GetLineInfo(l:byte):string;
  var
    build:string;
    code,i:integer;
    aline:string;
  begin
    build:=''; { Init }
    b:=''; { Init Instruction }
    if LCDLine[l] > 0 then build :=MP3Info(LCDLine[l]) else
    begin
      aline := LCDInfo[l];
      while (length(aline) > 0) do
        begin
          a:=pos('%',aline);
          if (a>0) then
            begin
              build := build + copy(aline,1,a-1); { Get whatever is before %in }
              b := copy(aline,a+1,3); { Get instruction (not %)}
              aline := copy(aline,a+4,length(aline)); { Update aline }
              build := build + GetMP3Info(b);
              b := '';
            end
          else begin
            build := build + aline;
            aline := '';
          end;
        end;
        build := center(build);
    end;
    GetLineInfo := build;
  end;

procedure DoNumLock;
var test:boolean;
  begin
    if ShowNumLock then begin
      if numlockon <> numlockstatus then
        begin
          numlockstatus := numlockon;
          LCDCursor(2,LcdLen);
          if numlockstatus then LCDPrint(chr(165)) else LCDPrint(' ');
        end;
    end;
  end;

function strr(b:word):string;
var s1:string;
  begin
    s1:='';
    str(b,s1);
    strr:=s1;
  end;

procedure TurnOff;
  var
    l:integer;
  begin
    itson:=false;
    PlayFile:='Nothing';
    lcdclear;
    for l := 1 to Attributes do attrinfo[l].name := ' ';
    Attributes := 0;
{    writeln(Attributes);
    for l := 1 to Attributes do writeln(length(attrinfo[l].name),attrinfo[l].name);}
  end;

procedure FindBounds;
  var start:byte;
      cbound:byte;
      c:char;

  begin
    start := 1;
    cbound := 1;
    Attributes := 0;
    while (cbound < 5) and (start<80) do begin
      if (getchar(start,StatLine,a) = '{') then bounds[cbound].start := start;
      if (getchar(start,Statline,a) = '}') then begin
        bounds[cbound].theend := start;
        inc(cbound);
      end;
      inc(start);
    end;

    start := 1;

    b:='';
    while (start < 80) do begin
      c:= (getchar(start,InfoLine,a));
      if (a = white) or (c=#32) then begin
        if (length(b)=0) then inc(Attributes);
        if (length(b) < 30) then b := b + c;
      end else begin
        if (length(b) > 0) then begin
          attrinfo[attributes].name := b;
          b:='';
        end;
      end;
      inc(start);
    end;
    if (length(b) > 0) then begin
      while(b[length(b)] = #32) do b:=copy(b,1,length(b)-1);
      attrinfo[attributes].name := b;
    end;
    b:='';
    AllStats := GetAllStats;

  end;



function playerpaused:boolean;
 var
   b:boolean;
   c:char;
   a:byte;

   begin
     if itson then begin
       c:=getchar(33,pauseline,a);
       if c='v' then b:=false else b:=true;
{       if b then begin
          LCDPrintAt(1,'  -  Player  -  ');
          LCDPrintAt(2,'   - Paused -   ');
       end;}
     end else b := false;
     playerpaused := b;
   end;



procedure ResetLCDInfo;
 var a:byte;
     code,i:integer;
  begin
    for a := 1 to LCDLines do begin
      scrolling[a].on := true;
      scrolling[a].p := 1;
      scrolling[a].pause := ScrollPause;
      scrolling[a].dir := 2;
      LCDInfo[a] := LCDLineSet[a];
      val(LCDInfo[a],LCDLine[a],code);
   end;

      linedelay := 0;
{      if Attributes > 1 then LCDLine[1] := 0 else LCDLine[1] := 5;

{        LCDInfo[1] := '%i1 - %i2';
        LCDInfo[2] := '[%st] [%pl]';}

        LCDSetCharDelay(lcdchardelay);
        LCDSetControlDelay(lcdcontroldelay);
        numlockstatus := not numlockon; { Force to update }
{        gotoxy(30,26);
        write('MPXF '+version);}
  end;



{ Is MPX Player Loaded ? }

function MPXLoaded:Boolean;
var ret:boolean;
    a:byte;
    i:integer;
  begin
    b := '';
    for i:=1 to 3 do b:=b+(getchar(32+i,1,a));
    if b = 'MPX' then ret := true else ret := false;
    ItsOn:=ret;      { Set Player Loaded to On }
    MPXLoaded := ret;
  end;

function PlayerIsOn:Boolean;
var ret:boolean;
    a:byte;
    i:integer;
    b:string;
  begin

    if (getchar(1,StatLine,a) = '{') then ret := true
      { Set Player to On }
    else ret := false;
{    Itson:=ret;}
    PlayerIsOn := ret;
  end;

function ValidSong:boolean;
  var ret:boolean;
  begin
    if (PlayFile ='Nothing') or (Playfile = 'No file') then ValidSong:=false else ValidSong := true;
  end;

function MPXPlaying:boolean;
  var ret:boolean;
  begin
    if (ValidSong) or (not playerpaused) then ret := true else ret:=false;
    MPXPlaying:= false;
  end;

procedure DoBrowse;
var l:byte;
  begin
    c := getchar(1,BracketLine,a);
    if c = chr(201) then
    begin
      b := '';
      l:=30;
      while((l<60) and (c <> ' ')) do
      begin
        c := getchar(l,BracketLine,a);
        if (c='\') then b:='' else b := b + c;
        inc(l);
      end;
      c:=' ';
      lcdprintat(2,b);
    end;
  end;

{procedure CheckLoading;
var i,a:byte;
  begin
    if ((getchar(1,Startline,a) = chr(27)) and (PreLoad)) then
    begin
      if firstload = false then
      begin
        firstload := true;
        if itson then LCDClear;
        itson:=false;
      end;
      LCDPrintAt(2,'Loading: ');
      for i := 16 to 17 do LCDPrint(getchar(i,InfoLine,a));
      LCDPrint('%');
    end else begin
      if firstload = true then begin
        firstload := false;
        FindBounds;
        ResetLCDInfo;
        playfile := changefactor;
      end else begin
        firstload := false;
        itson:=false;
      end;
    end;
  end;
 }

procedure ProcessLine(l:byte;var s:string);
  begin
    if (Scrolling[l].on) and (length(s) > LCDLen) then
    begin
      if (linedelay >= scrolldelay) then linedelay := 0;
      if (linedelay = 0) then begin
        case scrolling[l].dir of
          1: begin
               inc(scrolling[l].p);
               if (Scrolling[l].p > length(s)-lcdlen+1) then
               begin
                 if Scrolling[l].pause = 0 then Scrolling[l].pause := ScrollPause;
                 if Scrolling[l].pause = 1 then
                 begin
                   Scrolling[l].dir := 2;            { go back! }
                   dec(Scrolling[l].p);
                   Scrolling[l].pause := 0;
                 end else
                 begin
                   dec(Scrolling[l].pause);
                   dec(scrolling[l].p);
                 end;
               end;
             end;
        2: begin
             dec(scrolling[l].p);
             if scrolling[l].p = 0 then begin
               scrolling[l].dir := 1;
               scrolling[l].p := 1;
             end;
           end;
         end;
         inc(linedelay);
      end else inc(linedelay);
      s:=copy(s,scrolling[l].p,scrolling[l].p+lcdlen);
    end; { Scrolling }
  end;


Procedure Get_Time;Interrupt;
Var
    l:integer;
    s:string;
Begin
  Inc(Count);
  If (Count = DelayFactor) Then                        { Every Second 18.2 Pulses      }
  begin
    if PlayerIsOn and (not Paused) then
    begin
      ItsOn:=true;
        for l := 1 to LCDLines do if (not Paused) then
        begin
          s:=getlineinfo(l);
          if not Scrolling[l].on then s := copy(s,1,LCDLEN) else
            ProcessLine(l,s);
          if (l = LCDlines) and (ShowNumLock) then LCDPrintAt(l,copy(s,1,lcdlen-1))
           else LCDPrintAt(l,s);
        end; { Cycle through lines }
        s:=changefactor;
        if (s <> playfile) then begin
          playfile := s;
          findbounds;
          resetlcdinfo;
        end;
        DoNumLock;
    end else begin
      if itson then TurnOff;
      playfile := 'nothing';
    end;
    Paused := PlayerPaused;
    count := 0;
  end; { Delay Factor }
  Inline($9C);                             { Pushf - Push Flags           }
  Old1Cint;                                { Link Old 1C Procedure        }
End;

{$F+}
Procedure LCDOptions; Interrupt;
 var w:word;
     c1:char;
begin
  if ItsOn and ( not numlockstatus) then begin
    w:=port[$60];
    if w <> 0 then
    if w = keyLineDown then
      begin
        dec(LCDSelected);
        if LCDSelected = 0 then LCDSelected := 1;
      end else
    if w = keyLineUp then
      begin
        inc(LCDSelected);
        if LCDSelected > LCDLines then LCDSelected := LCDLines;
     end else
   if w = keyScrollToggle then
    begin
      scrolling[lcdselected].on := not scrolling[lcdselected].on;
      Scrolling[lcdselected].p := 1;
      Scrolling[lcdselected].dir := 1;
      scrolling[lcdselected].pause := 0;
    end else
   if w = keyLineToggle then
     begin
       inc(lcdline[lcdselected]);
       if (lcdline[lcdselected] > (8+Attributes)) then lcdline[lcdselected] := 0;
       scrolling[lcdselected].p := 1;
     end;
{     83: begin {ExitPlayer := true; numlock(true); end;}
  end;
    Inline($9C);                             { Pushf - Push Flags            }
    Orgint9;                                { Link Old 1C Procedure         }
end;
{$F-}


Begin
  numlockstatus := not numlockon; { Force to update }
  ExitPlayer:=false;
  keyboardenabled := false;
  PlayFile:='Nothing';
  LCDSelected := 1;
  RefreshDelay:=1; TimetoRefresh:=1;
  itson:=false;
  Count:=0;                    { Clock Pulses Counter                }
  writeln('MPXF TSR for Parallel Port LCD');
  writeln('Version '+version+'. ('+vdate+') Written by Coldblood.');
  writeln;
  write('Loading config...');
  DoConfig;
  writeln('Done!');             { $1C}
  initlcd;                       { Of Main Program                     }
  LCDCursorOff;
  LCDtoScreen := false;
  Getintvec($1C ,@Old1Cint);   { Save Old 1C Interrupt Vector        }
  Setintvec($1C ,@Get_Time);   { Insert Current Interurupt Procedure }
{  if keyboardenabled then begin
    GetIntVec(9, @OrgInt9);
    SetIntVec(9, Addr(LCDOptions));
    writeln('Keyboard enabled!');
  end;}
  LCDPrintAt(1,'MPXF  TSR Loaded');
  LCDPrintAt(2,' v'+version);

  writeln('MPXF TSR Loaded.');
  firstload:=false;
{  Keep(0);                     { Terminate And Stay Resident - Tsr   }
{ delay(3000);}
  exec('c:\windows\command.com','');
End.

